// $Header$


#ifndef FI4_COMMON_H
#define FI4_COMMON_H

#include "base/testsuite.h"

#include "base/mpstrstream.h"
#include "base/collection.h"
#include "base/except.h"
#include "base/event.h"

#include <string>


namespace ToppersFi4 {

		//J[l\t@C
	class SpecialtyFile : public MultipartStream, public RuntimeObject
	{
	protected:
		SpecialtyFile(void) throw();

		template<class T>
		static T * createInstance(std::string filename) throw(Exception)
		{
			T * old;
			T * result = 0;

				//ROTo^ IuWFNg폜 (Bꐫ̕ۏ (ǃVOgł͂Ȃ) )
			old = dynamic_cast<T *>(RuntimeObjectTable::getInstance(typeid(T)));
			if(old != 0)
				delete old;

			result = new(std::nothrow) T;
			if(result == 0)
				ExceptionMessage("Internal error : Object creation failure [ToppersFi4::KernelCfg::createKernelCfg]","G[ : IuWFNgG[ [createKernelCfg]") << throwException;

			try {
				result->setFilename(filename);
			}
			catch(...) {
				if(result != 0)
					delete result;
				throw;
			}
			return result;
		}

	};


	/*
	 *  Visual C++ 6.0 : fatal error C1001: INTERNAL COMPILER ERROR (msc1.cpp:1794) ΍ 
	 *    (ƂAdo^ĂÂCX^X̓o^`FbNȂ)
	 */
#if defined(_MSC_VER) && (_MSC_VER < 1300)
#  define SPECIALTY_FILE(x)                                                             \
    class x : public SpecialtyFile {                                                    \
        public:                                                                         \
            struct CreationEvent { class x * file; };                                   \
            static inline x * createInstance(std::string filename) throw(Exception)     \
            {                                                                           \
                x * instance = new(std::nothrow) x;                                     \
                if(instance != 0)                                                       \
                    instance->setFilename(filename);                                    \
                return instance;                                                        \
            }                                                                           \
    }
#else
#  define SPECIALTY_FILE(x)                                                             \
    class x : public SpecialtyFile {                                                    \
        public:                                                                         \
            struct CreationEvent { class x * file; };                                   \
            static inline x * createInstance(std::string filename) throw(Exception)     \
            {   return SpecialtyFile::createInstance<x>(filename);   }                  \
    }
#endif

		//TOPPERS/FI4̃RtBM[VŏoĂȃt@C
	SPECIALTY_FILE(KernelCfg);
	SPECIALTY_FILE(KernelID);

		//o[WԂzϊȂ
	std::string conv_includefile(std::string file) throw();	//CN[ht@C
	std::string conv_kernelobject(std::string obj) throw();	//J[l̕ϐ

		//萔Ȃ
//	std::string get_agreement(std::string filename = "") throw();	//̎擾
}

#endif

