/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uITRON4.0 Kernel
 * 
 *  Copyright (C) 2003-2004 by Monami Software Limited Partnership, JAPAN.
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/cfg/fi4/fi4_staticapi.cpp 2750 2006-03-07T16:15:24.532712Z monaka  $
 */

// $Header$

#include "fi4/fi4_defs.h"

#include "base/parser.h"
#include "base/mpstrstream.h"
#include <iostream>

using namespace std;

DECLARE_API(INCLUDE,"INCLUDE")
{
	Token token;
	Directory * node;
	Directory * scope;

	last = NULL;
	p.getToken(token, Token::STRINGLITERAL);
	token.chopLiteral();

	if( (token[0] != '\"' || token[token.size()-1] != '\"') &&
		(token[0] != '<' || token[token.size()-1] != '>') )
		ExceptionMessage("An include filename must be enclosed with \"...\" or <...>","t@C \"...\"  <...> ̌`łȂ΂Ȃ܂").throwException();

	node = container.openChild(OBJECTTREE,INCLUDEFILE,NULL);
	last = node;

		//d`FbN
	scope = node->getFirstChild();
	while(scope != 0)
	{
		if(token.compare((*scope).toString()) == 0)
		{
			cerr << p.getStreamLocation() << ' ' << (Message("Include file % was already specified (ignored).","CN[ht@C%w肳܂ (܂)") << token) << endl;
			return;
		}
		scope = scope->getNext();
	}
	
	node->addChild(new Directory(token));
}

DECLARE_API(VAID_TSK,"VAID_TSK")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,TASK,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, TASK);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_TSK,"VRID_TSK")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, TASK);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, TASK);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_TSK,"CRE_TSK")
{
	Token token;
    string work;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, TASK);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"tskatr,exinf,task,itskpri,stksz");
	p.getToken(",","NULL","}",NULL);

	(*node)["texatr"] = "TA_NULL";
	(*node)["texrtn"] = "NULL";

    if(container["/cpu"].toString().compare("nios32") == 0) 
    {
    	(*node)["hi_limit"] = "TSK_HI_LIMIT";
	    (*node)["lo_limit"] = "TSK_LO_LIMIT";
    }
}

DECLARE_API(VATT_TRW,"VATT_TRW")
{
	Token token;
	Directory * node;

    if(container["/cpu"].toString().compare("nios32") != 0)
        ExceptionMessage("VATT_TRW is not supported except for the processor 'nios32'.","VATT_TRWnios32vZbTł̂݃T|[g܂").throwException();

	p.getToken(token);
	node = find(container[OBJECTTREE], token, TASK);

	p.getToken(",","{",NULL);
	parseParameters(p, node, "hi_limit,lo_limit");
	p.getToken("}");
}

DECLARE_API(DEF_TEX,"DEF_TEX")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = find(container[OBJECTTREE], token, TASK);

	p.getToken(",","{",NULL);
	parseParameters(p, node, "texatr,texrtn");
	p.getToken("}");
}

DECLARE_API(VAID_SEMAPHORE,"VAID_SEM")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,SEMAPHORE,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, SEMAPHORE);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_SEM,"VRID_SEM")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, SEMAPHORE);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, SEMAPHORE);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_SEM,"CRE_SEM")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, SEMAPHORE);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"sematr,isemcnt,maxsem");
	p.getToken("}");
}

DECLARE_API(VAID_FLG,"VAID_FLG")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,EVENTFLAG,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, EVENTFLAG);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_FLG,"VRID_FLG")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, EVENTFLAG);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, EVENTFLAG);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_FLG,"CRE_FLG")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, EVENTFLAG);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"flgatr,iflgptn");
	p.getToken("}");
}

DECLARE_API(VAID_DTQ,"VAID_DTQ")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,DATAQUEUE,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, DATAQUEUE);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_DTQ,"VRID_DTQ")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, DATAQUEUE);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, DATAQUEUE);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_DTQ,"CRE_DTQ")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, DATAQUEUE);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"dtqatr,dtqcnt");
	p.getToken(",","NULL","}",NULL);
}

DECLARE_API(VAID_MBX,"VAID_MBX")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,MAILBOX,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, MAILBOX);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_MBX,"VRID_MBX")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, MAILBOX);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, MAILBOX);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_MBX,"CRE_MBX")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, MAILBOX);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"mbxatr,maxmpri,mprihd");
	p.getToken("}",NULL);
}

DECLARE_API(VAID_MPF,"VAID_MPF")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,FIXEDSIZEMEMORYPOOL,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, FIXEDSIZEMEMORYPOOL);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_MPF,"VRID_MPF")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, FIXEDSIZEMEMORYPOOL);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, FIXEDSIZEMEMORYPOOL);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_MPF,"CRE_MPF")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, FIXEDSIZEMEMORYPOOL);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"mpfatr,blkcnt,blksz");
	p.getToken(",","NULL","}",NULL);
}

DECLARE_API(VAID_CYC,"VAID_CYC")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,CYCLICHANDLER,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, CYCLICHANDLER);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_CYC,"VRID_CYC")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, CYCLICHANDLER);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, CYCLICHANDLER);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_CYC,"CRE_CYC")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, CYCLICHANDLER);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"cycatr,exinf,cychdr,cyctim,cycphs");
	p.getToken("}");
}

DECLARE_API(DEF_INH,"DEF_INH")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, INTERRUPTHANDLER, false);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"inhatr,inthdr");
	p.getToken("}");
}

DECLARE_API(DEF_EXC,"DEF_EXC")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, EXCEPTIONHANDLER, false);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"excatr,exchdr");
	p.getToken("}");
}

DECLARE_API(ATT_INI,"ATT_INI")
{
	Token token;
	Directory * node;

	node = container.openChild(OBJECTTREE,INITIALIZER,NULL)->addChild();
	last = node;

	(*node)["position"] = p.getStreamLocation();

	p.getToken("{",NULL);
	parseParameters(p,node,"iniatr,exinf,inirtn");
	p.getToken("}");
}

DECLARE_API(ATT_FIN, "VATT_TER")
{
	Token token;
	Directory * node;

	node = container.openChild(OBJECTTREE,TERMINATOR,NULL)->addChild();
	last = node;

	(*node)["position"] = p.getStreamLocation();

	p.getToken("{",NULL);
	parseParameters(p,node,"teratr,exinf,terrtn");
	p.getToken("}");
}


DECLARE_API(VAID_MPL,"VAID_MPL")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,VARSIZEMEMORYPOOL,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, VARSIZEMEMORYPOOL);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_MPL,"VRID_MPL")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, VARSIZEMEMORYPOOL);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, VARSIZEMEMORYPOOL);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_MPL, "CRE_MPL")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, VARSIZEMEMORYPOOL, false);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"mplatr,mplsz");
	p.getToken(",","NULL","}",NULL);
}

DECLARE_API(VAID_ALM,"VAID_ALM")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,ALARMHANDLER,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, ALARMHANDLER);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_ALM,"VRID_ALM")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, ALARMHANDLER);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, ALARMHANDLER);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_ALM, "CRE_ALM")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, ALARMHANDLER);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"almatr,exinf,almhdr");
	p.getToken("}");
}

DECLARE_API(DEF_OVR, "DEF_OVR")
{
	Token token;
	Directory * node;

	node = container.openChild(SYSTEM,OVERRUNHANDLER,NULL)->getFirstChild();
	if (node != 0) {
	    node->erase();
	}

	node = container.openChild(SYSTEM,OVERRUNHANDLER,NULL)->addChild();
	(*node)["position"] = p.getStreamLocation();

	p.getToken("{",NULL);
	parseParameters(p,node,"ovratr,ovrhdr");
	p.getToken("}");
}

DECLARE_API(VAID_ISR,"VAID_ISR")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,INTERRUPTSERVICE,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, INTERRUPTSERVICE);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_ISR,"VRID_ISR")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, INTERRUPTSERVICE);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, INTERRUPTSERVICE);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(ATT_ISR, "ATT_ISR")
{
	Token token;
	Directory * node;

	node = container.openChild(OBJECTTREE,ATTACHED_ISR,NULL)->addChild();
	last = node;

	(*node)["position"] = p.getStreamLocation();

	p.getToken("{",NULL);
	parseParameters(p,node,"isratr,exinf,intno,isr");
	p.getToken("}");
}

DECLARE_API(VAID_MBF,"VAID_MBF")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,MESSAGEBUFFER,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, MESSAGEBUFFER);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_MBF,"VRID_MBF")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, MESSAGEBUFFER);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, MESSAGEBUFFER);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_MBF, "CRE_MBF")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, MESSAGEBUFFER, false);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"mbfatr,maxmsz,mbfsz");
	p.getToken(",","NULL","}",NULL);
}

DECLARE_API(VAID_MTX,"VAID_MTX")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,MUTEX,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, MUTEX);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_MTX,"VRID_MTX")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, MUTEX);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, MUTEX);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_MTX, "CRE_MTX")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, MUTEX, false);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"mtxatr,ceilpri");
	p.getToken("}");
}

DECLARE_API(VAID_POR,"VAID_POR")
{
	Token token;
	Directory * node;
	Directory * scope;
	unsigned int n = 0;

	p.getToken(token);

	node = container.openChild(DYNAMICID,RENDEZVOUSPORT,NULL);
	scope = node->getFirstChild();
	if (scope != 0) {
		n = scope->toInteger();
		scope->erase();
		token.value += n;
	}
	node = allocate(container[DYNAMICID], token, RENDEZVOUSPORT);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(VRID_POR,"VRID_POR")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, RENDEZVOUSPORT);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVEDID], token, RENDEZVOUSPORT);
	(*node)["position"] = p.getStreamLocation();
}

DECLARE_API(CRE_POR, "CRE_POR")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, RENDEZVOUSPORT, false);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"poratr,maxcmsz,maxrmsz");
	p.getToken("}");
}

DECLARE_API(DEF_SVC, "DEF_SVC")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[OBJECTTREE], token, EXSERVICECALL, false);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",","{",NULL);
	parseParameters(p,node,"svcatr,svcrtn");
	p.getToken("}");
}


DECLARE_API(VDEF_KMB, "VDEF_KMB")
{
	Token token;
	Directory * node;

	p.getToken(token);
	node = allocate(container[SYSTEM], token, KERNELBUFFER, false);
	(*node)["position"] = p.getStreamLocation();
}


