/*

 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uITRON4.0 Kernel
 * 
 *  Copyright (C) 2003-2004 by Monami Software Limited Partnership, JAPAN.
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/config/sh3/ms7727cp01/hw_h8.c 2750 2006-03-07T16:15:24.532712Z monaka  $
 */

/*
 *  VAI/OfoCXiSIOjhCoiMS7717CP01pj
 *  dRg[ H8/3048F-ONE
 */

#include "hw_h8.h"

#define H8_PINT	11

#define KEYCR	0x0060
#define KATIMER	0x0061
#define KEYSR	0x0062
#define KBITPR	0x0064

#define RTKISR	0x0090

#define	KEYCR_PONNMI	0x20
#define	KEYxR_PONSW	0x10
#define	KEYxR_ARKEY	0x08
#define	KEYxR_KEY_OFF	0x04
#define	KEYxR_KEY_ON	0x02
#define	KEYCR_KEY_STR	0x01

/*
 * CgR}hij
 */
void
h8_write(W addr, UB data)
{
	int i;
	UB buf[5];

	/* CgR}h̐ */
	buf[0] = 0x02;
	buf[1] = 0xc0 | 0x01;
	buf[2] = addr >> 8;
	buf[3] = addr;
	buf[4] = data;
	
	/* R}hM */
	for(i=0;i<5;i++)
	{
		st16c2550_pol_putc(buf[i], 2);
	}
	
	/* R}h̎M|[Oő҂ */
	while( (UB)-1 == (buf[0] = st16c2550_pol_getc(2)) )	{ }
	while( (UB)-1 == (buf[1] = st16c2550_pol_getc(2)) )	{ }
	if(buf[0] == 0x15)
		return;
	while( (UB)-1 == (buf[2] = st16c2550_pol_getc(2)) )	{ }
	while( (UB)-1 == (buf[3] = st16c2550_pol_getc(2)) )	{ }
	while( (UB)-1 == (buf[4] = st16c2550_pol_getc(2)) )	{ }
}

/*
 * dǗRg[̏
 */
void
h8_init(void)
{
	/* ݋֎~ */
    sil_wrh_mem((VP)PINTER,
                (sil_reh_mem((VP)PINTER) & ~(1 << H8_PINT)));
    sil_wrh_mem((VP)IPRD,
                (sil_reh_mem((VP)IPRD) & 0xf0ff));
    
    /* TODO:WX^̃NAKv */
    
    /* L[͂̊݊Jn */
    h8_write(KEYCR, KEYCR_PONNMI | KEYxR_KEY_ON | KEYCR_KEY_STR);
    
    /* PINTCl[u */
	sil_wrh_mem((VP)ICR2,
                (sil_reh_mem((VP)ICR2) & ~(1 << H8_PINT))); 
    sil_wrh_mem((VP)IPRD,
                (sil_reh_mem((VP)IPRD) | (H8_PINT << 8))); 
    sil_wrh_mem((VP)PINTER,
                (sil_reh_mem((VP)PINTER) | (1 << H8_PINT)));

}


void
h8_handler()
{

    /* PINTfBXG[u */
    sil_wrh_mem((VP)PINTER,
                (sil_reh_mem((VP)PINTER) & ~(1 << H8_PINT)));

	/* L[͂̊荞݂NA */
    h8_write(KEYSR, 0x00);

    syslog(LOG_EMERG, "Power Controler Interrupt occurs.");

    /* PINTCl[u */
    sil_wrh_mem((VP)PINTER,
                (sil_reh_mem((VP)PINTER) | (1 << H8_PINT)));
}

void
h8_key_isr(VP_INT exinf)
{

    /* PINTfBXG[u */
    sil_wrh_mem((VP)PINTER,
                (sil_reh_mem((VP)PINTER) & ~(1 << H8_PINT)));

	/* L[͂̊荞݂NA */
    h8_write(KEYSR, 0x00);

    syslog(LOG_EMERG, "Power Controler Interrupt occurs.");

    /* PINTCl[u */
    sil_wrh_mem((VP)PINTER,
                (sil_reh_mem((VP)PINTER) | (1 << H8_PINT)));
}
