/*

 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uITRON4.0 Kernel
 * 
 *  Copyright (C) 2003-2004 by Monami Software Limited Partnership, JAPAN.
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/config/sh3/overrun_timer.c 2750 2006-03-07T16:15:24.532712Z monaka  $
 */

/*
 *  CPUˑI[onh^C}W[iSH3/4pj
 *  TMU1gp
 */

/*
 *  ^C}݃nhINTEVTԍ
 */
#define	INHNO_OVERRUN_TIMER	TMU1_INTEVT

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include <hw_timer.h>

/*
 *  ^C}݃nh
 */
void
overrun_timer_handler()
{
    /* ^C}~ */
    sil_wrb_mem((VP)TMU_TSTR,
                (sil_reb_mem((VP)TMU_TSTR) & ~TMU_STR1));

    call_ovrhdr();		/* I[onȟďo */

    /* 荞ݗvNA */
    sil_wrh_mem((VP)TMU_TCR1,
                (sil_reh_mem((VP)TMU_TCR1) & ~TCR_UNF));
}



/*
 *  ^C}̋N
 *
 *  ^C}D
 */
void
hw_overrun_timer_initialize()
{
    define_inh(TMU1_INTEVT, overrun_timer_handler);

	/*
	 *  ^C}֘A̐ݒ
	 */
    sil_wrb_mem((VP)TMU_TSTR,
                (sil_reb_mem((VP)TMU_TSTR) & ~TMU_STR1));  /* ^C}~ */

    /*
	 *  ݊֘A̐ݒ
	 */
    define_int_plevel(TMU1_INTEVT,KTIM_INT_LV); /* 荞݃xݒ(SF) */
    /* 荞݃xݒ(HW) */
    sil_wrh_mem((VP)IPRA,
                ((sil_reh_mem((VP)IPRA) & 0x0fff) | (KTIM_INT_LV<<8)));
    /* 荞ݗvNA */
    sil_wrh_mem((VP)TMU_TCR1,
                (sil_reh_mem((VP)TMU_TCR1) & ~TCR_UNF));

    /* ݒA荞݋ */
    sil_wrh_mem((VP)TMU_TCR1,(0x020 | TCR1_TPSC));
    sil_wrw_mem((VP)TMU_TCOR1, 0); /* timer constantWX^Zbg */
}

void
hw_overrun_timer_start()
{
    sil_wrw_mem((VP)TMU_TCNT1, runtsk->leftotm); /* JE^[Zbg */
    /* ^C}1X^[g */
    sil_wrb_mem((VP)TMU_TSTR,
                (sil_reb_mem((VP)TMU_TSTR) | TMU_STR1));
}

void
hw_overrun_timer_stop()
{
    /* ^C}~ */
    sil_wrb_mem((VP)TMU_TSTR,
                (sil_reb_mem((VP)TMU_TSTR) & ~TMU_STR1));

    /* 荞ݗvNA */
    sil_wrh_mem((VP)TMU_TCR1,
                (sil_reh_mem((VP)TMU_TCR1) & ~TCR_UNF));

    runtsk->leftotm = sil_rew_mem((VP)TMU_TCNT1); /* JE^[̓ǎ */
}

/*
 *  ^C}̒~
 */
void
hw_overrun_timer_terminate()
{
    /* ^C}~ */
    sil_wrb_mem((VP)TMU_TSTR,
                (sil_reb_mem((VP)TMU_TSTR) & ~TMU_STR1));
    /* 荞ݗvNA */
    sil_wrh_mem((VP)TMU_TCR1,0);

    /* 荞݃xݒ(HW) */
    sil_wrh_mem((VP)IPRA,
                ((sil_reh_mem((VP)IPRA) & 0x0fff) & ~(KTIM_INT_LV<<8)));
}


