/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2006 by Monami Software Limited Partnership, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/config/sh3/sil_sh.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *  SH2¢쥸ؤΥ桼ƥƥʥӥåȱ黻
 *  
 *  sh2.h˵ҤΤ쥬Ȥsil.hȤΥ󥯥롼ɤ
 *  ֤δطΩեȤ
 *  t_config.hľܥ󥯥롼ɤȤsil.hˤ
 *  ե뤬󥯥롼ɤǽ롣
 *  
 *  ѥηåǽͭˤ뤿ᡢݥ󥿷
 *  VB *VH *VW *ѤƤ롣
 *  
 */

#ifndef TOPPERS_SIL_SH2_H
#define TOPPERS_SIL_SH2_H

#ifndef _MACRO_ONLY

/*
 *  8ӥåȥ쥸AND黻
 */
#ifdef __HITACHI_VERSION__
#pragma inline(sh2_b_and)
#endif
Inline void
sh2_b_and(VB *mem, VB data)
{
	VB reg = sil_reb_mem((VP)mem);
	reg &= data;
	sil_wrb_mem((VP)mem, reg);
}

/*
 *  8ӥåȥ쥸OR黻
 */
#ifdef __HITACHI_VERSION__
#pragma inline(sh2_b_or)
#endif
Inline void
sh2_b_or(VB *mem, VB data)
{
	VB reg = sil_reb_mem((VP)mem);
	reg |= data;
	sil_wrb_mem((VP)mem, reg);
}


/*
 *  16ӥåȥ쥸AND黻
 */
#ifdef __HITACHI_VERSION__
#pragma inline(sh2_h_and)
#endif
Inline void
sh2_h_and(VH *mem, VH data)
{
	VH reg = sil_reh_mem((VP)mem);
	reg &= data;
	sil_wrh_mem((VP)mem, reg);
}

/*
 *  16ӥåȥ쥸OR黻
 */
#ifdef __HITACHI_VERSION__
#pragma inline(sh2_h_or)
#endif
Inline void
sh2_h_or(VH *mem, VH data)
{
	VH reg = sil_reh_mem((VP)mem);
	reg |= data;
	sil_wrh_mem((VP)mem, reg);
}

/*
 *  32ӥåȥ쥸AND黻
 */
#ifdef __HITACHI_VERSION__
#pragma inline(sh2_w_and)
#endif
Inline void
sh2_w_and(VW *mem, VW data)
{
	VW reg = sil_rew_mem((VP)mem);
	reg &= data;
	sil_wrw_mem((VP)mem, reg);
}

/*
 *  32ӥåȥ쥸OR黻
 */
#ifdef __HITACHI_VERSION__
#pragma inline(sh2_w_or)
#endif
Inline void
sh2_w_or(VW *mem, VW data)
{
	VW reg = sil_rew_mem((VP)mem);
	reg |= data;
	sil_wrw_mem((VP)mem, reg);
}


#endif /* _MACRO_ONLY */
#endif /* TOPPERS_SIL_SH2_H */
