/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006 by Monami Software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/include/kernel.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	ITRON4.0dlWCN[ht@C
 *
 *  ̃t@Cł́CX^_[hvt@CŕKvȂ̂`
 *  ĂDf[^^̒`́CX^_[hvt@C𖞂傤
 *  ̒ɂ͂ĂȂD
 *
 *  AZũ\[Xt@CVXeRtBM[Vt@
 *  C炱̃t@CCN[h鎞́C_MACRO_ONLY `
 *  ƂŁC}N`ȊŐLqƂłD
 *
 *  ̃CN[ht@ĆCWCN[ht@Cit_services.h 
 *   jsp_kernel.hjŃCN[hD܂C ITRONdlOS 
 *  \tgEFA|[eBOꍇȂǂɂ́C̃t@C𒼐ڃC
 *  N[hĂ悢D̗OāC̃t@C璼ڃCN[
 *  h邱Ƃ͂ȂD
 *
 *  ̒ŃCN[hĂt@CāC̃CN[ht@
 *  CɈˑĂȂD
 */

#ifndef TOPPERS_KERNEL_H
#define TOPPERS_KERNEL_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  J[lEAvP[V ʃCN[ht@C
 */
#include <t_stddef.h>

/*
 *  ITRONdlʋK̃f[^^E萔E}N
 */
#include <itron.h>

/*
 *  VXevZbTɈˑ`
 */
#include <sys_defs.h>
#include <cpu_defs.h>

/*
 *  VXeOT[rX̂߂̒`
 */
#include <t_syslog.h>

/*
 *  ⏕}N
 */
#define	TROUND_VP(sz)	(((sz) + sizeof(VP) - 1) & ~(sizeof(VP) - 1))
#define	TCOUNT_VP(sz)	(((sz) + sizeof(VP) - 1) / sizeof(VP))

/*
 *  f[^^̒`
 */
#ifndef _MACRO_ONLY

typedef	UINT		TEXPTN;		/* ^XNOṽrbgp^[ */
typedef	UINT		FLGPTN;		/* CxgtÕrbgp^[ */

typedef UW		OVRTIM;		/* vZbT */
typedef UW		RDVPTN;		/* fu */
typedef UW		RDVNO;		/* fuԍ */

typedef	struct t_msg {			/* [{bNX̃bZ[Wwb_ */
	struct t_msg	*next;
} T_MSG;

typedef	struct t_msg_pri {		/* DxtbZ[Wwb_ */
	T_MSG		msgque;		/* bZ[Wwb_ */
	PRI		msgpri;		/* bZ[WDx */
} T_MSG_PRI;


typedef struct t_ctsk {
	ATR	tskatr;			/* ^XN */
	VP_INT	exinf;			/* ^XN̊g */
	FP	task;			/* ^XN̋NԒn */
	PRI	itskpri;		/* ^XN̋NDx */
	SIZE	stksz;			/* ^XÑX^bN̈̃TCYioCgj*/
	VP	stk;			/* ^XÑX^bN̈̐擪Ԓn */
} T_CTSK;

typedef struct t_rtsk {
	STAT   tskstat;			/* ^XN */
	PRI    tskpri;			/* ^XŇݗDx */
	PRI    tskbpri;			/* ^XÑx[XDx */
	STAT   tskwait;			/* ҂v */
	ID     wobjid;			/* ҂Ώۂ̃IuWFNgIDԍ */
	TMO    lefttmo;			/* ^CAEg܂ł̎ */
	UINT   actcnt;			/* NvL[CO */
	UINT   wupcnt;			/* NvL[CO */
	UINT   suscnt;			/* ҂vlXg */
} T_RTSK;

typedef struct t_rtst {
	STAT   tskstat;			/* ^XN */
	STAT   tskwait;			/* ҂v */
} T_RTST;

typedef struct t_dtex {
	ATR    texatr;			/* ^XNO[` */
	FP     texrtn;			/* ^XNO[`̋NԒn */
} T_DTEX;

typedef struct t_rtex {
	STAT   texstat;			/* ^XNȌ */
	TEXPTN pndptn;			/* ۗOv */
} T_RTEX;

typedef struct t_csem {
	ATR    sematr;			/* Z}tH */
	UINT   isemcnt;			/* Z}tH̎̏l */
	UINT   maxsem;			/* Z}tH̍đ厑 */
} T_CSEM;

typedef struct t_rsem {
	ID	wtskid;			/* Z}tH̑҂s̐擪̃^XNIDԍ */
	UINT	semcnt;			/* Z}tȞ݂̎ */
} T_RSEM;

typedef struct t_cflg {
	ATR    flgatr;			/* CxgtO */
	FLGPTN iflgptn;			/* CxgtÕrbgp^[̏l */
} T_CFLG;

typedef struct t_rflg {
	ID     wtskid;			/* CxgtÔ̑҂s̐擪̃^XNIDԍ */
	FLGPTN flgptn;			/* CxgtÔ݂̌̃rbgp^[ */
} T_RFLG;

typedef struct t_cdtq {
	ATR    dtqatr;			/* f[^L[ */
	UINT   dtqcnt;			/* f[^L[̗̈eʁif[^̌j*/
	VP     dtq;			/* f[^L[̈̐擪Ԓn */
} T_CDTQ;

typedef struct t_rdtq {
	ID     stskid;			/* f[^L[̑M҂s̐擪̃^XNIDԍ */
	ID     rtskid;			/* f[^L[̎M҂s̐擪̃^XNIDԍ */
	UINT   sdtqcnt;			/* f[^L[ɓĂf[^̐ */
} T_RDTQ;

typedef struct t_cmbx {
	ATR    mbxatr;			/* [{bNX */
	PRI    maxmpri;			/* M郁bZ[W̗Dx̍ől */
	VP     mprihd;			/* Dxʂ̃bZ[WL[wb_̈̐擪Ԓn */
} T_CMBX;

typedef struct t_rmbx {
	ID     wtskid;			/* [{bNX̑҂s̐擪̃^XNIDԍ */
	T_MSG *pk_msg;			/* bZ[WL[̐擪̃bZ[WpPbg̐擪Ԓn */
} T_RMBX;

typedef struct t_cmtx {
	ATR    mtxatr;			/* ~[ebNX */
	PRI    ceilpri;			/* ~[ebNX̏Dx */
} T_CMTX;

typedef struct t_rmtx {
	ID     htskid;			/* ~[ebNXbNĂ^XNIDԍ */
	ID     wtskid;			/* ~[ebNX̑҂s̐擪̃^XNIDԍ */
} T_RMTX;

typedef struct t_cmbf {
	ATR    mbfatr;			/* bZ[Wobt@ */
	UINT   maxmsz;			/* bZ[W̍őTCYioCgj */
	SIZE   mbfsz;			/* bZ[Wobt@̈̃TCYioCgj */
	VP     mbf;			/* bZ[Wobt@̈̐擪Ԓn */
} T_CMBF;

typedef struct t_rmbf {
	ID     stskid;			/* bZ[Wobt@̑M҂s̐擪̃^XNIDԍ */
	ID     rtskid;			/* bZ[Wobt@̎M҂s̐擪̃^XNIDԍ */
	UINT   smsgcnt;			/* bZ[Wobt@ɓĂ郁bZ[W̐ */
	SIZE   fmbfsz;			/* bZ[Wobt@̈̋󂫗̈̃TCYioCgAŒ̊Ǘ̈j */
} T_RMBF;

typedef struct t_cpor {
	ATR    poratr;			/* fu|[g */
	UINT   maxcmsz;			/* ĂяobZ[W̍őTCYioCgj */
	UINT   maxrmsz;			/* ԓbZ[W̍őTCYioCgj */
} T_CPOR;

typedef struct t_rpor {
	ID     ctskid;			/* fu|[ǧďo҂s̐擪̃^XNIDԍ */
	ID     atskid;			/* fu|[g̎t҂s̐擪̃^XNIDꍆ */
} T_RPOR;

typedef struct t_rrdv {
	ID     wtskid;			/* fuI҂Ԃ̃^XNIDԍ */
} T_RRDV;

typedef struct t_cmpf {
	ATR    mpfatr;			/* Œ蒷v[ */
	UINT   blkcnt;			/* lł郁ubNij */
	UINT   blksz;			/* ubÑTCYioCgj */
	VP     mpf;			/* Œ蒷v[̈̐擪Ԓn */
} T_CMPF;

typedef struct t_rmpf {
	ID     wtskid;			/* Œ蒷v[̑҂s̐擪̃^XNIDԍ */
	UINT   fblkcnt;			/* Œ蒷v[̋󂫃ubNij */
} T_RMPF;

typedef struct t_cmpl {
	ATR    mplatr;			/* ϒv[ */
	UINT   mplsz;			/* ubÑTCYioCgj */
	VP     mpl;			/* ϒv[̈̐擪Ԓn */
} T_CMPL;

typedef struct t_rmpl {
	ID     wtskid;			/* ϒv[̑҂s̐擪̃^XNIDԍ */
	UINT   fmplsz;			/* ϒv[̋󂫗̈̍vTCYioCgj */
	UINT   fblksz;			/* Ɋl\ȍő僁ubNTCYioCgj */
} T_RMPL;

typedef struct t_ccyc {
	ATR    cycatr;			/* nh */
	VP_INT exinf;			/* nh̊g */
	FP     cychdr;			/* nh̋NԒn */
	RELTIM cyctim;			/* nh̋N */
	RELTIM cycphs;			/* nh̋Nʑ */
} T_CCYC;

typedef struct t_rcyc {
	STAT   cycstat;			/* nh̓ */
	RELTIM lefttim;			/* nhpɋN鎞܂ł̎ */
} T_RCYC;

typedef struct t_calm {
	ATR    almatr;			/* A[nh */
	VP_INT exinf;			/* A[nh̊g */
	FP     almhdr;			/* A[nh̋NԒn */
} T_CALM;

typedef struct t_ralm {
	STAT   almstat;			/* A[nh̓ */
	RELTIM lefttim;			/* A[nh̋N܂ł̎ */
} T_RALM;

typedef struct t_dovr {
	ATR    ovratr;			/* I[onh */
	FP     ovrhdr;			/* I[onh̋NԒn */
} T_DOVR;

typedef struct t_rovr {
	STAT   ovrstat;			/* I[onh̓ */
	OVRTIM leftotm;			/* c̃vZbT */
} T_ROVR;

typedef struct t_rsys {
	UH dummy;
} T_RSYS;

typedef struct t_dinh {
	ATR    inhatr;			/* ݃nh */
	FP     inthdr;			/* ݃nh̋NԒn */
} T_DINH;

typedef struct t_cisr {
	ATR    isratr;			/* ݃T[rX[` */
	VP_INT exinf;			/* ݃T[rX[`̊g */
	INTNO  intno;			/* ݃T[rX[`t銄ݔԍ */
	FP     isr;			/* ݃T[rX[`̋NԒn */
} T_CISR;

typedef struct t_risr {
	/*
	 * pk_risr̓e͎`B
	 * {o[Włpk_risr͋B
	 */
	UINT	dummy;			/* dummy */
} T_RISR;

typedef struct t_dsvc {
	ATR    svcatr;			/* gT[rXR[ */
	FP     svcrtn;			/* gT[rXR[[`̋NԒn */
} T_DSVC;

typedef struct t_dexc {
	ATR    excatr;			/* CPUOnh */
	FP     exchdr;			/* CPUOnh̋NԒn */
} T_DEXC;

typedef struct t_rcfg {
  /*
   * pk_rcfg̒g͎ˑB
   * {o[Wł́Apk_rcfg ͋B
   */
	UINT	dummy;			/* dummy */
} T_RCFG;

typedef struct t_rver {
	UH     maker;			/* J[l̃[JR[h */
	UH     prid;			/* J[l̎ʔԍ */
	UH     spver;			/* ITRONdl̃o[Wԍ */
	UH     prver;			/* J[l̃o[Wԍ */
	UH     prno[4];			/* J[li̊Ǘ */
} T_RVER;

#endif /* _MACRO_ONLY */

/*
 *  T[rXR[̐錾
 */
#ifndef _MACRO_ONLY

/*
 *  ^XNǗ@\
 */
extern ER	cre_tsk(ID tskid, const T_CTSK *pk_ctsk) throw();
extern ER_ID	acre_tsk(const T_CTSK *pk_ctsk) throw();
extern ER	del_tsk(ID tskid);
extern ER	act_tsk(ID tskid) throw();
extern ER	iact_tsk(ID tskid) throw();
extern ER_UINT	can_act(ID tskid) throw();
extern ER	sta_tsk(ID tskid, VP_INT stacd) throw();
extern void	ext_tsk(void) throw();
extern void	exd_tsk(void) throw();
extern ER	ter_tsk(ID tskid) throw();
extern ER	chg_pri(ID tskid, PRI tskpri) throw();
extern ER	get_pri(ID tskid, PRI *p_tskpri) throw();
extern ER	ref_tsk(ID tskid, T_RTSK *pk_rtsk) throw();
extern ER	ref_tst(ID tskid, T_RTST *pk_rtst) throw();


/*
 *  ^XNt@\
 */
extern ER	slp_tsk(void) throw();
extern ER	tslp_tsk(TMO tmout) throw();
extern ER	wup_tsk(ID tskid) throw();
extern ER	iwup_tsk(ID tskid) throw();
extern ER_UINT	can_wup(ID tskid) throw();
extern ER	rel_wai(ID tskid) throw();
extern ER	irel_wai(ID tskid) throw();
extern ER	sus_tsk(ID tskid) throw();
extern ER	rsm_tsk(ID tskid) throw();
extern ER	frsm_tsk(ID tskid) throw();
extern ER	dly_tsk(RELTIM dlytim) throw();

/*
 *  ^XNO@\
 */
extern ER	def_tex(ID tskid, const T_DTEX *pk_dtex) throw();
extern ER	ras_tex(ID tskid, TEXPTN rasptn) throw();
extern ER	iras_tex(ID tskid, TEXPTN rasptn) throw();
extern ER	dis_tex(void) throw();
extern ER	ena_tex(void) throw();
extern BOOL	sns_tex(void) throw();
extern ER	ref_tex(ID tskid, T_RTEX *pk_rtex) throw();

/*
 *  EʐM@\
 */
extern ER	cre_sem(ID semid, const T_CSEM *pk_csem) throw();
extern ER_ID	acre_sem(const T_CSEM *pk_csem) throw();
extern ER	del_sem(ID semid) throw();
extern ER	sig_sem(ID semid) throw();
extern ER	isig_sem(ID semid) throw();
extern ER	wai_sem(ID semid) throw();
extern ER	pol_sem(ID semid) throw();
extern ER	twai_sem(ID semid, TMO tmout) throw();
extern ER	ref_sem(ID semid, T_RSEM *pk_rsem) throw();

extern ER	cre_flg(ID flgid, const T_CFLG *pk_cflg) throw();
extern ER_ID	acre_flg(const T_CFLG *pk_cflg) throw();
extern ER	del_flg(ID flgid) throw();
extern ER	set_flg(ID flgid, FLGPTN setptn) throw();
extern ER	iset_flg(ID flgid, FLGPTN setptn) throw();
extern ER	clr_flg(ID flgid, FLGPTN clrptn) throw();
extern ER	wai_flg(ID flgid, FLGPTN waiptn,
			MODE wfmode, FLGPTN *p_flgptn) throw();
extern ER	pol_flg(ID flgid, FLGPTN waiptn,
			MODE wfmode, FLGPTN *p_flgptn) throw();
extern ER	twai_flg(ID flgid, FLGPTN waiptn,
			MODE wfmode, FLGPTN *p_flgptn, TMO tmout) throw();
extern ER	ref_flg(ID flgid, T_RFLG *pk_rflg) throw();

extern ER	cre_dtq(ID dtqid, const T_CDTQ *pk_cdtq) throw();
extern ER_ID	acre_dtq(const T_CDTQ *pk_cdtq) throw();
extern ER	del_dtq(ID dtqid) throw();
extern ER	snd_dtq(ID dtqid, VP_INT data) throw();
extern ER	psnd_dtq(ID dtqid, VP_INT data) throw();
extern ER	ipsnd_dtq(ID dtqid, VP_INT data) throw();
extern ER	tsnd_dtq(ID dtqid, VP_INT data, TMO tmout) throw();
extern ER	fsnd_dtq(ID dtqid, VP_INT data) throw();
extern ER	ifsnd_dtq(ID dtqid, VP_INT data) throw();
extern ER	rcv_dtq(ID dtqid, VP_INT *p_data) throw();
extern ER	prcv_dtq(ID dtqid, VP_INT *p_data) throw();
extern ER	trcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout) throw();
extern ER	ref_dtq(ID dtqid, T_RDTQ *pk_rdtq) throw();

extern ER	cre_mbx(ID mbxid, const T_CMBX *pk_cmbx) throw();
extern ER_ID	acre_mbx(const T_CMBX *pk_cmbx) throw();
extern ER	del_mbx(ID mbxid) throw();
extern ER	snd_mbx(ID mbxid, T_MSG *pk_msg) throw();
extern ER	rcv_mbx(ID mbxid, T_MSG **ppk_msg) throw();
extern ER	prcv_mbx(ID mbxid, T_MSG **ppk_msg) throw();
extern ER	trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout) throw();
extern ER	ref_mbx(ID mbxid, T_RMBX *pk_rmbx) throw();

/*
 *  gEʐM@\
 */
extern ER	cre_mtx(ID mtxid, const T_CMTX *pk_cmtx) throw();
extern ER_ID	acre_mtx(const T_CMTX *pk_cmtx) throw();
extern ER	del_mtx(ID mtxid) throw();
extern ER	loc_mtx(ID mtxid) throw();
extern ER	ploc_mtx(ID mtxid) throw();
extern ER	tloc_mtx(ID mtxid, TMO tmout) throw();
extern ER	unl_mtx(ID mtxid) throw();
extern ER	ref_mtx(ID mtxid, T_RMTX *pk_rmtx) throw();

extern ER	cre_mbf(ID mbfid, const T_CMBF *pk_cmbf) throw();
extern ER_ID	acre_mbf(const T_CMBF *pk_cmbf) throw();
extern ER	del_mbf(ID mbfid) throw();
extern ER	snd_mbf(ID mbfid, VP msg, UINT msgsz) throw();
extern ER	psnd_mbf(ID mbfid, VP msg, UINT msgsz) throw();
extern ER	tsnd_mbf(ID mbfid, VP msg, UINT msgsz, TMO tmout) throw();
extern ER_UINT	rcv_mbf(ID mbfid, VP msg) throw();
extern ER_UINT	prcv_mbf(ID mbfid, VP msg) throw();
extern ER_UINT	trcv_mbf(ID mbfid, VP msg, TMO tmout) throw();
extern ER	ref_mbf(ID mbfid, T_RMBF *pk_rmbf) throw();

extern ER	cre_por(ID porid, const T_CPOR *pk_cpor) throw();
extern ER_ID	acre_por(const T_CPOR *pk_cpor) throw();
extern ER	del_por(ID porid) throw();
extern ER_UINT	cal_por(ID porid, RDVPTN calptn, VP msg, UINT cmsgsz) throw();
extern ER_UINT	tcal_por(ID porid, RDVPTN calptn, VP msg, UINT cmsgsz, TMO tmout) throw();
extern ER_UINT	acp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg) throw();
extern ER_UINT	pacp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg) throw();
extern ER_UINT	tacp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg, TMO tmout) throw();
extern ER	fwd_por(ID porid, RDVPTN calptn, RDVNO rdvno, VP msg, UINT cmsgsz) throw();
extern ER	rpl_rdv(RDVNO rdvno, VP msg, UINT rmsgsz) throw();
extern ER	ref_por(ID porid, T_RPOR *pk_rpor) throw();
extern ER	ref_rdv(RDVNO rdvno, T_RRDV *pk_rrdv) throw();


/*
 *  v[Ǘ@\
 */
extern ER	cre_mpf(ID mpfid, const T_CMPF *pk_cmpf) throw();
extern ER_ID	acre_mpf(const T_CMPF *pk_cmpf) throw();
extern ER	del_mpf(ID mpfid) throw();
extern ER	get_mpf(ID mpfid, VP *p_blk) throw();
extern ER	pget_mpf(ID mpfid, VP *p_blk) throw();
extern ER	tget_mpf(ID mpfid, VP *p_blk, TMO tmout) throw();
extern ER	rel_mpf(ID mpfid, VP blk) throw();
extern ER	ref_mpf(ID mpfid, T_RMPF *pk_rmpf) throw();

extern ER	cre_mpl(ID mplid, const T_CMPL *pk_cmpl) throw();
extern ER_ID	acre_mpl(const T_CMPL *pk_cmpl) throw();
extern ER	del_mpl(ID mplid) throw();
extern ER	get_mpl(ID mplid, UINT blksz, VP *p_blk) throw();
extern ER	pget_mpl(ID mplid, UINT blksz, VP *p_blk) throw();
extern ER	tget_mpl(ID mplid, UINT blksz, VP *p_blk, TMO tmout) throw();
extern ER	rel_mpl(ID mplid, VP blk) throw();
extern ER	ref_mpl(ID mplid, T_RMPL *pk_rmpl) throw();

/*
 *  ԊǗ@\
 */
extern ER	set_tim(const SYSTIM *p_systim) throw();
extern ER	get_tim(SYSTIM *p_systim) throw();
extern ER	isig_tim(void) throw();

extern ER	cre_cyc(ID cycid, const T_CCYC *pk_ccyc) throw();
extern ER_ID	acre_cyc(const T_CCYC *pk_ccyc) throw();
extern ER	cre_cyc(ID cycid, const T_CCYC *pk_ccyc) throw();
extern ER	del_cyc(ID cycid) throw();
extern ER	sta_cyc(ID cycid) throw();
extern ER	stp_cyc(ID cycid) throw();
extern ER	ref_cyc(ID cycid, T_RCYC *pk_rcyc) throw();

extern ER	cre_alm(ID almid, const T_CALM *pk_calm) throw();
extern ER_ID	acre_alm(const T_CALM *pk_calm) throw();
extern ER	del_alm(ID almid);
extern ER	sta_alm(ID almid, RELTIM almtim) throw();
extern ER	stp_alm(ID almid) throw();
extern ER	ref_alm(ID almid, T_RALM *pk_ralm) throw();

extern ER	def_ovr(const T_DOVR *pk_dovr) throw();
extern ER	sta_ovr(ID tskid, OVRTIM ovrtim) throw();
extern ER	stp_ovr(ID tskid) throw();
extern ER	ref_ovr(ID tskid, T_ROVR *pk_rovr) throw();


/*
 *  VXeԊǗ@\
 */
extern ER	rot_rdq(PRI tskpri) throw();
extern ER	irot_rdq(PRI tskpri) throw();
extern ER	get_tid(ID *p_tskid) throw();
extern ER	iget_tid(ID *p_tskid) throw();
extern ER	loc_cpu(void) throw();
extern ER	iloc_cpu(void) throw();
extern ER	unl_cpu(void) throw();
extern ER	iunl_cpu(void) throw();
extern ER	dis_dsp(void) throw();
extern ER	ena_dsp(void) throw();
extern BOOL	sns_ctx(void) throw();
extern BOOL	sns_loc(void) throw();
extern BOOL	sns_dsp(void) throw();
extern BOOL	sns_dpn(void) throw();
extern BOOL	vsns_ini(void) throw();
extern ER	ref_sys(T_RSYS *pk_rsys) throw();


/*
 *  ݊Ǘ@\
 */
extern ER	def_inh(INHNO inhno, const T_DINH *pk_dinh) throw();
extern ER	cre_isr(ID isrid, const T_CISR *pk_cisr) throw();
extern ER_ID	acre_isr(const T_CISR *pk_cisr) throw();
extern ER	del_isr(ID isrid) throw();
extern ER	ref_isr(ID isrid, T_RISR *pk_risr) throw();
/* TODO: extern ER chg_ixx(IXXXX ixxxx) throw(); */
/* TODO: extern ER get_ixx(IXXXX *p_ixxxx) throw(); */

/*
 *  T[rXR[Ǘ@\
 */
extern ER	def_svc(FN fncd, const T_DSVC *pk_dsvc) throw();
extern ER	cal_svc(FN fncd, VP_INT arg1, VP_INT arg2, VP_INT arg3, VP_INT arg4, VP_INT arg5) throw();

/*
 *  VXe\Ǘ@\
 */
extern ER	def_exc(EXCNO excno, const T_DEXC *pk_dexc) throw();
extern ER	ref_cfg(T_RCFG *pk_rcfg) throw();
extern ER	ref_ver(T_RVER *pk_rver) throw();


/*
 *  ƎT[rXR[
 */
extern BOOL	vxsns_ctx(VP p_excinf) throw();
extern BOOL	vxsns_loc(VP p_excinf) throw();
extern BOOL	vxsns_dsp(VP p_excinf) throw();
extern BOOL	vxsns_dpn(VP p_excinf) throw();
extern BOOL	vxsns_tex(VP p_excinf) throw();


#endif /* _MACRO_ONLY */

/*
 *  IuWFNg̒`
 */
#define TA_HLNG		0x00u		/* pC^tF[X */
#define TA_ASM		0x01u		/* AZupC^tF[X */

#define TA_TFIFO	0x00u		/* ^XN̑҂sFIFO */
#define TA_TPRI		0x01u		/* ^XN̑҂sDx */

#define TA_INHERIT	(0x02u|TA_TPRI)	/* ~[ebNXDxpvgR*/
#define TA_CEILING	(0x04u|TA_TPRI) /* ~[ebNXDxvgR*/

#define TA_MFIFO	0x00u		/* bZ[WL[FIFO */
#define TA_MPRI		0x02u		/* bZ[WL[Dx */

#define TA_ACT		0x02u		/* ^XNNꂽԂŐ */

#define TA_WSGL		0x00u		/* CxgtȎ҂^XN1 */
#define TA_WMUL		0x02u		/* CxgtȎ҂^XN𕡐 */
#define TA_CLR		0x04u		/* CxgtÕNAw */

#define	TA_STA		0x02u		/* nh𓮍ԂŐ */
#define TA_PHS		0x04u		/* nḧʑۑ */

/*
 *  T[rXR[̓샂[h̒`
 */
#define	TWF_ANDW	0x00u		/* CxgtOAND҂ */
#define	TWF_ORW		0x01u		/* CxgtOOR҂ */

/*
 *  ^XNԂ̒`
 */
#define TTS_RUN		0x01u			/* s */
#define TTS_RDY		0x02u			/* s\ */
#define TTS_WAI		0x04u			/* ҂ */
#define TTS_SUS		0x08u			/* ҂ */
#define TTS_WAS		(TTS_WAI|TTS_SUS)	/* d҂ */
#define TTS_DMT		0x10u			/* x~ */

#define TTW_SLP		0x0001u		/* N҂ */
#define TTW_DLY		0x0002u		/* Ԍoߑ҂ */
#define TTW_SEM		0x0004u		/* Z}tH̊l҂ */
#define TTW_FLG		0x0008u		/* CxgtO҂ */
#define TTW_SDTQ	0x0010u		/* f[^L[ւ̑M҂ */
#define TTW_RDTQ	0x0020u		/* f[^L[̎M҂ */
#define TTW_MBX		0x0040u		/* [{bNX̎M҂ */
#define TTW_MTX		0x0080u		/* ~[ebNX̃bN҂ */
#define TTW_SMBF	0x0100u		/* bZ[Wobt@ւ̑M҂ */
#define TTW_RMBF	0x0200u		/* bZ[Wobt@̎M҂ */
#define TTW_CAL		0x0400u		/* fǔďo҂ */
#define TTW_ACP		0x0800u		/* fu̎t҂ */
#define TTW_RDV		0x1000u		/* fȕI҂ */
#define TTW_MPF		0x2000u		/* Œ蒷ubN̊l҂ */
#define TTW_MPL		0x4000u		/* ϒubN̊l҂ */

/*
 *  IuWFNg̏
 */
#define TTEX_ENA	0x00u		/* ^XNO */
#define TTEX_DIS	0x01u		/* ^XNO֎~ */

#define TCYC_STP	0x00u		/* nh삵ĂȂ */
#define TCYC_STA	0x01u		/* nh삵Ă */

#define TALM_STP	0x00u		/* A[nh삵ĂȂ */
#define TALM_STA	0x01u		/* A[nh삵Ă */

#define TOVR_STP	0x00u		/* vZbTԐݒ肳ĂȂ */
#define TOVR_STA	0x01u		/* vZbTԐݒ肳Ă */

/*
 *  ̑̒萔̒`
 */
#define	TSK_SELF	0		/* ^XNw */
#define	TSK_NONE	0		/* Y^XNȂ */
#define	TPRI_SELF	0		/* ^XÑx[XDx̎w */
#define	TPRI_INI	0		/* ^XN̋NDx̎w */

/*
 *  \萔ƃ}N
 */

/*
 *  Dx͈̔
 */
#define	TMIN_TPRI	1		/* ^XNDx̍ŏl */
#define	TMAX_TPRI	16		/* ^XNDx̍ől */
#define	TMIN_MPRI	1		/* bZ[WDx̍ŏl */
#define	TMAX_MPRI	16		/* bZ[WDx̍ől */

/*
 *  o[W
 *  FI4J[l̏ꍇATKERNEL_PRVER͑ΉJSP̒lɍ킹B
 */
#define	TKERNEL_MAKER	0x0118u		/* J[l̃[J[R[h */
#define	TKERNEL_PRID	0x4010u		/* J[l̎ʔԍ */
#define	TKERNEL_SPVER	0x5402u		/* ITRONdl̃o[Wԍ */
#define	TKERNEL_PRVER	0x1042u		/* J[l̃o[Wԍ */

/*
 *  L[CO^lXg񐔂̍ől
 */
#define	TMAX_ACTCNT	1		/* NvL[CO̍ől */
#define	TMAX_WUPCNT	1		/* NvL[CO̍ől */
#define	TMAX_SUSCNT	1		/* ҂vlXg̍ől */

/*
 *  rbgp^[̃rbg
 */
#define	TBIT_TEXPTN	(sizeof(TEXPTN) * CHAR_BIT)
					/* ^XNOṽrbg */
#define	TBIT_FLGPTN	(sizeof(FLGPTN) * CHAR_BIT)
					/* CxgtÕrbg */
#define	TBIT_RDVPTN	(sizeof(RDVPTN) * CHAR_BIT)
					/* fũrbg */

/*
 *  Z}tH̍ő厑
 */
#define TMAX_MAXSEM	((UINT)-1)

/*
 *  dtqcnt̃f[^i[̂ɕKvȃf[^L[̈̃TCY
 *  (oCg)
 */
#define TSZ_DTQ(dtqcnt) (sizeof(VP_INT) * (dtqcnt))

/*
 *  JSPlAP̃L[ŊǗ邽߁AmprihdgȂB
 *  ITRON4.0dl̋LqɊÂA萔ƂĒ`B
 */
#define TSZ_MPRIHD(mpricnt) (4)

/*
 * blkszoCg̉ϒubNblkcnti[邽߂
 * Kvȃv[̈̃oCgB
 *
 * 傫߂ɎĂB
 */
#define TSZ_MPL(blkcnt, blksz) ((blkcnt) * (TROUND_VP(blksz) + 16) + 16)

/*
 * msgszoCg̃bZ[Wmsgcnti[̕Kv
 * bZ[Wobt@̈̃TCY(ڈ̃oCg)
 *
 * 傫߂ɎĂB
 */
#define TSZ_MBF(msgcnt, msgsz)	((msgcnt) * TROUND_VP((msgsz) + sizeof(SIZE)))

/*
 *  blkszoCg̃ubNblkcnt擾ł̂
 *  KvȌŒ蒷v[̈̃TCY(oCg)
 */
#define TSZ_MPF(blkcnt, blksz)	((blkcnt) * TROUND_VP(blksz))

/*
 *  @\R[h̒`
 */
#include "fncd.h"

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_KERNEL_H */
