/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/alarm.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	A[nh@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "alarm.h"

/*
 *  A[nhID̍őlikernel_cfg.cj
 */
extern const ID	tmax_almid;

/*
 *  A[nhubÑGAikernel_cfg.cj
 */
extern ALMINIB	alminib_table[];

/*
 *  A[nhubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_alminia;

/*
 *  A[nhubNAzyÃGAikernel_cfg.cj
 */
extern const ALMINIA	alminia_table[];

/*
 *  A[nh\ID̃GAikernel_cfg.cj
 */
extern const ID		almrid_table[];

/*
 *  A[nh\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_almrid;

/*
 *  A[nhǗubÑGAikernel_cfg.cj
 */
extern ALMCB	almcb_table[];

/*
 *  A[nh̐
 */
#define TNUM_ALM	((UINT)(tmax_almid - TMIN_ALMID + 1))

/*
 *  A[nhIDA[nhǗubNo߂̃}N
 */
#define INDEX_ALM(almid)	((UINT)((almid) - TMIN_ALMID))
#define get_almcb(almid)	(&(almcb_table[INDEX_ALM(almid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE alm_freelist;

/*
 *  ܂Œ`A[nȟ^
 */
typedef void	(*ALMHDR)(VP_INT exinf);

/*
 *  A[nh@\̏
 */
#ifdef __almini

QUEUE alm_freelist;

void
alarm_initialize()
{
	UINT	i;
	ALMCB	*almcb;
	ALMINIB *alminib;
	const ALMINIA *alminia;
	const ID	*almrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (almcb = almcb_table, i = 0; i < TNUM_ALM; almcb++, i++) {
		queue_initialize(&(almcb->free_queue));
		almcb->alminib = NULL;
	}
	queue_initialize(&alm_freelist);

	/*
	 * alminia ɂĎ̂܂
	 */
	for (alminia = alminia_table, i = 0; i < tnum_alminia; alminia++, i++) {
		UINT idx;
		idx = INDEX_ALM(alminia->almid);
		alminib = &alminib_table[idx];
		*alminib = alminia->alminib;
		almcb = &almcb_table[idx];
		almcb->alminib = alminib;

		almcb->almsta = FALSE;
		almcb->evttim = 0;

		almcb->exist = KOBJ_EXIST;
		almcb->reserved = TRUE;
	}

	/*
	 *  \ID̐ݒ
	 */
	for (almrid = almrid_table, i = 0; i < tnum_almrid; almrid++, i++) {
		almcb_table[INDEX_ALM(*almrid)].reserved = TRUE;
	}

	/*
	 * alminia ɂĎȂ̂
	 */
	for (almcb = almcb_table, i = 0; i < TNUM_ALM; almcb++, i++) {
		if (almcb->alminib == NULL) {
			almcb->exist = KOBJ_NOEXS;
			almcb->alminib = &alminib_table[i];

			if (!CHECK_OBJECT_RESERVED(almcb)) {
				queue_insert_prev(&alm_freelist, (QUEUE*)almcb);
			}
		}
	}
}

#endif /* __almini */

/*
 *  A[nh̐
 */
#ifdef __cre_alm

SYSCALL ER
cre_alm(ID almid, const T_CALM * pk_calm)
{
	ALMCB	*almcb;
	ALMINIB *alminib;
	ER	ercd;
    
	LOG_CRE_ALM_ENTER(almid, pk_calm);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	CHECK_ATTRIBUTE(pk_calm->almatr, TA_HLNG | TA_ASM);

	almcb = get_almcb(almid);
	CHECK_OBJECT_CREATABLE(almcb);
	UPDATE_OBJECT_FREELIST(almcb);

	/*
	 * ݒsB
	 */
	queue_initialize(&(almcb->free_queue));
	alminib = almcb->alminib;
	alminib->almatr = pk_calm->almatr;
	alminib->exinf  = pk_calm->exinf;
	alminib->almhdr = pk_calm->almhdr;
	almcb->almsta = FALSE;

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	almcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_alm */

/*
 *  A[nh̐(IDԍt)
 */
#ifdef __acre_alm

SYSCALL ER_ID
acre_alm(const T_CALM *pk_calm)
{
	ALMCB	*almcb;
	ALMINIB *alminib;
	ER_ID	ercd;
    
	LOG_ACRE_ALM_ENTER(pk_calm);
	CHECK_TSKCTX_UNL();

	if (TNUM_ALM == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_calm->almatr, TA_HLNG | TA_ASM);

	t_lock_cpu();
	almcb = (ALMCB *)t_get_free_id((QUEUE *)&alm_freelist);
	if (almcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	almcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * ݒsB
	 */
	queue_initialize(&(almcb->free_queue));
	alminib = almcb->alminib;
	alminib->almatr = pk_calm->almatr;
	alminib->exinf  = pk_calm->exinf;
	alminib->almhdr = pk_calm->almhdr;
	almcb->almsta = FALSE;

	ercd = ALMID(almcb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	almcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_alm */

/*
 *  A[nh̍폜
 */
#ifdef __del_alm
SYSCALL ER
del_alm(ID almid)
{
	ALMCB	*almcb;
	ER	ercd;
    
	LOG_DEL_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);

	CHECK_OBJECT_DELETABLE(almcb);

	/*
	 *  A[nh삵ĂA~B
	 */
	if (almcb->almsta) {
		t_lock_cpu();
		almcb->almsta = FALSE;
		tmevtb_dequeue(&(almcb->tmevtb));
		t_unlock_cpu();
	}

	/*
	 *  \IDłȂ΃t[XgɓB
	 */
	if (!CHECK_OBJECT_RESERVED(almcb)) {
		t_lock_cpu();
		queue_insert_prev(&alm_freelist, (QUEUE *)almcb);
		t_unlock_cpu();
	}

	/*
	 *  acre_/cre_ł̃ANZX\
	 */
	almcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_alm */

/*
 *  A[nh̓Jn
 */
#ifdef __sta_alm

SYSCALL ER
sta_alm(ID almid, RELTIM almtim)
{
	ALMCB	*almcb;
	ER	ercd;
	EVTTIM	evttim;

	LOG_STA_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);

	evttim = base_time + almtim;
	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(almcb);

	if (almcb->almsta) {
		tmevtb_dequeue(&(almcb->tmevtb));
	} else {
		almcb->almsta = TRUE;
	}
	tmevtb_enqueue_evttim(&(almcb->tmevtb), evttim,
				(CBACK) call_almhdr, (VP) almcb);
	almcb->evttim = evttim;

	t_unlock_cpu();

	ercd = E_OK;
    exit:
	LOG_STA_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_alm */

/*
 *  A[nh̓~
 */
#ifdef __stp_alm

SYSCALL ER
stp_alm(ID almid)
{
	ALMCB	*almcb;
	ER	ercd;

	LOG_STP_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(almcb);

	/*
	 * ΏۃA[nh,삵ĂȂA[nhw肳ꂽ
	 * ꍇɂ,Ȃ. (ITRON4.0dl)
	 */
	if (almcb->almsta) {
		almcb->almsta = FALSE;
		tmevtb_dequeue(&(almcb->tmevtb));
	}
	ercd = E_OK;

	t_unlock_cpu();
     exit:
	LOG_STP_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __stp_alm */

/*
 *  A[nh̏ԎQ
 */
#ifdef __ref_alm
SYSCALL ER
ref_alm(ID almid, T_RALM *pk_ralm)
{
	ALMCB	*almcb;
	ER	ercd;
    
	LOG_REF_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(almcb);

	if (almcb->almsta) {
		pk_ralm->almstat = TALM_STA;
	} else {
		pk_ralm->almstat = TALM_STP;
	}

	pk_ralm->lefttim = almcb->evttim - base_time;

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_alm */

/*
 *  nhN[`
 */
#ifdef __almcal

void
call_almhdr(ALMCB *almcb)
{
	/*
	 *  A[nhCCPUbNԂŌĂяoD
	 */
	i_unlock_cpu();
	LOG_ALM_ENTER(almcb);
	((ALMHDR)(*almcb->alminib->almhdr))(almcb->alminib->exinf);
	almcb->almsta = FALSE;
	LOG_ALM_LEAVE(almcb);
	i_lock_cpu();
}

#endif /* __almcal */
