/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/check.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	G[`FbNp}N
 */

#ifndef TOPPERS_CHECK_H
#define TOPPERS_CHECK_H

/*
 *  Dx͈̔͂̔
 */
#define VALID_TPRI(tpri) \
	(TMIN_TPRI <= (tpri) && (tpri) <= TMAX_TPRI)

/*
 *  l0łȂƂ`FbN (E_PAR)
 */
#define CHECK_NOT_ZERO(value) { \
	if ((value) == 0) { \
		ercd = E_PAR; \
		goto exit; \
	} \
}


/*
 *  bZ[WDx̃`FbNiE_PARj
 */
#define VALID_MPRI(mpri) \
((mpri) != 0 && (TMIN_MPRI <= (mpri) && (mpri) <= TMAX_MPRI))

#define CHECK_MPRI(mpri) { \
	if (!VALID_MPRI(mpri)) { \
		ercd = E_PAR; \
		goto exit; \
	} \
}

/*
 *  ^XNDx̃`FbNiE_PARj
 */
#define CHECK_TPRI(tpri) {					\
	if (!VALID_TPRI(tpri)) {				\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

#define CHECK_TPRI_INI(tpri) {					\
	if (!(VALID_TPRI(tpri) || (tpri) == TPRI_INI)) {	\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

#define CHECK_TPRI_SELF(tpri) {					\
	if (!(VALID_TPRI(tpri) || (tpri) == TPRI_SELF)) {	\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/*
 *  ^CAEgwl̃`FbNiE_PARj
 */
#define CHECK_TMOUT(tmout) {					\
	if (!(TMO_FEVR <= (tmout))) {				\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/*
 *  ̑̃p[^G[̃`FbNiE_PARj
 */
#define CHECK_PAR(exp) {					\
	if (!(exp)) {						\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

#define CHECK_ATTRIBUTE(atr, flg) {				\
	if (((atr) & ~(flg)) != 0) {				\
		ercd = E_RSATR;					\
		goto exit;					\
	}							\
}

/*
 *  t[XgɊĉ\ID邩ǂ̃`FbN
 *  \ȃRg[ubNt[Xgɖ΁ANULLԂB
 *  ԒlNULL̂ƂAT[rXR[ E_NOID Ŕ邱Ƃ҂B
 *  CPŨbN͍sȂ̂ŁAT[rXR[̐ӔCōsƁB
 */
#define t_get_free_id(list) \
	(queue_empty((list)) ?					\
	 NULL : queue_delete_next((list)))			\

/*
 *  IuWFNgID͈̔͂̔
 */
#define VALID_TSKID(tskid) \
	(TMIN_TSKID <= (tskid) && (tskid) <= tmax_tskid)

#define VALID_SEMID(semid) \
	(TMIN_SEMID <= (semid) && (semid) <= tmax_semid)

#define VALID_FLGID(flgid) \
	(TMIN_FLGID <= (flgid) && (flgid) <= tmax_flgid)

#define VALID_DTQID(dtqid) \
	(TMIN_DTQID <= (dtqid) && (dtqid) <= tmax_dtqid)

#define VALID_MBXID(mbxid) \
	(TMIN_MBXID <= (mbxid) && (mbxid) <= tmax_mbxid)

#define VALID_MPFID(mpfid) \
	(TMIN_MPFID <= (mpfid) && (mpfid) <= tmax_mpfid)

#define VALID_MPLID(mplid) \
	(TMIN_MPLID <= (mplid) && (mplid) <= tmax_mplid)

#define VALID_MTXID(mtxid) \
	(TMIN_MTXID <= (mtxid) && (mtxid) <= tmax_mtxid)

#define VALID_MBFID(mbfid) \
	(TMIN_MBFID <= (mbfid) && (mbfid) <= tmax_mbfid)

#define VALID_PORID(porid) \
	(TMIN_PORID <= (porid) && (porid) <= tmax_porid)

#define VALID_CYCID(cycid) \
	(TMIN_CYCID <= (cycid) && (cycid) <= tmax_cycid)

#define VALID_ALMID(almid) \
	(TMIN_ALMID <= (almid) && (almid) <= tmax_almid)

#define VALID_ISRID(almid) \
	(TMIN_ISRID <= (isrid) && (isrid) <= tmax_isrid)

/*
 *  IuWFNgID̃`FbNiE_IDj
 */
#define CHECK_TSKID(tskid) {					\
	if (!VALID_TSKID(tskid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_TSKID_SELF(tskid) {				\
	if (!(VALID_TSKID(tskid) || (tskid) == TSK_SELF)) {	\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_SEMID(semid) {					\
	if (!VALID_SEMID(semid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_FLGID(flgid) {					\
	if (!VALID_FLGID(flgid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_DTQID(dtqid) {					\
	if (!VALID_DTQID(dtqid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MBXID(mbxid) {					\
	if (!VALID_MBXID(mbxid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MPFID(mpfid) {					\
	if (!VALID_MPFID(mpfid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MPLID(mplid) {					\
	if (!VALID_MPLID(mplid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MTXID(mtxid) {					\
	if (!VALID_MTXID(mtxid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MBFID(mbfid) {					\
	if (!VALID_MBFID(mbfid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_PORID(porid) {					\
	if (!VALID_PORID(porid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_CYCID(cycid) {					\
	if (!VALID_CYCID(cycid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_ALMID(almid) {					\
	if (!VALID_ALMID(almid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_ISRID(isrid) {					\
	if (!VALID_ISRID(isrid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

/*
 *  ďoReLXg̃`FbNiE_CTXj
 */
#define CHECK_TSKCTX() {					\
	if (sense_context()) {					\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

#define CHECK_INTCTX() {					\
	if (!sense_context()) {					\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  ďoReLXgCPUbNԂ̃`FbNiE_CTXj
 */
#define CHECK_TSKCTX_UNL() {					\
	if (sense_context() || t_sense_lock()) {		\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

#define CHECK_INTCTX_UNL() {					\
	if (!sense_context() || i_sense_lock()) {		\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  fBXpb`ۗԂłȂ̃`FbNiE_CTXj
 */
#define CHECK_DISPATCH() {					\
	if (sense_context() || t_sense_lock() || !(enadsp)) {	\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  ̑̃ReLXgG[̃`FbNiE_CTXj
 */
#define CHECK_CTX(exp) {					\
	if (!(exp)) {						\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  ^XNw肵ĂȂ̃`FbNiE_ILUSEj
 */
#define CHECK_NONSELF(tcb) {					\
	if ((tcb) == runtsk) {					\
		ercd = E_ILUSE;					\
		goto exit;					\
	}							\
}

/*
 *  ̑̕sgpG[̃`FbNiE_ILUSEj
 */
#define CHECK_ILUSE(exp) {					\
	if (!(exp)) {						\
		ercd = E_ILUSE;					\
		goto exit;					\
	}							\
}


/*
 *  cre_nŗpB
 *  ݂/IDɑ΂ĂE_OBJԂA݂Ȃꍇ
 *  IuWFNg̑ݏԂɈڍsB
 */
#define CHECK_OBJECT_CREATABLE(exp) {				\
	t_lock_cpu();						\
	if ((exp)->exist != KOBJ_NOEXS) {			\
		t_unlock_cpu();					\
		ercd = E_OBJ;					\
		goto exit;					\
	}							\
	(exp)->exist = KOBJ_INIT;				\
	t_unlock_cpu();						\
}
#define CHECK_TASK_CREATABLE(exp) {				\
	t_lock_cpu();						\
	if ((exp)->exist != KOBJ_NOEXS) {			\
		t_unlock_cpu();					\
		ercd = E_OBJ;					\
		goto exit;					\
	}							\
	(exp)->exist = KOBJ_INIT;				\
	t_unlock_cpu();						\
}

/*
 *  del_nŗpB
 *  ݂ȂIDɑ΂ĂE_NOEXSԂA݂ꍇ
 *  IuWFNg̑ݏԂ폜ɈڍsB
 */
#define CHECK_OBJECT_DELETABLE(exp) {				\
	t_lock_cpu();						\
	if ((exp)->exist != KOBJ_EXIST) {			\
		t_unlock_cpu();					\
		ercd = E_NOEXS;					\
		goto exit;					\
	}							\
	(exp)->exist = KOBJ_INIT;				\
	t_unlock_cpu();						\
}

#define T_CHECK_OBJECT_EXIST(exp) {				\
	if ((exp)->exist != KOBJ_EXIST) {			\
		t_unlock_cpu();					\
		ercd = E_NOEXS;					\
		goto exit;					\
	}							\
}
#define I_CHECK_OBJECT_EXIST(exp) {				\
	if ((exp)->exist != KOBJ_EXIST) {			\
		i_unlock_cpu();					\
		ercd = E_NOEXS;					\
		goto exit;					\
	}							\
}

#define CHECK_OBJECT_RESERVED(exp) ((exp)->reserved)

/*
 * Rg[ubNt[XgɂꍇAt[Xg폜B
 * 폜Ȃacre_Ŕj]B
 */
#define UPDATE_OBJECT_FREELIST(exp) {				\
	if (!(CHECK_OBJECT_RESERVED(exp))) {			\
		queue_delete((QUEUE*)(exp));			\
	}							\
 }

#endif /* TOPPERS_CHECK_H */
