/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/configuration.c 2750 2006-03-07T16:15:24.532712Z monaka  $
 */

/*
 *	VXe\Ǘ@\
 */

#include "fi4_kernel.h"
#include "configuration.h"
#include "check.h"

/*
 *  CPUOnh̒`
 */
#ifdef __def_exc

SYSCALL
ER def_exc(EXCNO excno, const T_DEXC *pk_dexc)
{
	ER ercd = E_OK;

	LOG_DEF_EXC_ENTER(excno);

	if (pk_dexc == NULL) {
		undef_exc(excno);
	} else {
		CHECK_ATTRIBUTE(pk_dexc->excatr, TA_HLNG | TA_ASM);
		define_exc(excno, pk_dexc->exchdr);
	}
exit:
	LOG_DEF_EXC_LEAVE(ercd);
	return ercd;
}

#endif /* __def_exc */

/*
 *  RtBM[V̎Q
 *
 * pk_rcfg̒g͎ˑB
 * {o[Wł́Apk_rcfg ͋B
 * āA邱ƂȂB
 */
#ifdef __ref_cfg

SYSCALL
ER ref_cfg(T_RCFG *pk_rcfg)
{
	return E_OK;
}
#endif /* __ref_cfg */

/*
 *  o[W̎Q
 */
#ifdef __ref_ver

SYSCALL
ER ref_ver(T_RVER *pk_rver)
{
	pk_rver->maker = TKERNEL_MAKER;
	pk_rver->prid = TKERNEL_PRID;
	pk_rver->spver = TKERNEL_SPVER;
	pk_rver->prver = TKERNEL_PRVER;

	/*
	 *  prno ̓e̓[JɔCĂB
	 *  A̍ڂg悤ɂȂ
	 *  Ȃ悤A{o[Wł
	 *  z0NAB
	 */
	pk_rver->prno[0] = 0;
	pk_rver->prno[1] = 0;
	pk_rver->prno[2] = 0;
	pk_rver->prno[3] = 0;

	return E_OK;
}

#endif /* __ref_ver */


