/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/cyclic.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	nh@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "cyclic.h"

/*
 *  nhID̍őlikernel_cfg.cj
 */
extern const ID	tmax_cycid;

/*
 *  nhubÑGAikernel_cfg.cj
 */
extern CYCINIB	cycinib_table[];

/*
 *  nhubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_cycinia;

/*
 *  nhubNAzyÃGAikernel_cfg.cj
 */
extern const CYCINIA	cycinia_table[];

/*
 *  nh\ID̃GAikernel_cfg.cj
 */
extern const ID		cycrid_table[];

/*
 *  nh\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_cycrid;

/*
 *  nhǗubÑGAikernel_cfg.cj
 */
extern CYCCB	cyccb_table[];

/*
 *  nh̐
 */
#define TNUM_CYC	((UINT)(tmax_cycid - TMIN_CYCID + 1))

/*
 *  nhIDnhǗubNo߂̃}N
 */
#define INDEX_CYC(cycid)	((UINT)((cycid) - TMIN_CYCID))
#define get_cyccb(cycid)	(&(cyccb_table[INDEX_CYC(cycid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE cyc_freelist;

/*
 *  ܂Œ`nȟ^
 */
typedef void	(*CYCHDR)(VP_INT exinf);

/*
 *  nh@\̏
 */
#ifdef __cycini

QUEUE cyc_freelist;

void
cyclic_initialize()
{
	UINT	i;
	CYCCB	*cyccb;
	CYCINIB *cycinib;
	const CYCINIA *cycinia;
	const ID	*cycrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (cyccb = cyccb_table, i = 0; i < TNUM_CYC; cyccb++, i++) {
		queue_initialize(&(cyccb->free_queue));
		cyccb->cycinib = NULL;
	}
	queue_initialize(&cyc_freelist);

	/*
	 * cycinia ɂĎ̂܂
	 */
	for (cycinia = cycinia_table, i = 0; i < tnum_cycinia; cycinia++, i++) {
		UINT idx;
		idx = INDEX_CYC(cycinia->cycid);
		cycinib = &cycinib_table[idx];
		*cycinib = cycinia->cycinib;
		cyccb = &cyccb_table[idx];
		cyccb->cycinib = cycinib;
		cyccb->exist = KOBJ_EXIST;
		cyccb->reserved = TRUE;

		if ((cyccb->cycinib->cycatr & TA_STA) != 0) {
			cyccb->cycsta = TRUE;
			tmevtb_enqueue_cyc(cyccb, cyccb->cycinib->cycphs);
		}
		else {
			if ((cyccb->cycinib->cycatr & TA_PHS) != 0) {
				tmevtb_enqueue_cyc(cyccb, cyccb->cycinib->cycphs);
			}
			cyccb->cycsta = FALSE;
		}
	}

	/*
	 *  \ID̐ݒ
	 */
	for (cycrid = cycrid_table, i = 0; i < tnum_cycrid; cycrid++, i++) {
		cyccb_table[INDEX_CYC(*cycrid)].reserved = TRUE;
	}

	/*
	 * cycinia ɂĎȂ̂
	 */
	for (cyccb = cyccb_table, i = 0; i < TNUM_CYC; cyccb++, i++) {
		if (cyccb->cycinib == NULL) {
			cyccb->exist = KOBJ_NOEXS;
			cyccb->cycinib = &cycinib_table[i];

			if (!CHECK_OBJECT_RESERVED(cyccb)) {
				queue_insert_prev(&cyc_freelist, (QUEUE*)cyccb);
			}
		}
	}
}

#endif /* __cycini */

/*
 *  nhN̂߂̃^CCxgubN̓o^
 */
#ifdef __cycenq

void
tmevtb_enqueue_cyc(CYCCB *cyccb, EVTTIM evttim)
{
	tmevtb_enqueue_evttim(&(cyccb->tmevtb), evttim,
				(CBACK) call_cychdr, (VP) cyccb);
	cyccb->evttim = evttim;
}

#endif /* __cycenq */

/*
 *  nh̐
 */
#ifdef __cre_cyc

SYSCALL ER
cre_cyc(ID cycid, const T_CCYC * pk_ccyc)
{
	CYCCB	*cyccb;
	CYCINIB *cycinib;
	ER	ercd;
    
	LOG_CRE_CYC_ENTER(cycid, pk_ccyc);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	CHECK_ATTRIBUTE(pk_ccyc->cycatr, TA_HLNG | TA_ASM | TA_PHS | TA_STA);
	CHECK_NOT_ZERO(pk_ccyc->cyctim);

	cyccb = get_cyccb(cycid);
	CHECK_OBJECT_CREATABLE(cyccb);
	UPDATE_OBJECT_FREELIST(cyccb);

	/*
	 * ݒsB
	 */
	queue_initialize(&(cyccb->free_queue));
	cycinib = cyccb->cycinib;
	cycinib->cycatr = pk_ccyc->cycatr;
	cycinib->exinf  = pk_ccyc->exinf;
	cycinib->cychdr = pk_ccyc->cychdr;
	cycinib->cyctim = pk_ccyc->cyctim;
	cycinib->cycphs = pk_ccyc->cycphs;

	if ((cyccb->cycinib->cycatr & TA_STA) != 0) {
		cyccb->cycsta = TRUE;
		tmevtb_enqueue_cyc(cyccb, base_time + cyccb->cycinib->cycphs);
	}
	else {
		if ((cyccb->cycinib->cycatr & TA_PHS) != 0) {
			tmevtb_enqueue_cyc(cyccb, base_time + cyccb->cycinib->cycphs);
		}
		cyccb->cycsta = FALSE;
	}

	ercd = E_OK;

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	cyccb->exist = KOBJ_EXIST;

    exit:
	LOG_CRE_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_cyc */

/*
 *  nh̐(IDԍt)
 */
#ifdef __acre_cyc

SYSCALL ER_ID
acre_cyc(const T_CCYC *pk_ccyc)
{
	CYCCB	*cyccb;
	CYCINIB *cycinib;
	ER_ID	ercd;
    
	LOG_ACRE_CYC_ENTER(pk_ccyc);
	CHECK_TSKCTX_UNL();

	if (TNUM_CYC == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_ccyc->cycatr, TA_HLNG | TA_ASM | TA_PHS | TA_STA);
	CHECK_NOT_ZERO(pk_ccyc->cyctim);

	t_lock_cpu();
	cyccb = (CYCCB *)t_get_free_id((QUEUE *)&cyc_freelist);
	if (cyccb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	cyccb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * ݒsB
	 */
	queue_initialize(&(cyccb->free_queue));
	cycinib = cyccb->cycinib;
	cycinib->cycatr = pk_ccyc->cycatr;
	cycinib->exinf  = pk_ccyc->exinf;
	cycinib->cychdr = pk_ccyc->cychdr;
	cycinib->cyctim = pk_ccyc->cyctim;
	cycinib->cycphs = pk_ccyc->cycphs;

	if ((cyccb->cycinib->cycatr & TA_STA) != 0) {
		cyccb->cycsta = TRUE;
		tmevtb_enqueue_cyc(cyccb, base_time + cyccb->cycinib->cycphs);
	}
	else {	
		if ((cyccb->cycinib->cycatr & TA_PHS) != 0) {
			tmevtb_enqueue_cyc(cyccb, base_time + cyccb->cycinib->cycphs);
		}
		cyccb->cycsta = FALSE;
	}

	ercd = CYCID(cyccb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	cyccb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_cyc */

/*
 *  nh̍폜
 */
#ifdef __del_cyc
SYSCALL ER
del_cyc(ID cycid)
{
	CYCCB	*cyccb;
	ER	ercd;
    
	LOG_DEL_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	CHECK_OBJECT_DELETABLE(cyccb);

	/*
	 * nh삵ĂA~B
	 * ԃCxgL[ɓĂŌ̃nh
	 * ̂悤ɑŎ~߂ėǂ̂ǂ́A
	 * dl͓ǂ߂ȂÂ悤ȎɂȂ
	 * ςK͂ɂȂ̂ŁAˑƗ邱ƂɂB
	 */
	if (cyccb->cycsta || (cyccb->cycinib->cycatr & TA_PHS)) {
		cyccb->cycsta = FALSE;
		t_lock_cpu();
		tmevtb_dequeue(&(cyccb->tmevtb));
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(cyccb)) {
	  /*
	   * \IDłȂ΃t[XgɓB
	   */
		t_lock_cpu();
		queue_insert_prev(&cyc_freelist, (QUEUE *)cyccb);
		t_unlock_cpu();
	}

	/* acre_/cre_ł̃ANZX\ */
	cyccb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_cyc */

/*
 *  nh̓Jn
 */
#ifdef __sta_cyc

SYSCALL ER
sta_cyc(ID cycid)
{
	CYCCB	*cyccb;
	ER	ercd;

	LOG_STA_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(cyccb);

	if ((cyccb->cycinib->cycatr & TA_PHS) != 0) {
		/*
		 *  TA_PHS ̂Ƃ́Atmevtb ɃL[COĂ̂
		 *  P cycsta  TRUE ɂ邾ł悢B
		 */
		cyccb->cycsta = TRUE;
	} else {
		if (cyccb->cycsta) {
			tmevtb_dequeue(&(cyccb->tmevtb));
		}
		else {
			cyccb->cycsta = TRUE;
		}
		tmevtb_enqueue_cyc(cyccb, base_time + cyccb->cycinib->cyctim);
	}
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_STA_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_cyc */

/*
 *  nh̓~
 */
#ifdef __stp_cyc

SYSCALL ER
stp_cyc(ID cycid)
{
	CYCCB	*cyccb;
	ER	ercd;

	LOG_STP_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(cyccb);

	/*
	 * Ώێnh,삵ĂȂԂ̎nhw肳ꂽ
	 * ꍇɂ,Ȃ. (ITRON4.0dl)
	 */
	if (cyccb->cycsta) {
		if ((cyccb->cycinib->cycatr & TA_PHS) != 0) {
			/*
			 *  TA_PHS ̂Ƃ́Atmevtb fL[Ă
			 *  ȂB(ʑۑłȂȂ)
			 */
			cyccb->cycsta = FALSE;
		} else {
			cyccb->cycsta = FALSE;
			tmevtb_dequeue(&(cyccb->tmevtb));
		}
	}
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_STP_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __stp_cyc */

/*
 *  nh̏ԎQ
 */
#ifdef __ref_cyc

SYSCALL ER
ref_cyc(ID cycid, T_RCYC *pk_rcyc)
{
	CYCCB	*cyccb;
	ER	ercd;

	LOG_STP_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(cyccb);

	if (cyccb->cycsta) {
		pk_rcyc->cycstat = TCYC_STA;
	} else {
		pk_rcyc->cycstat = TCYC_STP;
	}

	pk_rcyc->lefttim = cyccb->evttim - base_time;

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_STP_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_cyc */

/*
 *  nhN[`
 */
#ifdef __cyccal

void
call_cychdr(CYCCB *cyccb)
{
	/*
	 *  ̋N̂߂̃^CCxgubNo^D
	 *
	 *  ^CeBbNŎnhēxNׂꍇɂ́C
	 *  ̊֐ isig_tim ɖ߂ɁCēx̊֐Ă΂
	 *  ƂɂȂD
	 */
	tmevtb_enqueue_cyc(cyccb, cyccb->evttim + cyccb->cycinib->cyctim);

	if (cyccb->cycsta) {
		/*
		 *  nhCCPUbNԂŌĂяoD
		 */
		i_unlock_cpu();
		LOG_CYC_ENTER(cyccb);
		((CYCHDR)(*cyccb->cycinib->cychdr))(cyccb->cycinib->exinf);
		LOG_CYC_LEAVE(cyccb);
		i_lock_cpu();
	} else {
		if ((cyccb->cycinib->cycatr & TA_PHS) != 0) {
			/*
			 *  Nʑ̕ۑȂ̂,
			 *  nh͌ĂяoȂ.
			 *  OcKvȂ΁A
			 *  ɑ}΂悢.
			 */
			return;
		} else {
			/*
			 *  nh̓삪~,Nʑ̕ۑ
			 *  ȂԂŁÅ֐ɓĂ邱Ƃ͂蓾Ȃ.
			 */
			assert("Internal error: called call_cychdr in stopped state.");
		}
	}
}

#endif /* __cyccal */
