/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/cyclic.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	nh@\
 */

#ifndef TOPPERS_CYCLIC_H
#define TOPPERS_CYCLIC_H

#include "queue.h"
#include "time_event.h"

/*
 *  nhubN
 */
typedef struct cyclic_handler_initialization_block {
	ATR	cycatr;		/* nh */
	VP_INT	exinf;		/* nh̊g */
	FP	cychdr;		/* nh̋NԒn */
	RELTIM	cyctim;		/* nh̋N */
	RELTIM	cycphs;		/* nh̋Nʑ */
} CYCINIB;

/*
 *  nhubNAzyA
 */
typedef struct cyclic_handler_initialization_block_apair {
	ID	cycid;
	CYCINIB	cycinib;
} CYCINIA;

/*
 *  nhǗubN
 */
typedef struct cyclic_handler_control_block {
	QUEUE free_queue;	/* IDăt[XgpL[ */
	CYCINIB *cycinib;	/* nhubNւ̃|C^ */
	BOOL	cycsta;		/* nh̓ */
	EVTTIM	evttim;		/* ɎnhN鎞 */
	TMEVTB	tmevtb;		/* ^CCxgubN */
	unsigned int	exist:2;	/* gĂƂAKOBJ_EXIST */
	unsigned int	reserved:1;
} CYCCB;

/*
 *  nh@\̏
 */
extern void	cyclic_initialize(void);

/*
 *  nhN̂߂̃^CCxgubN̓o^
 */
extern void	tmevtb_enqueue_cyc(CYCCB *cyccb, EVTTIM evttim);

/*
 *  nhN[`
 */
extern void	call_cychdr(CYCCB *cyccb);

#define CYCID(cyccb)	((ID)((cyccb) - cyccb_table) + TMIN_CYCID)

#endif /* TOPPERS_CYCLIC_H */
