/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/eventflag.c 6186 2006-11-05T04:04:59.527214Z monaka  $
 */

/*
 *	CxgtO@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "eventflag.h"

/*
 *  CxgtOID̍őlikernel_cfg.cj
 */
extern const ID	tmax_flgid;

/*
 *  CxgtOubÑGAikernel_cfg.cj
 */
extern FLGINIB	flginib_table[];

/*
 *  CxgtOubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_flginia;

/*
 *  CxgtOubNAzyÃGAikernel_cfg.cj
 */
extern const FLGINIA	flginia_table[];

/*
 *  CxgtO\ID̃GAikernel_cfg.cj
 */
extern const ID		flgrid_table[];

/*
 *  CxgtO\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_flgrid;

/*
 *  CxgtOǗubÑGAikernel_cfg.cj
 */
extern FLGCB	flgcb_table[];

/*
 *  CxgtO̐
 */
#define TNUM_FLG	((UINT)(tmax_flgid - TMIN_FLGID + 1))

/*
 *  CxgtOIDCxgtOǗubNo߂̃}N
 */
#define INDEX_FLG(flgid)	((UINT)((flgid) - TMIN_FLGID))
#define get_flgcb(flgid)	(&(flgcb_table[INDEX_FLG(flgid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE flg_freelist;

/*
 *  CxgtO҂ubN̒`
 *
 *  flgptn ́Cwaiptn  wfmode ƓɎgƂ͂Ȃ߁Cunion 
 *  g΃ߖ񂷂邱Ƃ\łD
 */
typedef struct eventflag_waiting_information {
	WINFO	winfo;		/* W̑҂ubN */
	WOBJCB	*wobjcb;	/* ҂IuWFNg̊ǗubN */
	FLGPTN	waiptn;		/* ҂p^[ */
	MODE	wfmode;		/* ҂[h */
	FLGPTN	flgptn;		/* ҂̃p^[ */
} WINFO_FLG;

extern QUEUE *chk_flg_cond(FLGCB *flgcb, QUEUE *queue, BOOL *disp);

/*
 *  CxgtO@\̏
 */
#ifdef __flgini

QUEUE flg_freelist;

void
eventflag_initialize(void)
{
	UINT	i;
	FLGCB	*flgcb;
	FLGINIB *flginib;
	FLGINIA const *flginia;
	ID	const *flgrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (flgcb = flgcb_table, i = 0; i < TNUM_FLG; flgcb++, i++) {
		queue_initialize(&(flgcb->wait_queue));
		flgcb->flginib = NULL;
	}
	queue_initialize(&flg_freelist);

	/*
	 * flginia ɂĎ̂܂
	 */
	for (flginia = flginia_table, i = 0; i < tnum_flginia; flginia++, i++) {
		flginib = &flginib_table[INDEX_FLG(flginia->flgid)];
		*flginib = flginia->flginib;
		flgcb = &flgcb_table[INDEX_FLG(flginia->flgid)];
		flgcb->flginib = flginib;
		flgcb->exist = KOBJ_EXIST;
		flgcb->reserved = TRUE;

		flgcb->flgptn = flginib->iflgptn;
	}

	/*
	 *  \ID̐ݒ
	 */
	for (flgrid = flgrid_table, i = 0; i < tnum_flgrid; flgrid++, i++) {
		flgcb_table[INDEX_FLG(*flgrid)].reserved = TRUE;
	}

	/*
	 * flginia ɂĎȂ̂
	 */
	for (flgcb = flgcb_table, i = 0; i < TNUM_FLG; flgcb++, i++) {
		if (flgcb->flginib == NULL) {
			flgcb->exist = KOBJ_NOEXS;
			flgcb->flginib = &flginib_table[i];

			if (!CHECK_OBJECT_RESERVED(flgcb)) {
				queue_insert_prev(&flg_freelist, (QUEUE*)flgcb);
			}
		}
	}
}

#endif /* __flgini */

/*
 *  CxgtO҂̃`FbN
 */
#ifdef __flgcnd

BOOL
eventflag_cond(FLGCB *flgcb, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	if ((wfmode & TWF_ORW) != 0 ? (flgcb->flgptn & waiptn) != 0
				: (flgcb->flgptn & waiptn) == waiptn) {
		*p_flgptn = flgcb->flgptn;
		if ((flgcb->flginib->flgatr & TA_CLR) != 0) {
			flgcb->flgptn = 0;
		}
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __flgcnd */

/*
 *  CxgtO̐
 */
#ifdef __cre_flg

SYSCALL ER
cre_flg(ID flgid, const T_CFLG * pk_cflg)
{
	FLGCB	*flgcb;
	FLGINIB *flginib;
	ER	ercd;
    
	LOG_CRE_FLG_ENTER(flgid, pk_cflg);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	CHECK_ATTRIBUTE(pk_cflg->flgatr, TA_TFIFO | TA_TPRI | TA_WSGL | TA_WMUL | TA_CLR);
	flgcb = get_flgcb(flgid);
	CHECK_OBJECT_CREATABLE(flgcb);
	UPDATE_OBJECT_FREELIST(flgcb);

	/*
	 * ݒsB
	 */
	queue_initialize((QUEUE *)flgcb);
	flginib = flgcb->flginib;
	flginib->flgatr = pk_cflg->flgatr;
	flgcb->flgptn = flginib->iflgptn = pk_cflg->iflgptn;

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	flgcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_flg */

/*
 *  CxgtO̐(IDԍt)
 */
#ifdef __acre_flg

SYSCALL ER_ID
acre_flg(const T_CFLG *pk_cflg)
{
	FLGCB	*flgcb;
	FLGINIB	*flginib;
	ER_ID	ercd;
    
	LOG_ACRE_FLG_ENTER(pk_cflg);
	CHECK_TSKCTX_UNL();

	if (TNUM_FLG == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_cflg->flgatr, TA_TFIFO | TA_TPRI | TA_WSGL | TA_WMUL | TA_CLR);
	t_lock_cpu();
	flgcb = (FLGCB *)t_get_free_id((QUEUE *)&flg_freelist);
	if (flgcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	flgcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * ݒsB
	 */
	queue_initialize((QUEUE *)flgcb);
	flginib = flgcb->flginib;
	flginib->flgatr = pk_cflg->flgatr;
	flgcb->flgptn = flginib->iflgptn = pk_cflg->iflgptn;

	ercd = FLGID(flgcb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	flgcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_flg */

/*
 *  CxgtO̍폜
 */
#ifdef __del_flg
SYSCALL ER
del_flg(ID flgid)
{
	FLGCB	*flgcb;
	ER	ercd;
    
	LOG_DEL_FLG_ENTER(flgid);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	CHECK_OBJECT_DELETABLE(flgcb);

	/* ҂šЕtB폜ɔ҂sB*/
	while (queue_empty(&(flgcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(flgcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}
	  
	if (!CHECK_OBJECT_RESERVED(flgcb)) {
	  /*
	   * \IDłȂ΃t[XgɓB
	   */
		t_lock_cpu();
		queue_insert_prev(&flg_freelist, (QUEUE *)flgcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ł̃ANZX\ */
	flgcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_flg */

#ifdef __chk_flg_cond

QUEUE *chk_flg_cond(FLGCB *flgcb, QUEUE *queue, BOOL *disp)
{
	TCB	*tcb;
	WINFO_FLG *winfo;
	QUEUE	*ret;

	tcb = (TCB *)queue;
	ret = queue;
	winfo = (WINFO_FLG *)(tcb->winfo);
	if (eventflag_cond(flgcb, winfo->waiptn,
				winfo->wfmode, &(winfo->flgptn))) {
	  //	  	queue_delete(&(tcb->task_queue));
		ret = queue->prev;
	  	queue_delete(queue);
		if (wait_complete(tcb)) {
			*disp = TRUE;
		} else {
			*disp = FALSE;
		}
	} else {
		*disp = FALSE;
	}

	return ret;
}

#endif /* __chk_flg_cond */
/*
 *  CxgtÕZbg
 */
#ifdef __set_flg

SYSCALL ER
set_flg(ID flgid, FLGPTN setptn)
{
	FLGCB	*flgcb;
	QUEUE	*queue = NULL;
	ER	ercd;

	LOG_SET_FLG_ENTER(flgid, setptn);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	flgcb->flgptn |= setptn;
	if ((flgcb->flginib->flgatr & TA_WMUL) != TA_WMUL ||
	    (flgcb->flginib->flgatr & TA_CLR) == TA_CLR) {
		if (!(queue_empty(&(flgcb->wait_queue)))) {
			BOOL disp;
			queue = flgcb->wait_queue.next;
			chk_flg_cond(flgcb, queue, &disp);
			if (disp) {
				dispatch();
			}
		}
	} else {
		queue = NULL;
		while ((queue = queue_enumerate(&(flgcb->wait_queue), queue)) != NULL) {
			BOOL disp;
			queue = chk_flg_cond(flgcb, queue, &disp);
			if (disp) {
				dispatch();
			}
		}
	}
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_SET_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __set_flg */

/*
 *  CxgtÕZbgi^XNReLXgpj
 */
#ifdef __iset_flg

SYSCALL ER
iset_flg(ID flgid, FLGPTN setptn)
{
	QUEUE	*queue;
	FLGCB	*flgcb;
	ER	ercd;

	LOG_ISET_FLG_ENTER(flgid, setptn);
	CHECK_INTCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	i_lock_cpu();
	I_CHECK_OBJECT_EXIST(flgcb);

	flgcb->flgptn |= setptn;
	if ((flgcb->flginib->flgatr & TA_WMUL) != TA_WMUL ||
	    (flgcb->flginib->flgatr & TA_CLR) == TA_CLR) {
		if (!(queue_empty(&(flgcb->wait_queue)))) {
			BOOL disp;
			queue = flgcb->wait_queue.next;
			chk_flg_cond(flgcb, queue, &disp);
			if (disp) {
				reqflg = TRUE;
			}
		}
	} else {
		queue = NULL;
		while ((queue = queue_enumerate(&(flgcb->wait_queue), queue)) != NULL) {
			BOOL disp;
			queue = chk_flg_cond(flgcb, queue, &disp);
			if (disp) {
				reqflg = TRUE;
			}
		}
	}
	ercd = E_OK;

	i_unlock_cpu();

    exit:
	LOG_ISET_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __iset_flg */

/*
 *  CxgtÕNA
 */
#ifdef __clr_flg

SYSCALL ER
clr_flg(ID flgid, FLGPTN clrptn)
{
	FLGCB	*flgcb;
	ER	ercd;

	LOG_CLR_FLG_ENTER(flgid, clrptn);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	flgcb->flgptn &= clrptn; 
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_CLR_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __clr_flg */

/*
 *  CxgtO҂
 */
#ifdef __wai_flg

SYSCALL ER
wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	FLGCB	*flgcb;
	WINFO_FLG winfo;
	ER	ercd;

	LOG_WAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn);
	CHECK_DISPATCH();
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	if (!(queue_empty(&(flgcb->wait_queue))) &&
	    (flgcb->flginib->flgatr & TA_WMUL) == 0) {
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		ercd = E_OK;
	}
	else {
		winfo.waiptn = waiptn;
		winfo.wfmode = wfmode;
		wobj_make_wait((WOBJCB *) flgcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_flgptn = winfo.flgptn;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_WAI_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __wai_flg */

/*
 *  CxgtO҂i|[Oj
 */
#ifdef __pol_flg

SYSCALL ER
pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	FLGCB	*flgcb;
	ER	ercd;

	LOG_POL_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn);
	CHECK_TSKCTX_UNL();
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	if (!(queue_empty(&(flgcb->wait_queue))) &&
	    (flgcb->flginib->flgatr & TA_WMUL) == 0) {
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_POL_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __pol_flg */

/*
 *  CxgtO҂i^CAEgj
 */
#ifdef __twai_flg

SYSCALL ER
twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout)
{
	FLGCB	*flgcb;
	WINFO_FLG winfo;
	TMEVTB	tmevtb;
	ER	ercd;

	LOG_TWAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn, tmout);
	CHECK_DISPATCH();
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);
	CHECK_TMOUT(tmout);

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	if (!(queue_empty(&(flgcb->wait_queue))) &&
	    (flgcb->flginib->flgatr & TA_WMUL) == 0) {
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else {
		winfo.waiptn = waiptn;
		winfo.wfmode = wfmode;
		wobj_make_wait_tmout((WOBJCB *) flgcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_flgptn = winfo.flgptn;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_TWAI_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __twai_flg */

/*
 *  CxgtȌԎQ
 */
#ifdef __ref_flg
SYSCALL ER
ref_flg(ID flgid, T_RFLG *pk_rflg)
{
	FLGCB	*flgcb;
	ER	ercd;
    
	LOG_REF_FLG_ENTER(flgid);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	if (!queue_empty(&(flgcb->wait_queue))) {
		TCB	*tcb;
		tcb = (TCB *)queue_peek_next(&(flgcb->wait_queue));
		pk_rflg->wtskid = TSKID(tcb);
	} else {
		pk_rflg->wtskid = TSK_NONE;
	}
	pk_rflg->flgptn = flgcb->flgptn;
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_flg */

