/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/interrupt.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	݊Ǘ@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "interrupt.h"

/*
 *  ݃T[rX[`ID̍őlikernel_cfg.cj
 */
extern const ID	tmax_isrid;
extern const ID	tnum_attached_isrno;

/*
 *  ݃T[rX[`ubÑGAikernel_cfg.cj
 */
extern ISRINIB	isrinib_table[];
extern ATTACHED_ISRINIB	attached_isrinib_table[];

/*
 *  ݃T[rX[`ubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_isrinia;

/*
 *  ݃T[rX[`ubNAzyÃGAikernel_cfg.cj
 */
extern const ISRINIA	isrinia_table[];

/*
 *  ݃T[rX[`\ID̃GAikernel_cfg.cj
 */
extern const ID		isrrid_table[];

/*
 *  ݃T[rX[`\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_isrrid;

/*
 *  ݃T[rX[`ǗubÑGAikernel_cfg.cj
 */
extern ISRCB	isrcb_table[];

/*
 *  ݃T[rX[`̐
 */
#define TNUM_ISR	((UINT)(tmax_isrid - TMIN_ISRID + 1))

/*
 *  ݃T[rX[`ID
 *  ݃T[rX[`ǗubNo߂̃}N
 */
#define INDEX_ISR(isrid)	((UINT)((isrid) - TMIN_ISRID))
#define get_isrcb(isrid)	(&(isrcb_table[INDEX_ISR(isrid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE isr_freelist;

/*
 *  ݃nhԍ̐ikernel_cfg.cj
 */
extern const UINT	tnum_inhno;

/*
 *  ݃nhubÑGAikernel_cfg.cj
 */
extern const INHINIB	inhinib_table[];

/* 
 *  ݊Ǘ@\̏
 */
#ifdef __inhini

void
interrupt_initialize()
{
	UINT		i;
	const INHINIB	*inhinib;

	/* ݃nh̒` */
	for (inhinib = inhinib_table, i = 0; i < tnum_inhno; inhinib++, i++) {
		if (check_undefined_inh(inhinib->inhno)) {
			define_inh(inhinib->inhno, inhinib->inthdr);
		} else {
			assert("Duplicated inhno.");
		}
	}

}

#endif /* __inhini */


#ifdef __att_isrini

void
attached_isr_initialize()
{
	UINT		i;

	ATTACHED_ISRINIB	*attached_isrinib;

	/*
	 *  ÓI݃T[rX[`̏B
	 *  ̃T[rXR[ƈقȂAATT_cre_,acre_̑gɂȂĂ邱ƂɒӁB
	 */
	for (attached_isrinib = attached_isrinib_table, i = 0;
	     i < tnum_attached_isrno;
	     attached_isrinib++, i++) {
		if (check_undefined_inh((INHNO)attached_isrinib->intno)) {
			define_inh((INHNO)attached_isrinib->intno, isr_interrupt);
		} else {
			assert("Duplicated intno/inhno.");
		}
	}
}

#endif /* __att_isrini */


#ifdef __isrini

QUEUE isr_freelist;

void
interrupt_service_initialize()
{
	UINT		i;

	ISRCB		*isrcb;
	ISRINIB		*isrinib;
	const ISRINIA	*isrinia;
	const ID	*isrrid;


	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (isrcb = isrcb_table, i = 0; i < TNUM_ISR; isrcb++, i++) {
		queue_initialize(&(isrcb->wait_queue));
		isrcb->isrinib = NULL;
	}
	queue_initialize(&isr_freelist);

	/*
	 * isrinia ɂĎ̂܂
	 */
	for (isrinia = isrinia_table, i = 0; i < tnum_isrinia; isrinia++, i++) {
		isrinib = &isrinib_table[INDEX_ISR(isrinia->isrid)];
		*isrinib = isrinia->isrinib;
		isrcb = &isrcb_table[INDEX_ISR(isrinia->isrid)];
		isrcb->isrinib = isrinib;
		isrcb->exist = KOBJ_EXIST;
		isrcb->reserved = TRUE;
	}
	/*
	 *  \ID̐ݒ
	 */
	for (isrrid = isrrid_table, i = 0; i < tnum_isrrid; isrrid++, i++) {
		isrcb_table[INDEX_ISR(*isrrid)].reserved = TRUE;
	}

	/*
	 * isrinia ɂĎȂ̂
	 */
	for (isrcb = isrcb_table, i = 0; i < TNUM_ISR; isrcb++, i++) {
		if (isrcb->isrinib == NULL) {
			isrcb->exist = KOBJ_NOEXS;
			isrcb->isrinib = &isrinib_table[i];

			if (!CHECK_OBJECT_RESERVED(isrcb)) {
				queue_insert_prev(&isr_freelist, (QUEUE*)isrcb);
			}
		}
	}
}

#endif /* __isrini */

/*
 *  ݃nh̒`
 */
#ifdef __def_inh

SYSCALL ER
def_inh(INHNO inhno, const T_DINH *pk_dinh)
{
	ER ercd;

	LOG_DEF_INH_ENTER(inhno);

	/*
	 *  ݃T[rX[`
	 *  def_inhő삷邱Ƃ͂łȂB
	 */
	if (check_defined_isr((INTNO)inhno)) {
		return E_PAR;
	}

	/*
	 *  inhno ̐`FbN͍sȂB
	 */
	if (pk_dinh == NULL) {
		t_lock_cpu();
		undef_inh(inhno);
	} else {
		CHECK_ATTRIBUTE(pk_dinh->inhatr, TA_HLNG | TA_ASM);
		t_lock_cpu();
		define_inh(inhno, pk_dinh->inthdr);
	}
	t_unlock_cpu();

	ercd = E_OK;
    exit:
	LOG_DEF_INH_LEAVE(ercd);

	return(ercd);
}

#endif /* __def_inh */

/*
 *  ݃T[rX[`̐
 */
#ifdef __cre_isr

SYSCALL ER
cre_isr(ID isrid, const T_CISR *pk_cisr)
{
	ISRCB	*isrcb;
	ISRINIB *isrinib;
	ER	ercd;
    
	LOG_CRE_ISR_ENTER(isrid, pk_cisr);
	CHECK_TSKCTX_UNL();

	/*
	 *  ݃T[rX[`pȊO̊݃nh
	 *  `Ă銄݃xN^Ɋ݃T[rX[`
	 *  o^邱Ƃ͂łȂB
	 */
	if (!check_undefined_inh((INHNO)pk_cisr->intno) &&
	    !check_defined_isr(pk_cisr->intno)) {
		return E_PAR;
	}

	CHECK_ISRID(isrid);
	CHECK_ATTRIBUTE(pk_cisr->isratr, TA_HLNG | TA_ASM);
	isrcb = get_isrcb(isrid);
	CHECK_OBJECT_CREATABLE(isrcb);
	UPDATE_OBJECT_FREELIST(isrcb);

	/*
	 * ݒsB
	 * wait_queue ́A interrupt_initialize()ŏ邵
	 * del_isr̎ɂ|BāAł͏̕KvȂB
	 */
	isrinib = isrcb->isrinib;
	isrinib->isratr = pk_cisr->isratr;
	isrinib->exinf  = pk_cisr->exinf;
	isrinib->intno  = pk_cisr->intno;
	isrinib->isr	= pk_cisr->isr;

	/* TODO: Ȃ鏉v͂B*/

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	isrcb->exist = KOBJ_EXIST;

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_CRE_ISR_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_isr */

/*
 *  ݃T[rX[`̐iIDԍtj
 */
#ifdef __acre_isr

SYSCALL ER
acre_isr(const T_CISR *pk_cisr)
{
	ISRCB	*isrcb;
	ISRINIB	*isrinib;
	ER_ID	ercd;
    
	LOG_ACRE_ISR_ENTER(pk_cisr);
	CHECK_TSKCTX_UNL();

	if (TNUM_ISR == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_cisr->isratr, TA_HLNG | TA_ASM);

	/*
	 *  ݃T[rX[`pȊO̊݃nh
	 *  `Ă銄݃xN^Ɋ݃T[rX[`
	 *  o^邱Ƃ͂łȂB
	 */
	if (!check_undefined_inh((INHNO)pk_cisr->intno) &&
	    !check_defined_isr(pk_cisr->intno)) {
		return E_PAR;
	}

	t_lock_cpu();
	isrcb = (ISRCB *)t_get_free_id((QUEUE *)&isr_freelist);
	if (isrcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	isrcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * ݒsB
	 */
	queue_initialize(&(isrcb->wait_queue));
	isrinib = isrcb->isrinib;
	isrinib->isratr = pk_cisr->isratr;
	isrinib->exinf  = pk_cisr->exinf;
	isrinib->intno  = pk_cisr->intno;
	isrinib->isr	= pk_cisr->isr;

	ercd = ISRID(isrcb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	isrcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_ISR_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_isr */

/*
 *  ݃T[rX[`̍폜
 */
#ifdef __del_isr

SYSCALL ER
del_isr(ID isrid)
{
	ISRCB	*isrcb;
	ER	ercd;
    
	LOG_DEL_ISR_ENTER(isrid);
	CHECK_TSKCTX_UNL();

	CHECK_ISRID(isrid);
	isrcb = get_isrcb(isrid);

	CHECK_OBJECT_DELETABLE(isrcb);

	/* TODO: ЕtB*/
	  
	if (!CHECK_OBJECT_RESERVED(isrcb)) {
		/*
		 * \IDłȂ΃t[XgɓB
		 */
		t_lock_cpu();
		queue_insert_prev(&isr_freelist, (QUEUE *)isrcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ł̃ANZX\ */
	isrcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_ISR_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_isr */

/*
 *  ݃T[rX[`̖{
 */
#ifdef __isr_handler

SYSCALL void
isr_handler(INTNO intno)
{
	UINT		i;
	ISRCB		*isrcb;
	ISRINIB		*isrinib;
	ATTACHED_ISRINIB	*attached_isrinib;

	for (attached_isrinib = attached_isrinib_table, i = 0; i < tnum_attached_isrno; attached_isrinib++, i++) {
		if (attached_isrinib->intno == intno) {
			(void)(attached_isrinib->isr)(attached_isrinib->exinf);
		}
	}
	
	for (isrcb = isrcb_table, i = 0; i < TNUM_ISR; isrcb++, i++) {
		isrinib = isrcb->isrinib;
		if ((isrinib->intno == intno) && (isrcb->exist == KOBJ_EXIST)) {
			(void)(isrinib->isr)(isrinib->exinf);
		}
	}
}

#endif /* __isr_handler */

/*
 *  ݃T[rX[`̏ԎQ
 */
#ifdef __ref_isr

SYSCALL ER
ref_isr(ID isrid, T_RISR *pk_risr)
{
	ISRCB	*isrcb;
	ER	ercd;
    
	LOG_REF_ISR_ENTER(isrid);
	CHECK_TSKCTX_UNL();

	CHECK_ISRID(isrid);
	isrcb = get_isrcb(isrid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(isrcb);

	/*
	 * pk_risr̓e͎`B
	 * {o[Włpk_risr͋Ȃ̂ŁA邱ƂȂB
	 */
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_ISR_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_isr */

/*
 *  ݂̋֎~
 */
#ifdef __dis_int

SYSCALL ER
dis_int(INTNO intno)
{
	return E_NOSPT;
}

#endif /* __dis_int */

/*
 *  ݂̋
 */
#ifdef __ena_int

SYSCALL ER
ena_int(INTNO intno)
{
	return E_NOSPT;
}

#endif /* __ena_int */

