/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/interrupt.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	݊Ǘ@\
 */

#ifndef TOPPERS_INTERRUPT_H
#define TOPPERS_INTERRUPT_H

#include "queue.h"

/*
 *  ݃nhubN
 */
typedef struct interrupt_handler_initialization_block {
	INHNO	inhno;		/* ݃nhԍ */
	ATR	inhatr;		/* ݃nh */
	FP	inthdr;		/* ݃nh̋NԒn */
} INHINIB;

/*
 *  ݃T[rX[`ubN
 */
typedef struct interrupt_service_routine_initialization_block {
	ATR	isratr;		/* ݃T[rX[` */
	VP_INT	exinf;		/* ݃T[rX[`̊g */
	INTNO	intno;		/* ݃T[rX[`t銄ݔԍ */
	FP	isr;		/* ݃T[rX[`̋NԒn */
} ISRINIB;

typedef struct interrupt_service_routine_initialization_block ATTACHED_ISRINIB;

/*
 *  ݃T[rX[`ubNAzyA
 */
typedef struct interrupt_service_rourine_initialization_block_apair {
	ID	isrid;
	ISRINIB	isrinib;
} ISRINIA;

/*
 *  ݃T[rX[`ǗubN
 */
typedef struct interrupt_service_control_block {
	QUEUE	wait_queue;	/* Z}tH҂L[ */
	ISRINIB *isrinib;	/* ݃T[rX[`ubNւ̃|C^ */
	unsigned int	exist:2;	/* gĂƂAKOBJ_EXIST */
	unsigned int	reserved:1;
} ISRCB;

/*
 *  ݊Ǘ@\̏
 */
extern void	interrupt_initialize(void);

/*
 *  ÓI݃T[rX[`(ATT_ISR)̏
 */
extern void	attached_isr_initialize(void);

/*
 *  ݃T[rX[`(cre_,acre_isr)̏
 */
extern void	interrupt_service_initialize(void);

#define ISRID(isrcb)	((ID)((isrcb) - isrcb_table) + TMIN_ISRID)

#endif /* TOPPERS_INTERRUPT_H */
