/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/mailbox.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	[{bNX@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mailbox.h"

/*
 *  [{bNXID̍őlikernel_cfg.cj
 */
extern const ID	tmax_mbxid;

/*
 *  [{bNXubÑGAikernel_cfg.cj
 */
extern MBXINIB	mbxinib_table[];

/*
 *  [{bNXubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_mbxinia;

/*
 *  [{bNXubNAzyÃGAikernel_cfg.cj
 */
extern const MBXINIA	mbxinia_table[];

/*
 *  [{bNX\ID̃GAikernel_cfg.cj
 */
extern const ID		mbxrid_table[];

/*
 *  [{bNX\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_mbxrid;

/*
 *  [{bNXǗubÑGAikernel_cfg.cj
 */
extern MBXCB	mbxcb_table[];

/*
 *  [{bNX̐
 */
#define TNUM_MBX	((UINT)(tmax_mbxid - TMIN_MBXID + 1))

/*
 *  [{bNXID烁[{bNXǗubNo߂̃}N
 */
#define INDEX_MBX(mbxid)	((UINT)((mbxid) - TMIN_MBXID))
#define get_mbxcb(mbxid)	(&(mbxcb_table[INDEX_MBX(mbxid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE mbx_freelist;

/*
 *  [{bNX҂ubN̒`
 */
typedef struct mailbox_waiting_information {
	WINFO	winfo;		/* W̑҂ubN */
	WOBJCB	*wobjcb;	/* ҂IuWFNg̊ǗubN */
	T_MSG	*pk_msg;	/* MbZ[W */
} WINFO_MBX;

/* 
 *  [{bNX@\̏
 */
#ifdef __mbxini

QUEUE mbx_freelist;

void
mailbox_initialize()
{
	UINT	i;
	MBXCB	*mbxcb;
	MBXINIB *mbxinib;
	const MBXINIA	*mbxinia;
	const ID	*mbxrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (mbxcb = mbxcb_table, i = 0; i < TNUM_MBX; mbxcb++, i++) {
		queue_initialize(&(mbxcb->wait_queue));
		mbxcb->mbxinib = NULL;
	}
	queue_initialize(&mbx_freelist);

	/*
	 * mbxinia ɂĎ̂܂
	 */
	for (mbxinia = mbxinia_table, i = 0; i < tnum_mbxinia; mbxinia++, i++) {
		mbxinib = &mbxinib_table[INDEX_MBX(mbxinia->mbxid)];
		*mbxinib = mbxinia->mbxinib;
		mbxcb = &mbxcb_table[INDEX_MBX(mbxinia->mbxid)];
		mbxcb->mbxinib = mbxinib;
		mbxcb->exist = KOBJ_EXIST;
		mbxcb->reserved = TRUE;
		mbxcb->head = NULL;
	}

	/*
	 *  \ID̐ݒ
	 */
	for (mbxrid = mbxrid_table, i = 0; i < tnum_mbxrid; mbxrid++, i++) {
		mbxcb_table[INDEX_MBX(*mbxrid)].reserved = TRUE;
	}

	/*
	 * mbxinia ɂĎȂ̂
	 */
	for (mbxcb = mbxcb_table, i = 0; i < TNUM_MBX; mbxcb++, i++) {
		if (mbxcb->mbxinib == NULL) {
			mbxcb->exist = KOBJ_NOEXS;
			mbxcb->mbxinib = &mbxinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mbxcb)) {
				queue_insert_prev(&mbx_freelist, (QUEUE*)mbxcb);
			}
		}
	}
}

#endif /* __mbxini */

/*
 *  bZ[WDx̎o
 */
#define	MSGPRI(pk_msg)	(((T_MSG_PRI *) pk_msg)->msgpri)

/*
 *  DxbZ[WL[ւ̑}
 */
Inline void
enqueue_msg_pri(T_MSG **p_prevmsg_next, T_MSG *pk_msg)
{
	T_MSG	*pk_nextmsg;

	while ((pk_nextmsg = *p_prevmsg_next) != NULL) {
		if (MSGPRI(pk_nextmsg) > MSGPRI(pk_msg)) {
			break;
		}
		p_prevmsg_next = &(pk_nextmsg->next);
	}
	pk_msg->next = pk_nextmsg;
	*p_prevmsg_next = pk_msg;
}

/*
 *  [{bNX̐
 */
#ifdef __cre_mbx

SYSCALL ER
cre_mbx(ID mbxid, const T_CMBX * pk_cmbx)
{
	MBXCB	*mbxcb;
	MBXINIB *mbxinib;
	ER	ercd;

	LOG_CRE_MBX_ENTER(mbxid, pk_cmbx);
	CHECK_TSKCTX_UNL();

	CHECK_MBXID(mbxid);
	CHECK_ATTRIBUTE(pk_cmbx->mbxatr, TA_TFIFO | TA_TPRI | TA_MFIFO | TA_MPRI);
	if (pk_cmbx->mbxatr & TA_MPRI) {
		CHECK_MPRI(pk_cmbx->maxmpri);
	}

	mbxcb = get_mbxcb(mbxid);
	CHECK_OBJECT_CREATABLE(mbxcb);
	UPDATE_OBJECT_FREELIST(mbxcb);

	/*
	 * ݒsB
	 *
	 *  JSPlAP̃L[ŊǗB
	 *  mprihd͕ێ邾ŎgȂB
	 */
	queue_initialize((QUEUE*)mbxcb);
	mbxinib = mbxcb->mbxinib;
	mbxinib->mbxatr = pk_cmbx->mbxatr;
	mbxinib->maxmpri = pk_cmbx->maxmpri;
	mbxinib->mprihd = pk_cmbx->mprihd;
	mbxcb->head = NULL;

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mbxcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_mbx */

/*
 *  [{bNX̐(IDԍt)
 */
#ifdef __acre_mbx

SYSCALL ER_ID
acre_mbx(const T_CMBX *pk_cmbx)
{
	MBXCB	*mbxcb;
	MBXINIB *mbxinib;
	ER_ID	ercd;

	LOG_ACRE_MBX_ENTER(pk_cmbx);
	CHECK_TSKCTX_UNL();

	if (TNUM_MBX == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_cmbx->mbxatr, TA_TFIFO | TA_TPRI | TA_MFIFO | TA_MPRI);
	if (pk_cmbx->mbxatr & TA_MPRI) {
		CHECK_MPRI(pk_cmbx->maxmpri);
	}

	t_lock_cpu();
	mbxcb = (MBXCB *)t_get_free_id((QUEUE *)&mbx_freelist);
	if (mbxcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	mbxcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * ݒsB
	 *
	 *  JSPlAP̃L[ŊǗB
	 *  mprihd͕ێ邾ŎgȂB
	 */
	queue_initialize((QUEUE*)mbxcb);
	mbxinib = mbxcb->mbxinib;
	mbxinib->mbxatr = pk_cmbx->mbxatr;
	mbxinib->maxmpri = pk_cmbx->maxmpri;
	mbxinib->mprihd = pk_cmbx->mprihd;
	mbxcb->head = NULL;

	ercd = MBXID(mbxcb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mbxcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_mbx */

/*
 *  [{bNX̍폜
 */
#ifdef __del_mbx
SYSCALL ER
del_mbx(ID mbxid)
{
	MBXCB	*mbxcb;
	ER	ercd;

	LOG_DEL_MBX_ENTER(mbxid);
	CHECK_TSKCTX_UNL();

	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	CHECK_OBJECT_DELETABLE(mbxcb);

	/* ҂šЕtB폜ɔ҂sB*/
	while (queue_empty(&(mbxcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mbxcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(mbxcb)) {
	  /*
	   * \IDłȂ΃t[XgɓB
	   */
		t_lock_cpu();
		queue_insert_prev(&mbx_freelist, (QUEUE *)mbxcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ł̃ANZX\ */
	mbxcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mbx */

/*
 *  [{bNXւ̑M
 */
#ifdef __snd_mbx

SYSCALL ER
snd_mbx(ID mbxid, T_MSG *pk_msg)
{
	MBXCB	*mbxcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_SND_MBX_ENTER(mbxid, pk_msg);
	CHECK_TSKCTX_UNL();

	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	CHECK_PAR((mbxcb->mbxinib->mbxatr & TA_MPRI) == 0
		  || (TMIN_MPRI <= MSGPRI(pk_msg)
		      && MSGPRI(pk_msg) <= mbxcb->mbxinib->maxmpri));

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (!(queue_empty(&(mbxcb->wait_queue)))) {
		tcb = (TCB *) queue_delete_next(&(mbxcb->wait_queue));
		((WINFO_MBX *)(tcb->winfo))->pk_msg = pk_msg;
		if (wait_complete(tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if ((mbxcb->mbxinib->mbxatr & TA_MPRI) != 0) {
		enqueue_msg_pri(&(mbxcb->head), pk_msg);
		ercd = E_OK;
	}
	else {
		pk_msg->next = NULL;
		if (mbxcb->head != NULL) {
			mbxcb->last->next = pk_msg;
		}
		else {
			mbxcb->head = pk_msg;
		}
		mbxcb->last = pk_msg;
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_SND_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __snd_mbx */

/*
 *  [{bNX̎M
 */
#ifdef __rcv_mbx

SYSCALL ER
rcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	MBXCB	*mbxcb;
	WINFO_MBX winfo;
	ER	ercd;
    
	LOG_RCV_MBX_ENTER(mbxid, ppk_msg);
	CHECK_DISPATCH();
    
	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		ercd = E_OK;
	}
	else {
		wobj_make_wait((WOBJCB *) mbxcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*ppk_msg = winfo.pk_msg;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_RCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __rcv_mbx */

/*
 *  [{bNX̎Mi|[Oj
 */
#ifdef __prcv_mbx

SYSCALL ER
prcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	MBXCB	*mbxcb;
	ER	ercd;
    
	LOG_PRCV_MBX_ENTER(mbxid, ppk_msg);
	CHECK_TSKCTX_UNL();
    
	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_PRCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __prcv_mbx */

/*
 *  [{bNX̎Mi^CAEgj
 */
#ifdef __trcv_mbx

SYSCALL ER
trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout)
{
	MBXCB	*mbxcb;
	WINFO_MBX winfo;
	TMEVTB	tmevtb;
	ER	ercd;
    
	LOG_TRCV_MBX_ENTER(mbxid, ppk_msg, tmout);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);
    
	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else {
		wobj_make_wait_tmout((WOBJCB *) mbxcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*ppk_msg = winfo.pk_msg;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_TRCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __trcv_mbx */

/*
 *  [{bNX̏ԎQ
 */
#ifdef __ref_mbx
SYSCALL ER
ref_mbx(ID mbxid, T_RMBX *pk_rmbx)
{
	MBXCB	*mbxcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_REF_MBX_ENTER(mbxid);
	CHECK_TSKCTX_UNL();

	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (!queue_empty(&(mbxcb->wait_queue))) {
		tcb = (TCB *)(mbxcb->wait_queue.next);
		pk_rmbx->wtskid = TSKID(tcb);
	} else {
		pk_rmbx->wtskid = TSK_NONE;
	}
	pk_rmbx->pk_msg = mbxcb->head;
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_mbx */

