/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/mempfix.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	Œ蒷v[@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mempfix.h"
#include "bufmgr.h"

/*
 *  Œ蒷v[ID̍őlikernel_cfg.cj
 */
extern const ID	tmax_mpfid;

/*
 *  Œ蒷v[ubÑGAikernel_cfg.cj
 */
extern MPFINIB	mpfinib_table[];

/*
 *  Œ蒷v[ubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_mpfinia;

/*
 *  Œ蒷v[ubNAzyÃGAikernel_cfg.cj
 */
extern const MPFINIA	mpfinia_table[];

/*
 *  Œ蒷v[\ID̃GAikernel_cfg.cj
 */
extern const ID		mpfrid_table[];

/*
 *  Œ蒷v[\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_mpfrid;

/*
 *  Œ蒷v[ǗubÑGAikernel_cfg.cj
 */
extern MPFCB	mpfcb_table[];

/*
 *  Œ蒷v[̐
 */
#define TNUM_MPF	((UINT)(tmax_mpfid - TMIN_MPFID + 1))

/*
 *  Œ蒷v[IDŒ蒷v[ǗubNo
 *  ߂̃}N
 */
#define INDEX_MPF(mpfid)	((UINT)((mpfid) - TMIN_MPFID))
#define get_mpfcb(mpfid)	(&(mpfcb_table[INDEX_MPF(mpfid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE mpf_freelist;

/*
 *  Œ蒷v[҂ubN̒`
 */
typedef struct fixed_memorypool_waiting_information {
	WINFO	winfo;		/* W̑҂ubN */
	WOBJCB	*wobjcb;	/* ҂IuWFNg̊ǗubN */
	VP	blk;		/* lubN */
} WINFO_MPF;

/* 
 *  Œ蒷v[@\̏
 */
#ifdef __mpfini

QUEUE mpf_freelist;

void
mempfix_initialize()
{
	UINT	i;
	MPFCB	*mpfcb;
	MPFINIB *mpfinib;
	const MPFINIA *mpfinia;
	const ID	*mpfrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (mpfcb = mpfcb_table, i = 0; i < TNUM_MPF; mpfcb++, i++) {
		queue_initialize(&(mpfcb->wait_queue));
		mpfcb->mpfinib = NULL;
	}
	queue_initialize(&mpf_freelist);

	/*
	 * mpfinia ɂĎ̂܂
	 */
	for (mpfinia = mpfinia_table, i = 0; i < tnum_mpfinia; mpfinia++, i++) {
		mpfinib = &mpfinib_table[INDEX_MPF(mpfinia->mpfid)];
		*mpfinib = mpfinia->mpfinib;
		mpfcb = &mpfcb_table[INDEX_MPF(mpfinia->mpfid)];
		mpfcb->mpfinib = mpfinib;
		mpfcb->exist = KOBJ_EXIST;
		mpfcb->reserved = TRUE;

		/*
		 *  WcfggƂAmpfNULLɂȂ\B<BTS:21>
		 *  ̂悤cfgł͌؍ڂBWcfgł͂̃R[h
		 *  邱Ƃ͂ȂB
		 */
		if (mpfinib->mpf == NULL) {
			BOOL stat;
			mpfinib->limit = (VP)((SIZE)mpfinib->mpf + mpfinib->blksz);
			bufmgr_allocate(&stat, mpfinib->blksz, &(mpfinib->mpf));
			assert(stat);
		}

		mpfcb->unused = mpfinib->mpf;
		mpfcb->freelist = NULL;
	}

	/*
	 *  \ID̐ݒ
	 */
	for (mpfrid = mpfrid_table, i = 0; i < tnum_mpfrid; mpfrid++, i++) {
		mpfcb_table[INDEX_MPF(*mpfrid)].reserved = TRUE;
	}

	/*
	 * mpfinia ɂĎȂ̂
	 */
	for (mpfcb = mpfcb_table, i = 0; i < TNUM_MPF; mpfcb++, i++) {
		if (mpfcb->mpfinib == NULL) {
			mpfcb->exist = KOBJ_NOEXS;
			mpfcb->mpfinib = &mpfinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mpfcb)) {
				queue_insert_prev(&mpf_freelist, (QUEUE*)mpfcb);
			}
		}
	}
}

#endif /* __mpfini */

/*
 *  Œ蒷v[ubNl
 */
#ifdef __mpfget

BOOL
mempfix_get_block(MPFCB *mpfcb, VP *p_blk)
{
	FREEL	*free;

	if (mpfcb->freelist != NULL) {
		free = mpfcb->freelist;
		mpfcb->freelist = free->next;
		*p_blk = (VP) free;
		return(TRUE);
	}
	else if (mpfcb->unused < mpfcb->mpfinib->limit) {
		*p_blk = mpfcb->unused;
		mpfcb->unused = (VP)((char *)(mpfcb->unused)
						+ mpfcb->mpfinib->blksz);
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __mpfget */

/*
 *  Œ蒷v[̋󂫃ubN𐔂B
 */
#ifdef __mpfcnt

UINT
mempfix_count_free(MPFCB *mpfcb)
{
	FREEL	*free;
	UINT count = 0;
	free = mpfcb->freelist;
	while(free != NULL) {
		free = free->next;
		++count;
	}

	return count;
}

#endif /* __mpfcnt */

/*
 *  Œ蒷v[Rg[ubN̏
 */
#ifdef __mpfcbini

ER
init_mpfcb(MPFCB *mpfcb, T_CMPF *pk_cmpf)
{
	MPFINIB *mpfinib;
	VP mpf;
	UINT blksz;
	UINT blkcnt;

	mpfinib = mpfcb->mpfinib;
	mpf = pk_cmpf->mpf;
	blksz = TROUND_VP(pk_cmpf->blksz);
	blkcnt = pk_cmpf->blkcnt;

	if (mpf == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, blksz * blkcnt, &mpf);
		if (!stat) {
			return E_NOMEM;
		}
	}
	/*
	 * ݒsB
	 */
	queue_initialize((QUEUE *)mpfcb);
	mpfinib = mpfcb->mpfinib;
	mpfinib->mpfatr = pk_cmpf->mpfatr;
	mpfinib->blksz = blksz;
	mpfinib->mpf = mpf;
	mpfinib->limit = (VP)((SIZE)mpf + blksz * blkcnt);

	mpfcb->unused = mpf;
	mpfcb->freelist = NULL;

	return E_OK;
}

#endif /* __mpfcbini */

/*
 *  Œ蒷v[̐
 */
#ifdef __cre_mpf

SYSCALL ER
cre_mpf(ID mpfid, const T_CMPF *pk_cmpf)
{	
	MPFCB	*mpfcb;
	ER	ercd;
    
	LOG_CRE_MPF_ENTER(mpfid, pk_cmpf);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	CHECK_ATTRIBUTE(pk_cmpf->mpfatr, TA_TFIFO | TA_TPRI);
	CHECK_NOT_ZERO(pk_cmpf->blkcnt);
	CHECK_NOT_ZERO(pk_cmpf->blksz);

	mpfcb = get_mpfcb(mpfid);
	CHECK_OBJECT_CREATABLE(mpfcb);
	UPDATE_OBJECT_FREELIST(mpfcb);

	ercd = init_mpfcb(mpfcb, pk_cmpf);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mpfcb->exist = KOBJ_EXIST;

    exit:
	LOG_CRE_MPF_LEAVE(ercd);
	return(ercd);
}

#endif

/*
 *  Œ蒷v[̐(IDԍtj
 */
#ifdef __acre_mpf

SYSCALL ER_ID
acre_mpf(const T_CMPF *pk_cmpf)
{
	static MPFCB	*mpfcb = NULL;
	ER_ID	ercd;

	LOG_ACRE_MPF_ENTER(pk_cmpf);
	CHECK_TSKCTX_UNL();

	if (TNUM_MPF == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_cmpf->mpfatr, TA_TFIFO | TA_TPRI);
	CHECK_NOT_ZERO(pk_cmpf->blkcnt);
	CHECK_NOT_ZERO(pk_cmpf->blksz);

	t_lock_cpu();
	mpfcb = (MPFCB *)t_get_free_id((QUEUE *)&mpf_freelist);
	if (mpfcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	mpfcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	ercd = init_mpfcb(mpfcb, pk_cmpf);
	if (ercd == E_OK) {
		ercd = MPFID(mpfcb);
	}

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mpfcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MPF_LEAVE(ercd);
	return(ercd);
}

#endif

/*
 *  Œ蒷v[̍폜
 */
#ifdef __del_mpf
SYSCALL ER
del_mpf(ID mpfid)
{
	MPFCB	*mpfcb;
	ER	ercd;
	BOOL	stat;

	LOG_DEL_MPF_ENTER(mpfid);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	CHECK_OBJECT_DELETABLE(mpfcb);

	/* ҂šЕtB폜ɔ҂sB*/
	while (queue_empty(&(mpfcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mpfcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}
	  
	/* v[̈B*/
	stat = bufmgr_release(mpfcb->mpfinib->mpf);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_SYS;
	}

	if (!CHECK_OBJECT_RESERVED(mpfcb)) {
	  /*
	   * \IDłȂ΃t[XgɓB
	   */
		t_lock_cpu();
		queue_insert_prev(&mpf_freelist, (QUEUE *)mpfcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ł̃ANZX\ */
	mpfcb->exist = KOBJ_NOEXS;

    exit:
	LOG_DEL_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mpf */

/*
 *  Œ蒷ubN̊l
 */
#ifdef __get_mpf

SYSCALL ER
get_mpf(ID mpfid, VP *p_blk)
{
	MPFCB	*mpfcb;
	WINFO_MPF winfo;
	ER	ercd;

	LOG_GET_MPF_ENTER(mpfid, p_blk);
	CHECK_DISPATCH();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (mempfix_get_block(mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else {
		wobj_make_wait((WOBJCB *) mpfcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo.blk;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_GET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __get_mpf */

/*
 *  Œ蒷ubN̊li|[Oj
 */
#ifdef __pget_mpf

SYSCALL ER
pget_mpf(ID mpfid, VP *p_blk)
{
	MPFCB	*mpfcb;
	ER	ercd;

	LOG_PGET_MPF_ENTER(mpfid, p_blk);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (mempfix_get_block(mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_PGET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __pget_mpf */

/*
 *  Œ蒷ubN̊li^CAEgj
 */
#ifdef __tget_mpf

SYSCALL ER
tget_mpf(ID mpfid, VP *p_blk, TMO tmout)
{
	MPFCB	*mpfcb;
	WINFO_MPF winfo;
	TMEVTB	tmevtb;
	ER	ercd;

	LOG_TGET_MPF_ENTER(mpfid, p_blk, tmout);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (mempfix_get_block(mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else {
		wobj_make_wait_tmout((WOBJCB *) mpfcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo.blk;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_TGET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __tget_mpf */

/*
 *  Œ蒷ubN̕ԋp
 */
#ifdef __rel_mpf

SYSCALL ER
rel_mpf(ID mpfid, VP blk)
{
	MPFCB	*mpfcb;
	TCB	*tcb;
	FREEL	*free;
	ER	ercd;
    
	LOG_REL_MPF_ENTER(mpfid, blk);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	CHECK_PAR(mpfcb->mpfinib->mpf <= blk
			&& blk < mpfcb->mpfinib->limit
			&& ((char *)(blk) - (char *)(mpfcb->mpfinib->mpf))
					% mpfcb->mpfinib->blksz == 0);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (!(queue_empty(&(mpfcb->wait_queue)))) {
		tcb = (TCB *) queue_delete_next(&(mpfcb->wait_queue));
		((WINFO_MPF *)(tcb->winfo))->blk = blk;
		if (wait_complete(tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else {
		free = (FREEL *) blk;
		free->next = mpfcb->freelist;
		mpfcb->freelist = free;
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_REL_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __rel_mpf */


/*
 *  Œ蒷ubN̏ԎQ
 */
#ifdef __ref_mpf

SYSCALL ER
ref_mpf(ID mpfid, T_RMPF *pk_rmpf)
{
	MPFCB	*mpfcb;
	ER	ercd;
    
	LOG_REF_MPF_ENTER(mpfid);
	CHECK_TSKCTX_UNL();

	CHECK_MPFID(mpfid);
	mpfcb = get_mpfcb(mpfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mpfcb);

	if (!(queue_empty(&(mpfcb->wait_queue)))) {
		TCB	*tcb;
		tcb = (TCB *)queue_peek_next(&(mpfcb->wait_queue));
		pk_rmpf->wtskid = TSKID(tcb);
	}
	else {
		pk_rmpf->wtskid = TSK_NONE;
	}
	pk_rmpf->fblkcnt = mempfix_count_free(mpfcb) +
	  ((SIZE)(mpfcb->mpfinib->limit) - (SIZE)(mpfcb->unused)) /
	  mpfcb->mpfinib->blksz;

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_mpf */


