/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Masaki Muranaka
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/mempvar.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	ϒv[@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "kmem.h"
#include "bufmgr.h"
#include "mempvar.h"

/*
 *  ϒv[ID̍őlikernel_cfg.cj
 */
extern const ID	tmax_mplid;

/*
 *  ϒv[ubÑGAikernel_cfg.cj
 */
extern MPLINIB	mplinib_table[];

/*
 *  ϒv[ubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_mplinia;

/*
 *  ϒv[ubNAzyÃGAikernel_cfg.cj
 */
extern const MPLINIA	mplinia_table[];

/*
 *  ϒv[\ID̃GAikernel_cfg.cj
 */
extern const ID		mplrid_table[];

/*
 *  ϒv[\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_mplrid;

/*
 *  ϒv[ǗubÑGAikernel_cfg.cj
 */
extern MPLCB	mplcb_table[];

/*
 *  ϒv[̐
 */
#define TNUM_MPL	((UINT)(tmax_mplid - TMIN_MPLID + 1))

/*
 *  ϒv[IDϒv[ǗubN
 *  o߂̃}N
 */
#define INDEX_MPL(mplid)	((mplid) - TMIN_MPLID)
#define get_mplcb(mplid)	(&(mplcb_table[INDEX_MPL(mplid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE mpl_freelist;

/*
 *  ϒv[҂ubN̒`
 */
typedef struct variable_memorypool_waiting_information {
	WINFO winfo;	/* W̑҂ubN */
	WOBJCB *wobjcb;	/* ҂IuWFNg̃Rg[ubN */
	UINT blksz;
	VP blk;		/* lubN */
} WINFO_MPL;

/* 
 *  ϒv[@\̏
 */
#ifdef __mplini

QUEUE mpl_freelist;

void
mempvar_initialize()
{
	UINT	i;
	MPLCB	*mplcb;
	MPLINIB *mplinib;
	const MPLINIA *mplinia;
	const ID	*mplrid;

	/*
	 *  J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 *  ܂B
	 */
	for (mplcb = mplcb_table, i = 0; i < TNUM_MPL; mplcb++, i++) {
		queue_initialize(&(mplcb->wait_queue));
	}
	queue_initialize(&mpl_freelist);

	/*
	 *  mplinia ɂĎ̂܂
	 */
	for (mplinia = mplinia_table, i = 0; i < tnum_mplinia; mplinia++, i++) {
		BOOL stat;

		mplinib = &mplinib_table[INDEX_MPL(mplinia->mplid)];
		*mplinib = mplinia->mplinib;
		mplcb = &mplcb_table[INDEX_MPL(mplinia->mplid)];
		mplcb->mplinib = mplinib;
		mplcb->exist = KOBJ_EXIST;
		mplcb->reserved = TRUE;

		/*
		 *  WcfggƂAmplNULLɂȂ\B<BTS:21>
		 *  ̂悤cfgł͌؍ڂBWcfgł͂̃R[h
		 *  邱Ƃ͂ȂB
		 */
		if (mplinib->mpl == NULL) {
			bufmgr_allocate(&stat, mplinib->mplsz, &(mplinib->mpl));
			assert(stat);
		}
		stat = kmem_setup(mplinib->mpl, mplinib->mplsz, &(mplcb->free_list));
		assert(stat);
	}

	/*
	 *  \ID̐ݒ
	 */
	for (mplrid = mplrid_table, i = 0; i < tnum_mplrid; mplrid++, i++) {
		mplcb_table[INDEX_MPL(*mplrid)].reserved = TRUE;
	}

	/*
	 * mplinia ɂĎȂ̂
	 */
	for (mplcb = mplcb_table, i = 0; i < TNUM_MPL; mplcb++, i++) {
		if (mplcb->mplinib == NULL) {
			mplcb->exist = KOBJ_NOEXS;
			mplcb->mplinib = &mplinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mplcb)) {
				queue_insert_prev(&mpl_freelist, (QUEUE*)mplcb);
			}
		}
	}
}

#endif /* __mplini */

/*
 *  ݒsB
 */
#ifdef __mplcbini
ER
mplcb_initialize(MPLCB *mplcb, T_CMPL *pk_cmpl)
{
	BOOL stat;
	VP	mpl;
	MPLINIB	*mplinib;

	mpl = pk_cmpl->mpl;

	/*
	 *  mpl == NULL ̎Aobt@}l[W烁lB
	 */
	if (mpl == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, pk_cmpl->mplsz, &mpl);
		if (!stat) {
			return E_NOMEM;
		}
	}

	queue_initialize((QUEUE*)mplcb);
	mplinib = mplcb->mplinib;
	mplinib->mplatr = pk_cmpl->mplatr;
	mplinib->mpl = mpl;
	mplinib->mplsz = pk_cmpl->mplsz;
	stat = kmem_setup(mpl, mplinib->mplsz, &(mplcb->free_list));
	if (stat) {
		return E_OK;
	} else {
		return E_SYS;
	}
}

#endif

/*
 *  ϒv[̐
 */
#ifdef __cre_mpl

SYSCALL ER
cre_mpl(ID mplid, const T_CMPL *pk_cmpl)
{
	MPLCB	*mplcb;
	ER	ercd;
    
	LOG_CRE_MPL_ENTER(mplid, pk_cmpl);
	CHECK_TSKCTX_UNL();

	CHECK_MPLID(mplid);
	CHECK_ATTRIBUTE(pk_cmpl->mplatr, TA_TFIFO | TA_TPRI);
	CHECK_NOT_ZERO(pk_cmpl->mplsz);

	mplcb = get_mplcb(mplid);
	CHECK_OBJECT_CREATABLE(mplcb);
	UPDATE_OBJECT_FREELIST(mplcb);

	ercd = mplcb_initialize(mplcb, pk_cmpl);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mplcb->exist = KOBJ_EXIST;

    exit:
	LOG_CRE_MPL_LEAVE(ercd);
	return(ercd);
}

#endif

/*
 *  ϒv[̐(IDԍtj
 */
#ifdef __acre_mpl

SYSCALL ER_ID
acre_mpl(const T_CMPL *pk_cmpl)
{
	MPLCB	*mplcb;
	ER_ID	ercd;
    
	LOG_ACRE_MPL_ENTER(pk_cmpl);
	CHECK_TSKCTX_UNL();

	if (TNUM_MPL == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_cmpl->mplatr, TA_TFIFO | TA_TPRI);
	CHECK_NOT_ZERO(pk_cmpl->mplsz);

	t_lock_cpu();
	mplcb = (MPLCB *)t_get_free_id((QUEUE *)&mpl_freelist);
	if (mplcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	mplcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	ercd = mplcb_initialize(mplcb, pk_cmpl);
	if (ercd != E_OK) {
		t_lock_cpu();
		queue_insert_prev(&mpl_freelist, (QUEUE *)mplcb);
		t_unlock_cpu();
		goto exit;
	}

	ercd = MPLID(mplcb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mplcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MPL_LEAVE(ercd);
	return(ercd);
}

#endif

/*
 *  ϒv[̍폜
 */
#ifdef __del_mpl
SYSCALL ER
del_mpl(ID mplid)
{
	MPLCB	*mplcb;
	ER	ercd;
	BOOL	stat;

	LOG_DEL_MPL_ENTER(mplid);
	CHECK_TSKCTX_UNL();

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	CHECK_OBJECT_DELETABLE(mplcb);

	/*
	 *  ҂šЕtB폜ɔ҂sB
	 */
	while (queue_empty(&(mplcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mplcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}
	  
	/*
	 *  \IDłȂ΃t[XgɓB
	 */
	if (!CHECK_OBJECT_RESERVED(mplcb)) {
		t_lock_cpu();
		queue_insert_prev(&mpl_freelist, (QUEUE *)mplcb);
		t_unlock_cpu();
	}

	/*
	 *  v[̈B
	 */
	stat = bufmgr_release(mplcb->mplinib->mpl);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_SYS;
	}


	/*
	 *  acre_/cre_ł̃ANZX\
	 */
	mplcb->exist = KOBJ_NOEXS;

    exit:
	LOG_DEL_MPL_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mpl */

/*
 *  ϒubN̊l
 */
#ifdef __get_mpl

SYSCALL ER
get_mpl(ID mplid, UINT blksz, VP *p_blk)
{
	MPLCB	*mplcb;
	WINFO_MPL winfo;
	ER	ercd;

	LOG_GET_MPL_ENTER(mplid, blksz, p_blk);
	CHECK_DISPATCH();

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mplcb);

	if (kmem_allocate(mplcb->free_list, blksz, p_blk)) {
		ercd = E_OK;
	} else {
		winfo.blksz = blksz;
		wobj_make_wait((WOBJCB *) mplcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo.blk;
		}
	}

	t_unlock_cpu();

     exit:
	LOG_GET_MPL_LEAVE(ercd, p_blk);
	return(ercd);
}

#endif /* __get_mpl */

/*
 *  ϒubN̊li|[Oj
 */
#ifdef __pget_mpl

SYSCALL ER
pget_mpl(ID mplid, UINT blksz, VP *p_blk)
{
	MPLCB	*mplcb;
	ER	ercd;

	LOG_PGET_MPL_ENTER(mplid, blksz, p_blk);
	CHECK_TSKCTX_UNL();

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mplcb);

	if (kmem_allocate(mplcb->free_list, blksz, p_blk)) {
		ercd = E_OK;
	} else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_PGET_MPL_LEAVE(ercd, p_blk);
	return(ercd);
}

#endif /* __pget_mpl */

/*
 *  ϒubN̊li^CAEgj
 */
#ifdef __tget_mpl

SYSCALL ER
tget_mpl(ID mplid, UINT blksz, VP *p_blk, TMO tmout)
{
	MPLCB	*mplcb;
	WINFO_MPL winfo;
	TMEVTB	tmevtb;
	ER	ercd;

	LOG_TGET_MPL_ENTER(mplid, blksz, p_blk, tmout);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mplcb);

	if (kmem_allocate(mplcb->free_list, blksz, p_blk)) {
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	} else {
		winfo.blksz = blksz;
		wobj_make_wait_tmout((WOBJCB *) mplcb, (WINFO_WOBJ *) &winfo,
				     &tmevtb, tmout);
		dispatch();
		*p_blk = winfo.blk;
		ercd = winfo.winfo.wercd;
	}
	
	t_unlock_cpu();
    exit:
	LOG_TGET_MPL_LEAVE(ercd, p_blk);
	return(ercd);
}

#endif /* __tget_mpl */

/*
 *  ϒubN̕ԋp
 */
#ifdef __rel_mpl

SYSCALL ER
rel_mpl(ID mplid, VP blk)
{
	MPLCB	*mplcb;
	TCB	*tcb;
	ER	ercd = E_OK;
	BOOL	stat;
	
	LOG_REL_MPL_ENTER(mplid, blk);
	CHECK_TSKCTX_UNL();

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mplcb);

	if ((UB *)(mplcb->free_list) + mplcb->mplinib->mplsz <= (UB *)blk ||
	    (UB *)blk < (UB *)(mplcb->free_list)) {
		ercd = E_PAR;
	} else {
		stat = kmem_release(mplcb->free_list, blk);
		if (stat == FALSE) {
			ercd = E_PAR;
		} else while (!queue_empty(&(mplcb->wait_queue)))  {
			VP new_blk;
			UINT blksz;

			/*
			 *  ҂s̍ŏɂ^XNvĂ
			 *  ϒ̃TCY߂B
			 */
			tcb = (TCB *)(mplcb->wait_queue.next);
			blksz = ((WINFO_MPL *)(tcb->winfo))->blksz;

			if (!kmem_allocate(mplcb->free_list, blksz, &new_blk)) {
				break;
			}

			/*
			 *  擾łA҂dispatch
			 */
			queue_delete_next(&(mplcb->wait_queue));
			((WINFO_MPL *)(tcb->winfo))->blk = new_blk;
			if (wait_complete(tcb)) {
				dispatch();
			}

			/*
			 *  bNĂ^XNǂȂ낤ƂA
			 *  ̌ďoɂ͊֌WȂAE_OKłB
			 */
			ercd = E_OK;
		}
	}

	t_unlock_cpu();
 exit:
	LOG_REL_MPL_LEAVE(ercd);
	return(ercd);
}

#endif /* __tget_mpl */

/*
 *  ϒv[̏Ԏ擾
 */
#ifdef __ref_mpl

SYSCALL ER
ref_mpl(ID mplid, T_RMPL *pk_rmpl)
{
	MPLCB	*mplcb;
	ER	ercd;
	BOOL	stat;

	LOG_REF_MPL_ENTER(mplid);
	CHECK_TSKCTX_UNL();

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mplcb);

	if (!(queue_empty(&(mplcb->wait_queue)))) {
		TCB	*tcb;
		tcb = (TCB *)queue_peek_next(&(mplcb->wait_queue));
		pk_rmpl->wtskid = TSKID(tcb);
	}
	else {
		pk_rmpl->wtskid = TSK_NONE;
	}

	stat = kmem_status(mplcb->free_list, &(pk_rmpl->fmplsz), &(pk_rmpl->fblksz));
	if (stat == FALSE) {
		/*
		 *  free_list Ă
		 */
		ercd = E_SYS;
	} else {
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_REF_MPL_LEAVE(ercd);
	return(ercd);
}

#endif
