/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/messagebuffer.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	bZ[Wobt@@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "messagebuffer.h"
#include "bufmgr.h"

/*
 *  bZ[Wobt@ID̍őlikernel_cfg.cj
 */
extern const ID	tmax_mbfid;

/*
 *  bZ[Wobt@ubÑGAikernel_cfg.cj
 */
extern MBFINIB	mbfinib_table[];

/*
 *  bZ[Wobt@ubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_mbfinia;

/*
 *  bZ[Wobt@ubNAzyÃGAikernel_cfg.cj
 */
extern const MBFINIA	mbfinia_table[];

/*
 *  bZ[Wobt@\ID̃GAikernel_cfg.cj
 */
extern const ID		mbfrid_table[];

/*
 *  bZ[Wobt@\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_mbfrid;

/*
 *  bZ[Wobt@ǗubÑGAikernel_cfg.cj
 */
extern MBFCB	mbfcb_table[];
/*
 *  bZ[Wobt@̐
 */
#define TNUM_MBF	((UINT)(tmax_mbfid - TMIN_MBFID + 1))

/*
 *  bZ[WTCY̏
 */
#define MBF_MAXMSZ_MAX		((UINT)65536)

/*
 *  bZ[Wobt@ID烁bZ[Wobt@ǗubNo߂̃}N
 */
#define INDEX_MBF(mbfid)	((UINT)((mbfid) - TMIN_MBFID))
#define get_mbfcb(mbfid)	(&(mbfcb_table[INDEX_MBF(mbfid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE mbf_freelist;

/*
 *  bZ[Wobt@҂ubN̒`
 *
 *  bZ[Wobt@ւ̑M҂ƃbZ[Wobt@̎M҂ŁC҂
 *  ubNgD
 */
typedef struct dataqueue_waiting_information {
	WINFO	winfo;		/* W̑҂ubN */
	WOBJCB	*wobjcb;	/* ҂IuWFNg̊ǗubN */
	VP	msg;		/* MbZ[W  */
	UINT	msgsz;		/* MbZ[W̃TCY */
} WINFO_MBF;


/*
 *  (M҂)s𑖍A^XN̗Dx
 *  Dx̃^XN܂܂ƂATRUEԂB
 *  TRUÊƂTA_TPRÎƂ́A҂ɓ邱Ƃ
 *  ҂B
 *
 *  {֐CPUbNԂŌĂԂƁB
 */
Inline BOOL
check_queue_priority(QUEUE *wait_queue)
{
	TCB	*tcb;
	QUEUE	*queue = NULL;

	while((queue = queue_enumerate(wait_queue, queue)) != NULL) {
		tcb = (TCB *)queue;
		if (tcb->priority < runtsk->priority) {
			return TRUE;
		}
	}
	return FALSE;
}


/*
 *
 */
#ifdef __mbfrwait

BOOL
send_mbf_rwait(ID mbfid, VP msg, UINT msgsz)
{
	TCB		*tcb;
	MBFCB		*mbfcb;
	WINFO_MBF	*winfo_mbf;

	mbfcb = get_mbfcb(mbfid);
	if (queue_empty(&(mbfcb->rwait_queue))) {
		return FALSE;
	}

	tcb = (TCB *) queue_delete_next(&(mbfcb->rwait_queue));
	winfo_mbf = (WINFO_MBF *)(tcb->winfo);
	memcpy(winfo_mbf->msg, msg, msgsz);
	winfo_mbf->msgsz = msgsz;
	if (wait_complete(tcb)) {
		dispatch();
	}

	return TRUE;
}

#endif /* __mbfrwait */

/*
 *
 */
#ifdef __mbfrbuf

BOOL
read_mbf_buffer(ID mbfid, VP msg, UINT *msgsz)
{
	MBFCB *mbfcb;
	UB *m;
	UB *buf;
	UINT mbfsz;
	UINT head;
	UINT tail;
	UINT i;
	UINT size;

	mbfcb = get_mbfcb(mbfid);
	m = (UB*)msg;
	buf = mbfcb->mbfinib->mbf;
	mbfsz = mbfcb->mbfinib->mbfsz;
	head = mbfcb->head;
	tail = mbfcb->tail;

	if (head == tail) {
		return FALSE;
	}

	size = (buf[tail++ % mbfsz] << 8);
	size |= buf[tail++ % mbfsz];
	tail %= mbfsz;
	for(i = 0; i < size; i++, tail = (tail + 1) % mbfsz) {
		m[i] = buf[tail];
	}
	mbfcb->tail = tail;
	*msgsz = size;

	return TRUE;
}
#endif /* __mbfrbuf */

/*
 *
 */
#ifdef __mbfwbuf

BOOL
write_mbf_buffer(ID mbfid, VP msg, UINT msgsz)
{
	MBFCB *mbfcb;
	UB *m;
	UB *buf;
	UINT mbfsz;
	UINT head;
	UINT tail;
	UINT i;
	UINT limit;

	mbfcb = get_mbfcb(mbfid);
	m = (UB*)msg;
	buf = mbfcb->mbfinib->mbf;
	mbfsz = mbfcb->mbfinib->mbfsz;
	head = mbfcb->head;
	tail = mbfcb->tail;

	if (tail <= head) {
		limit = mbfsz + tail;
	} else {
		limit = tail;
	}

	if (head + 2 + msgsz >= limit) {
		return FALSE;
	}

	buf[head++ % mbfsz] = (msgsz >> 8) & 0xff;
	buf[head++ % mbfsz] = msgsz & 0xff;
	head %= mbfsz;

	for(i = 0; i < msgsz; i++, head = (head + 1) % mbfsz) {
		buf[head] = m[i];
	}
	mbfcb->head = head;

	return TRUE;
}
#endif /* __mbfrbuf */

/* 
 *  bZ[Wobt@@\̏
 */
#ifdef __mbfini

QUEUE mbf_freelist;

void
messagebuffer_initialize()
{
	UINT	i;
	MBFCB	*mbfcb;
	MBFINIB *mbfinib;
	const MBFINIA *mbfinia;
	const ID	*mbfrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (mbfcb = mbfcb_table, i = 0; i < TNUM_MBF; mbfcb++, i++) {
		queue_initialize(&(mbfcb->wait_queue));
		queue_initialize(&(mbfcb->rwait_queue));
		mbfcb->mbfinib = NULL;
	}
	queue_initialize(&mbf_freelist);

	/*
	 * mbfinia ɂĎ̂܂
	 */
	for (mbfinia = mbfinia_table, i = 0; i < tnum_mbfinia; mbfinia++, i++) {
		UINT idx = INDEX_MBF(mbfinia->mbfid);
		mbfinib = &mbfinib_table[idx];
		*mbfinib = mbfinia->mbfinib;
		mbfcb = &mbfcb_table[idx];
		mbfcb->mbfinib = mbfinib;
		mbfcb->exist = KOBJ_EXIST;
		mbfcb->reserved = TRUE;
		mbfcb->head = 0;
		mbfcb->tail = 0;

		/*
		 *  WcfggƂAmbfNULLɂȂ\B<BTS:21>
		 *  ̂悤cfgł͌؍ڂBWcfgł͂̃R[h
		 *  邱Ƃ͂ȂB
		 */
		if (mbfinib->mbf == NULL) {
			BOOL stat;
			bufmgr_allocate(&stat, mbfinib->mbfsz, &(mbfinib->mbf));
			assert(stat);
		}
	}

	/*
	 *  \ID̐ݒ
	 */
	for (mbfrid = mbfrid_table, i = 0; i < tnum_mbfrid; mbfrid++, i++) {
		mbfcb_table[INDEX_MBF(*mbfrid)].reserved = TRUE;
	}

	/*
	 * mbfinia ɂĎȂ̂
	 */
	for (mbfcb = mbfcb_table, i = 0; i < TNUM_MBF; mbfcb++, i++) {
		if (mbfcb->mbfinib == NULL) {
			mbfcb->exist = KOBJ_NOEXS;
			mbfcb->mbfinib = &mbfinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mbfcb)) {
				queue_insert_prev(&mbf_freelist, (QUEUE*)mbfcb);
			}
		}
	}
}

#endif /* __mbfini */

/*
 *  bZ[Wobt@̐
 */
#ifdef __cre_mbf

SYSCALL ER
cre_mbf(ID mbfid, const T_CMBF * pk_cmbf)
{
	MBFCB	*mbfcb;
	MBFINIB *mbfinib;
	ER	ercd;
	VP	mbf;
	LOG_CRE_MBF_ENTER(mbfid, pk_cmbf);
	CHECK_TSKCTX_UNL();

	CHECK_MBFID(mbfid);
	CHECK_ATTRIBUTE(pk_cmbf->mbfatr, TA_TFIFO | TA_TPRI);
	CHECK_NOT_ZERO(pk_cmbf->maxmsz);
	CHECK_PAR(pk_cmbf->maxmsz < MBF_MAXMSZ_MAX);

	mbfcb = get_mbfcb(mbfid);
	CHECK_OBJECT_CREATABLE(mbfcb);
	UPDATE_OBJECT_FREELIST(mbfcb);

	mbf = pk_cmbf->mbf;
	if (mbf == NULL) {
		BOOL stat;
		t_lock_cpu();
		bufmgr_allocate(&stat, pk_cmbf->mbfsz, &mbf);
		t_unlock_cpu();
		if (!stat) {
			ercd = E_NOMEM;
			goto exit;
		}
	}
	
	/*
	 * ݒsB
	 * wait_queue ́A messagebuffer_initialize()ŏ邵
	 * del_mbf̎ɂ|BāAł͏̕KvȂB
	 */
	queue_initialize((QUEUE *)mbfcb);
	queue_initialize(&(mbfcb->rwait_queue));
	mbfinib = mbfcb->mbfinib;
	mbfinib->mbfatr = pk_cmbf->mbfatr;
	mbfinib->maxmsz = pk_cmbf->maxmsz;
	mbfinib->mbfsz  = pk_cmbf->mbfsz;
	mbfinib->mbf = mbf;
	mbfcb->head = 0;
	mbfcb->tail = 0;

	ercd = E_OK;

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mbfcb->exist = KOBJ_EXIST;

    exit:
	LOG_CRE_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_mbf */

/*
 *  bZ[Wobt@̐(IDԍt)
 */
#ifdef __acre_mbf

SYSCALL ER_ID
acre_mbf(const T_CMBF *pk_cmbf)
{
	VP	mbf;
	MBFCB	*mbfcb;
	MBFINIB *mbfinib;
	ER_ID	ercd;
    
	LOG_ACRE_MBF_ENTER(pk_cmbf);

	if (TNUM_MBF == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_cmbf->mbfatr, TA_TFIFO | TA_TPRI);
	CHECK_NOT_ZERO(pk_cmbf->maxmsz);
	CHECK_PAR(pk_cmbf->maxmsz < MBF_MAXMSZ_MAX);

	t_lock_cpu();

	mbfcb = (MBFCB *)t_get_free_id((QUEUE *)&mbf_freelist);
	if (mbfcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}

	mbf = pk_cmbf->mbf;
	if (mbf == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, pk_cmbf->mbfsz, &mbf);
		if (!stat) {
			if (mbfcb) {
				queue_insert_prev(&mbf_freelist, (QUEUE *)mbfcb);		
			}
			t_unlock_cpu();
			ercd = E_NOMEM;
			goto exit;
		}
	}
	
	t_unlock_cpu();
	
	ercd = MBFID(mbfcb);
	mbfcb = get_mbfcb(ercd);

	mbfcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * ݒsB
	 * swait_queue ́A messagebuffer_initialize()ŏ邵
	 * del_mbf̎ɂ|BāAł͏̕KvȂB
	 */
	queue_initialize((QUEUE *)mbfcb);
	queue_initialize(&(mbfcb->rwait_queue));
	mbfinib = mbfcb->mbfinib;
	mbfinib->mbfatr = pk_cmbf->mbfatr;
	mbfinib->maxmsz = pk_cmbf->maxmsz;
	mbfinib->mbfsz  = pk_cmbf->mbfsz;
	mbfinib->mbf = mbf;
	mbfcb->head = 0;
	mbfcb->tail = 0;

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mbfcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_mbf */

/*
 *  bZ[Wobt@̍폜
 */
#ifdef __del_mbf
SYSCALL ER
del_mbf(ID mbfid)
{
	MBFCB	*mbfcb;
	ER	ercd;
   	BOOL	stat;
 
	LOG_DEL_MBF_ENTER(mbfid);
	CHECK_TSKCTX_UNL();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	CHECK_OBJECT_DELETABLE(mbfcb);

	/* M҂šЕtB폜ɔ҂sB*/
	while (queue_empty(&(mbfcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mbfcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	/* M҂šЕtB폜ɔ҂sB*/
	while (queue_empty(&(mbfcb->rwait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mbfcb->rwait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(mbfcb)) {
	  /*
	   * \IDłȂ΃t[XgɓB
	   */
		t_lock_cpu();
		queue_insert_prev(&mbf_freelist, (QUEUE *)mbfcb);
		t_unlock_cpu();
	}

	/*
	 *  bZ[Wobt@̈J[lŊmۂꍇɂ́A
	 *  ̗̈ԋpB
	 */
	stat = bufmgr_release(mbfcb->mbfinib->mbf);

	/* acre_/cre_ł̃ANZX\ */
	mbfcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mbf */

/*
 *  bZ[Wobt@ւ̑M
 */
#ifdef __snd_mbf
SYSCALL ER
snd_mbf(ID mbfid, VP msg, UINT msgsz)
{
	MBFCB	*mbfcb;
	QUEUE	*wait_queue;
	ATR	mbfatr;
	ER	ercd;
	BOOL	stat;

	LOG_SND_MBF_ENTER(mbfid);
	CHECK_DISPATCH();

	CHECK_MBFID(mbfid);
	CHECK_NOT_ZERO(msgsz);

	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);
	if (msgsz > mbfcb->mbfinib->maxmsz) {
		ercd = E_PAR;
		goto escape;
	}

	/*
	 * M҂ȂAɃ^[B
	 * Rs[send_mbf_rwaitœłɏIĂB
	 */
	stat = send_mbf_rwait(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
		goto escape;
	}


	/*
	 *  TA_TPRIŎ̗Dxȏ̗Dx^XNM҂
	 *  Ă邩ATA_TFIFOłłɑM҂^XNȂ΁A
	 *  ҂ցB
	 */
	mbfatr = mbfcb->mbfinib->mbfatr;
	wait_queue = &(mbfcb->wait_queue);
	if ((((mbfatr & TA_TPRI) == TA_TPRI) &&
	     check_queue_priority(wait_queue)) ||
	    (((mbfatr & TA_TFIFO) == TA_TFIFO) &&
	     !queue_empty(wait_queue))) {
		/* make waiting */
		WINFO_MBF winfo;
		winfo.msg = msg;
		winfo.msgsz = msgsz;
		wobj_make_wait((WOBJCB *) mbfcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		goto escape;
	}

	/*
	 *  bZ[Wobt@ւ݂݂̏B
	 *  bZ[Wobt@ɏȂꍇA
	 *  M҂ցB
	 */
	stat = write_mbf_buffer(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
	} else {
		/* make waiting */
		WINFO_MBF winfo;
		winfo.msg = msg;
		winfo.msgsz = msgsz;
		wobj_make_wait((WOBJCB *) mbfcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_SND_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __snd_mbf */

/*
 *  bZ[Wobt@ւ̑Mi|[Oj
 */
#ifdef __psnd_mbf
SYSCALL ER
psnd_mbf(ID mbfid, VP msg, UINT msgsz)
{
	MBFCB	*mbfcb;
	QUEUE	*wait_queue;
	ATR	mbfatr;
	ER	ercd;
	BOOL	stat;

	LOG_SND_MBF_ENTER(mbfid);
	CHECK_TSKCTX_UNL();

	CHECK_MBFID(mbfid);
	CHECK_NOT_ZERO(msgsz);

	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);
	if (msgsz > mbfcb->mbfinib->maxmsz) {
		ercd = E_PAR;
		goto escape;
	}

	/*
	 * M҂ȂAɃ^[B
	 * Rs[send_mbf_rwaitœłɏIĂB
	 */
	stat = send_mbf_rwait(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
		goto escape;
	}

	/*
	 *  TA_TPRIŎ̗Dxȏ̗Dx^XNM҂
	 *  Ă邩ATA_TFIFOłłɑM҂^XNȂ΁A
	 *  ^CAEgG[Ŗ߂B
	 */
	mbfatr = mbfcb->mbfinib->mbfatr;
	wait_queue = &(mbfcb->wait_queue);
	if ((((mbfatr & TA_TPRI) == TA_TPRI) &&
	     check_queue_priority(wait_queue)) ||
	    (((mbfatr & TA_TFIFO) == TA_TFIFO) &&
	     !queue_empty(wait_queue))) {
		ercd = E_TMOUT;
		goto escape;
	}

	/*
	 *  bZ[Wobt@ւ݂݂̏B
	 *  bZ[Wobt@ɏȂꍇA
	 *  ^CAEgG[Ŗ߂B
	 */
	stat = write_mbf_buffer(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_TMOUT;
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_SND_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __psnd_mbf */

/*
 *  bZ[Wobt@ւ̑Mi^CAEgj
 */
#ifdef __tsnd_mbf
SYSCALL ER
tsnd_mbf(ID mbfid, VP msg, UINT msgsz, TMO tmout)
{
	MBFCB	*mbfcb;
	QUEUE	*wait_queue;
	ATR	mbfatr;
	ER	ercd;
	BOOL	stat;

	LOG_SND_MBF_ENTER(mbfid);
	CHECK_DISPATCH();

	CHECK_MBFID(mbfid);
	CHECK_NOT_ZERO(msgsz);
	CHECK_TMOUT(tmout);

	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);
	if (msgsz > mbfcb->mbfinib->maxmsz) {
		ercd = E_PAR;
		goto escape;
	}

	/*
	 * M҂ȂAɃ^[B
	 * Rs[send_mbf_rwaitœłɏIĂB
	 */
	stat = send_mbf_rwait(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
		goto escape;
	}

	/*
	 *  TA_TPRIŎ̗Dxȏ̗Dx^XNM҂
	 *  Ă邩ATA_TFIFOłłɑM҂^XNȂ΁A
	 *  ҂ցB
	 */
	mbfatr = mbfcb->mbfinib->mbfatr;
	wait_queue = &(mbfcb->wait_queue);
	if ((((mbfatr & TA_TPRI) == TA_TPRI) &&
	     check_queue_priority(wait_queue)) ||
	    (((mbfatr & TA_TFIFO) == TA_TFIFO) &&
	     !queue_empty(wait_queue))) {
		/* make waiting */
		WINFO_MBF winfo;
		winfo.msg = msg;
		winfo.msgsz = msgsz;
		wobj_make_wait((WOBJCB *) mbfcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		goto escape;
	}

	/*
	 *  bZ[Wobt@ւ݂݂̏B
	 *  bZ[Wobt@ɏȂꍇA
	 *  M҂ցB
	 */
	stat = write_mbf_buffer(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
	} else {
		if (tmout == TMO_POL) {
			ercd = E_TMOUT;
		} else {
			/* make waiting */
			WINFO_MBF winfo;
			winfo.msg = msg;
			winfo.msgsz = msgsz;
			wobj_make_wait((WOBJCB *) mbfcb, (WINFO_WOBJ *) &winfo);
			dispatch();
			ercd = winfo.winfo.wercd;
		}
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_SND_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __tsnd_mbf */

/*
 *  bZ[Wobt@̎M
 */
#ifdef __rcv_mbf
SYSCALL ER_UINT
rcv_mbf(ID mbfid, VP msg)
{
	MBFCB	*mbfcb;
	TCB	*tcb;
	ER_UINT	ercd;
	UINT	msgsz;
	BOOL	stat;

	LOG_RCV_MBF_ENTER(mbfid);
	CHECK_DISPATCH();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * bZ[Wobt@Ƀf[^ȂAɃ^[B
	 * Rs[read_mbf_bufferœłɏIĂB
	 * f[^Ȃ΁AM҂sB
	 * M҂sȂAM҂ցB
	 * M҂^XNȂARs[đ҂B
	 */
	stat = read_mbf_buffer(mbfid, msg, &msgsz);
	if (stat) {
		ercd = msgsz;
	} else {
		if (queue_empty(&(mbfcb->wait_queue))) {
			/*
			 *  make waiting.
			 */
			WINFO_MBF winfo;
			winfo.msg = msg;
			winfo.msgsz = msgsz;
			runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
			make_wait(&(winfo.winfo));
			queue_insert_prev(&(mbfcb->rwait_queue),
						  &(runtsk->task_queue));
			winfo.wobjcb = (WOBJCB *)mbfcb;
			LOG_TSKSTAT(runtsk);
			dispatch();
			ercd = winfo.winfo.wercd;
			if (ercd == E_OK) {
				ercd = winfo.msgsz;
			}
		} else {
			WINFO_MBF *winfo;
			tcb = (TCB *) queue_delete_next(&(mbfcb->wait_queue));
			winfo = (WINFO_MBF *)(tcb->winfo);
			memcpy(msg, winfo->msg, winfo->msgsz);
			ercd = winfo->msgsz;
			if (wait_complete(tcb)) {
				dispatch();
			}
		}
	}

	/* 
	 * @܂ł̏AM҂^XNȂ΁A
	 * @bZ[Wobt@ւ݂̏ɒBMɂăbZ[Wobt@
	 * @]TłĂ邩Ȃ̂ŁB߂Α҂B
	 *  ͑M҂s񂪋ɂȂ邩AbZ[Wobt@tɂȂ܂
	 * @B
	 */
	if (ercd >= 0) {
		while (!queue_empty(&(mbfcb->wait_queue))) {
			BOOL stat;
			WINFO_MBF *winfo;

			tcb = (TCB *)(mbfcb->wait_queue.next);
			winfo = (WINFO_MBF *)(tcb->winfo);
			stat = write_mbf_buffer(mbfid, winfo->msg, winfo->msgsz);
			if (stat) {
				queue_delete_next(&(mbfcb->wait_queue));
				if (wait_complete(tcb)) {
					dispatch();
				}
			} else {
				break;
			}
		}
	}

	t_unlock_cpu();

    exit:
	LOG_RCV_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __rcv_mbf */

/*
 *  bZ[Wobt@̎Mi|[Oj
 */
#ifdef __prcv_mbf
SYSCALL ER_UINT
prcv_mbf(ID mbfid, VP msg)
{
	MBFCB	*mbfcb;
	TCB	*tcb;
	ER_UINT	ercd;
	UINT	msgsz;
	BOOL	stat;

	LOG_RCV_MBF_ENTER(mbfid);
	CHECK_DISPATCH();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * bZ[Wobt@Ƀf[^ȂAɃ^[B
	 * Rs[read_mbf_bufferœłɏIĂB
	 * f[^Ȃ΁A^CAEgG[B
	 */
	stat = read_mbf_buffer(mbfid, msg, &msgsz);
	if (stat) {
		ercd = msgsz;
	} else {
		ercd = E_TMOUT;
		goto escape;
	}

	/* 
	 * @܂ł̏AM҂^XNȂ΁A
	 * @bZ[Wobt@ւ݂̏ɒBMɂăbZ[Wobt@
	 * @]TłĂ邩Ȃ̂ŁB߂Α҂B
	 *  ͑M҂s񂪋ɂȂ邩AbZ[Wobt@tɂȂ܂
	 * @B
	 */
	if (ercd >= E_OK) {
		while (!queue_empty(&(mbfcb->wait_queue))) {
			BOOL stat;
			WINFO_MBF *winfo;

			tcb = (TCB *)(mbfcb->wait_queue.next);
			winfo = (WINFO_MBF *)(tcb->winfo);
			stat = write_mbf_buffer(mbfid, winfo->msg, winfo->msgsz);
			if (stat) {
				queue_delete_next(&(mbfcb->wait_queue));
				if (wait_complete(tcb)) {
					dispatch();
				}
			} else {
				break;
			}
		}
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_RCV_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __prcv_mbf */

/*
 *  bZ[Wobt@̎Mi^CAEgj
 */
#ifdef __trcv_mbf
SYSCALL ER_UINT
trcv_mbf(ID mbfid, VP msg, TMO tmout)
{
	MBFCB	*mbfcb;
	TCB	*tcb;
	TMEVTB	tmevtb;
	ER_UINT	ercd;
	UINT	msgsz;
	BOOL	stat;

	LOG_RCV_MBF_ENTER(mbfid);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * bZ[Wobt@Ƀf[^ȂAɃ^[B
	 * Rs[read_mbf_bufferœłɏIĂB
	 * f[^Ȃ΁AM҂sB
	 * M҂sȂAM҂ցB
	 * M҂^XNȂARs[đ҂B
	 */
	stat = read_mbf_buffer(mbfid, msg, &msgsz);
	if (stat) {
		ercd = msgsz;
	} else {
		if (queue_empty(&(mbfcb->wait_queue))) {
			if (tmout == TMO_POL) {
				ercd = E_TMOUT;
			} else {
				WINFO_MBF winfo;
				winfo.msg = msg;
				winfo.msgsz = msgsz;
				runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
				make_wait_tmout(&(winfo.winfo), &tmevtb, tmout);
				queue_insert_prev(&(mbfcb->rwait_queue),
						  &(runtsk->task_queue));
				winfo.wobjcb = (WOBJCB *)mbfcb;
				LOG_TSKSTAT(runtsk);
				dispatch();
				ercd = winfo.winfo.wercd;
				if (ercd == E_OK) {
					ercd = winfo.msgsz;
				}
			}
		} else {
			WINFO_MBF *winfo;
			tcb = (TCB *) queue_delete_next(&(mbfcb->wait_queue));
			winfo = (WINFO_MBF *)(tcb->winfo);
			memcpy(msg, winfo->msg, winfo->msgsz);
			ercd = winfo->msgsz;
			if (wait_complete(tcb)) {
				dispatch();
			}
		}
	}

	/* 
	 * @܂ł̏AM҂^XNȂ΁A
	 * @bZ[Wobt@ւ݂̏ɒBMɂăbZ[Wobt@
	 * @]TłĂ邩Ȃ̂ŁB߂Α҂B
	 *  ͑M҂s񂪋ɂȂ邩AbZ[Wobt@tɂȂ܂
	 * @B
	 */
	if (ercd > E_OK) {
		while (!queue_empty(&(mbfcb->wait_queue))) {
			BOOL stat;
			WINFO_MBF *winfo;

			tcb = (TCB *)(mbfcb->wait_queue.next);
			winfo = (WINFO_MBF *)(tcb->winfo);
			stat = write_mbf_buffer(mbfid, winfo->msg, winfo->msgsz);
			if (stat) {
				queue_delete_next(&(mbfcb->wait_queue));
				if (wait_complete(tcb)) {
					dispatch();
				}
			} else {
				break;
			}
		}
	}

	t_unlock_cpu();

    exit:
	LOG_RCV_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __trcv_mbf */

/*
 *  bZ[Wobt@̏ԎQ
 */
#ifdef __ref_mbf
SYSCALL ER
ref_mbf(ID mbfid, T_RMBF *pk_rmbf)
{
	TCB *tcb;
	MBFCB	*mbfcb;
	ER	ercd;
	UINT	head;
	UINT	tail;
	UB	*mbf;
	UINT	mbfsz;
	UINT	i;
	UINT	free;

	LOG_REF_MBF_ENTER(mbfid);
	CHECK_TSKCTX_UNL();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	if (!queue_empty(&(mbfcb->wait_queue))) {
		tcb = (TCB *)queue_peek_next(&(mbfcb->wait_queue));
		pk_rmbf->stskid = TSKID(tcb);
	} else {
		pk_rmbf->stskid = TSK_NONE;
	}
	if (!queue_empty(&(mbfcb->rwait_queue))) {
		tcb = (TCB *)queue_peek_next(&(mbfcb->rwait_queue));
		pk_rmbf->rtskid = TSKID(tcb);
	} else {
		pk_rmbf->rtskid = TSK_NONE;
	}

	mbf = mbfcb->mbfinib->mbf;
	mbfsz = mbfcb->mbfinib->mbfsz;
	free = mbfsz;
	head = mbfcb->head;
	tail = mbfcb->tail;

	pk_rmbf->smsgcnt = 0;
	for (i = tail; i != head; pk_rmbf->smsgcnt++) {
		UINT size;
		size = mbf[i] << 8;
		size |= mbf[i + 1];
		i = (i + size + 2) % mbfsz; /* +2 ̓wb_̕ */
		free -= size + 2;
	}

	if (free < 2) {
		free = 0;
	} else {
		free -= 2;
	}
	pk_rmbf->fmbfsz = free;

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_mbf */


