/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/messagebuffer.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	bZ[Wobt@@\
 */

#ifndef TOPPERS_MESSAGEBUFFER_H
#define TOPPERS_MESSAGEBUFFER_H

#include "queue.h"
#include "kmem.h"

/*
 *  bZ[Wobt@ubN
 */
typedef struct messagebuffer_initialization_block {
	ATR mbfatr;
	UINT maxmsz;
	UINT mbfsz;
	VP mbf;
} MBFINIB;

/*
 *  bZ[Wobt@ubNAzyA
 */
typedef struct messagebuffer_initialization_block_apair {
	ID	mbfid;
	MBFINIB	mbfinib;
} MBFINIA;

#define MBF_SWAIT_QUEUE_NUM	(TMAX_TPRI - TMIN_TPRI + 1)

/*
 *  bZ[Wobt@ǗubN
 */
typedef struct messagebuffer_control_block {
	QUEUE	wait_queue;				/* Mp҂L[ */
	MBFINIB	*mbfinib;
	QUEUE	rwait_queue;				/* Mp҂L[ */
	UINT	head;
	UINT	tail;
	unsigned int	exist:2;				/* gĂƂAKOBJ_EXIST */
	unsigned int	reserved:1;
} MBFCB;

/*
 *  bZ[Wobt@@\̏
 */
extern void	messagebuffer_initialize(void);

extern BOOL send_mbf_rwait(ID mbfid, VP msg, UINT msgsz);
extern BOOL recv_mbuffer_swait(ID mbfid, VP msg, UINT *msgsz);

#define MBFID(mbfcb)	((ID)((mbfcb) - mbfcb_table) + TMIN_MBFID)

#endif /* TOPPERS_MESSAGEBUFFER_H */
