/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2006 by Muranaka Masaki
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/multiqueue.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	L[색Cu
 *
 *  ̃L[색Cuł́CL[wb_܂ރO\̃_u
 *  NL[D̓Iɂ́CL[wb_̎Gg̓L[
 *  擪̃GgCOGg̓L[̖̃GgƂD܂CL
 *  [̐擪̃Gg̑OGgƁCL[̖̃Gg̎G
 *  ǵCL[wb_ƂD̃L[́CGgCOGg
 *  gwL[wb_ł킷D
 */

#ifndef TOPPERS_MULTIQUEUE_H
#define TOPPERS_MULTIQUEUE_H

#include "queue.h"


/*
 * TODO:comment
 */
typedef struct {
	ATR	multiobjatr;	/* TODO: comment */
} MULTIOBJINIB;

/*
 * TODO:comment
 */
typedef struct {
	QUEUE			wait_queue;
	const MULTIOBJINIB	*multiobjinib;
	QUEUE			multi_queue[1];
} MULTIOBJCB;

/*
 *  L[̏
 *
 *  wobjcb ɂ̓L[wb_w肷D
 */
Inline void
multiqueue_initialize(MULTIOBJCB *wobjcb, UINT pos)
{
	QUEUE *queue;

	queue = &(wobjcb->multi_queue[pos]);
	queue->prev = queue->next = (QUEUE *)wobjcb;
}

/*
 *  L[̑OGgւ̑}
 *
 *  wobjcb ̑O entry }Dmultiqueue ɃL[wb_w肵ꍇ
 *  ɂ́CL[̖ entry }邱ƂɂȂD
 */
Inline void
multiqueue_insert_prev(MULTIOBJCB *head, MULTIOBJCB *entry, UINT pos)
{
	QUEUE *head_queue;
	QUEUE *entry_queue;
	head_queue = &(head->multi_queue[pos]);
	entry_queue = &(entry->multi_queue[pos]);

	entry_queue->prev = head_queue->prev;
	entry_queue->next = (QUEUE *)head;
	(&((MULTIOBJCB *)(head_queue->prev))->multi_queue[pos])->next = (QUEUE *)entry;
	head_queue->prev = (QUEUE *)entry;
}

/*
 *  Gg̍폜
 *
 *  entry L[폜D
 */
Inline void
multiqueue_delete(MULTIOBJCB *entry, UINT pos)
{
	QUEUE *entry_queue;
	entry_queue = &(entry->multi_queue[pos]);
	((MULTIOBJCB *)(entry_queue->prev))->multi_queue[pos].next = entry_queue->next;
	((MULTIOBJCB *)(entry_queue->next))->multi_queue[pos].prev = entry_queue->prev;
}

/*
 *  L[̗
 *
 *  topL[ƂGg擪񋓂B
 *  ŏ̌ďoł́AentryNULLnBԒltop̎̃Gg(܂擪)łB
 *  ȍ~͑OɓGgentryɓnBԒlentry̎̃GgƂȂB
 *  entry̎̃GgtopƂANULLԒlƂāAL[̏I[킷B
 *  topNULL`FbNentry̑Ó؂͍sĂȂBďo̐ӔCōsƁB
 *  ܂A܂łȂAXbhZ[tɂ͂Ȃ肦ȂB񋓃[v͔r
 *  ďo̐ӔCōsƁB
 */
Inline MULTIOBJCB *
multiqueue_enumerate(MULTIOBJCB *top, MULTIOBJCB *entry, UINT pos)
{
	QUEUE	*result;

	if (entry == NULL) {
		result = top->multi_queue[pos].next;
	} else {
		result = entry->multi_queue[pos].next;
	}
	if (result == (QUEUE *)top) {
		return NULL;
	}
	return (MULTIOBJCB *)result;
}

/*
 *  L[̎Gg̎o
 *
 *  multiqueue ̎GgL[폜C폜GgԂDmultiqueue
 *  ɃL[wb_w肵ꍇɂ́CL[̐擪̃Ggo
 *  ƂɂȂDmultiqueue ɋ̃L[w肵ČĂяoĂ͂ȂȂD
 */
Inline MULTIOBJCB *
multiqueue_delete_next(MULTIOBJCB *objcb, UINT pos)
{
	MULTIOBJCB	*entry;
	MULTIOBJCB	*cb;

	assert(objcb->multi_queue[pos].next != (QUEUE *)objcb);
	entry = (MULTIOBJCB *)(objcb->multi_queue[pos].next);
	objcb->multi_queue[pos].next = entry->multi_queue[pos].next;
	cb = (MULTIOBJCB *)((MULTIOBJCB *)entry)->multi_queue[pos].next;
	cb->multi_queue[pos].prev = (QUEUE *)objcb;

	return (MULTIOBJCB *)entry;
}

/*
 *  L[󂩂ǂ̃`FbN
 *
 *  multiqueue ɂ̓L[wb_w肷D
 */
Inline BOOL
multiqueue_empty(MULTIOBJCB *objcb, UINT pos)
{
	if (objcb->multi_queue[pos].next == (QUEUE *)objcb) {
		assert(objcb->multi_queue[pos].prev == (QUEUE *)objcb);
		return(TRUE);
	}
	return(FALSE);
}

#endif /* TOPPERS_MULTIQUEUE_H */
