/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  Copyright (C) 2002 by Masao Higuchi
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 *
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/mutex.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	~[ebNX@\
 *	(ȗDxK)
 *
 *  The original code was written by Masao Higuchi.
 *  Extended for uITRON4.0 fullset was written by Masaki Muranaka.
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mutex.h"
#include "multiqueue.h"

/*
 *  ~[ebNXID̍őlikernel_cfg.cj
 */
extern const ID	tmax_mtxid;

/*
 *  ~[ebNXubÑGAikernel_cfg.cj
 */
extern MTXINIB	mtxinib_table[];

/*
 *  ~[ebNXubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_mtxinia;

/*
 *  ~[ebNXubNAzyÃGAikernel_cfg.cj
 */
extern const MTXINIA	mtxinia_table[];

/*
 *  ~[ebNX\ID̃GAikernel_cfg.cj
 */
extern const ID		mtxrid_table[];

/*
 *  ~[ebNX\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_mtxrid;

/*
 *  ~[ebNXǗubÑGAikernel_cfg.cj
 */
extern MTXCB	mtxcb_table[];

/*
 *  ~[ebNX̐
 */
#define TNUM_MTX	((UINT)(tmax_mtxid - TMIN_MTXID + 1))

/*
 *  ~[ebNXID~[ebNXǗubNo߂̃}N
 */
#define INDEX_MTX(mtxid)	((UINT)((mtxid) - TMIN_MTXID))
#define get_mtxcb(mtxid)	(&(mtxcb_table[INDEX_MTX(mtxid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE mtx_freelist;

/* 
 *  ~[ebNX@\̏
 */
#ifdef __mtxini

QUEUE mtx_freelist;

void
mutex_initialize()
{
	UINT	i;
	MTXCB	*mtxcb;
	MTXINIB *mtxinib;
	const MTXINIA *mtxinia;
	const ID	*mtxrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (mtxcb = mtxcb_table, i = 0; i < TNUM_MTX; mtxcb++, i++) {
		queue_initialize(&(mtxcb->wait_queue));
		queue_initialize(&(mtxcb->mtxlist));
		mtxcb->mtxinib = NULL;
	}
	queue_initialize(&mtx_freelist);

	/*
	 * mtxinia ɂĎ̂܂
	 */
	for (mtxinia = mtxinia_table, i = 0; i < tnum_mtxinia; mtxinia++, i++) {
		UINT idx;
		idx = INDEX_MTX(mtxinia->mtxid);
		mtxinib = &mtxinib_table[idx];
		*mtxinib = mtxinia->mtxinib;
		mtxcb = &mtxcb_table[idx];
		mtxcb->mtxinib = mtxinib;
		mtxcb->mtxtsk = NULL;
		mtxcb->exist = KOBJ_EXIST;
		mtxcb->reserved = TRUE;
	}

	/*
	 *  \ID̐ݒ
	 */
	for (mtxrid = mtxrid_table, i = 0; i < tnum_mtxrid; mtxrid++, i++) {
		mtxcb_table[INDEX_MTX(*mtxrid)].reserved = TRUE;
	}

	/*
	 * mtxinia ɂĎȂ̂
	 */
	for (mtxcb = mtxcb_table, i = 0; i < TNUM_MTX; mtxcb++, i++) {
		if (mtxcb->mtxinib == NULL) {
			mtxcb->exist = KOBJ_NOEXS;
			mtxcb->mtxinib = &mtxinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mtxcb)) {
				queue_insert_prev(&mtx_freelist, (QUEUE*)mtxcb);
			}
		}
	}
}

#endif /* __mtxini */

/*
 *  ~[ebNX̐
 */
#ifdef __cre_mtx

SYSCALL ER
cre_mtx(ID mtxid, const T_CMTX * pk_cmtx)
{
	MTXCB	*mtxcb;
	MTXINIB *mtxinib;
	ER	ercd;
    
	LOG_CRE_MTX_ENTER(mtxid, pk_cmtx);
	CHECK_TSKCTX_UNL();

	CHECK_MTXID(mtxid);
	CHECK_ATTRIBUTE(pk_cmtx->mtxatr, TA_TFIFO | TA_TPRI | TA_INHERIT | TA_CEILING);
	if ((pk_cmtx->mtxatr & TA_CEILING) == TA_CEILING) {
		if (pk_cmtx->ceilpri < TMIN_TPRI ||
		    pk_cmtx->ceilpri > TMAX_TPRI) {
			return E_PAR;
		}
	}
	    
	mtxcb = get_mtxcb(mtxid);
	CHECK_OBJECT_CREATABLE(mtxcb);
	UPDATE_OBJECT_FREELIST(mtxcb);

	/*
	 * ݒsB
	 */
	queue_initialize(&mtxcb->wait_queue);
	queue_initialize(&mtxcb->mtxlist);
	mtxcb->mtxtsk = NULL;

	mtxinib = mtxcb->mtxinib;
	mtxinib->mtxatr = pk_cmtx->mtxatr;
	mtxinib->ceilpri = pk_cmtx->ceilpri;

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mtxcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_mtx */

/*
 *  ~[ebNX̐(IDԍt)
 */
#ifdef __acre_mtx

SYSCALL ER_ID
acre_mtx(const T_CMTX *pk_cmtx)
{
	MTXCB	*mtxcb;
	MTXINIB *mtxinib;
	ER_ID	ercd;
    
	LOG_ACRE_MTX_ENTER(pk_cmtx);

	if (TNUM_MTX == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_cmtx->mtxatr, TA_TFIFO | TA_TPRI | TA_INHERIT | TA_CEILING);
	if ((pk_cmtx->mtxatr & TA_CEILING) == TA_CEILING) {
		if (pk_cmtx->ceilpri < TMIN_TPRI ||
		    pk_cmtx->ceilpri > TMAX_TPRI) {
			return E_PAR;
		}
	}

	t_lock_cpu();
	mtxcb = (MTXCB *)t_get_free_id((QUEUE *)&mtx_freelist);
	if (mtxcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	mtxcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * ݒsB
	 */
	queue_initialize(&mtxcb->wait_queue);
	queue_initialize(&mtxcb->mtxlist);
	mtxcb->mtxtsk = NULL;

	mtxinib = mtxcb->mtxinib;
	mtxinib->mtxatr = pk_cmtx->mtxatr;
	mtxinib->ceilpri = pk_cmtx->ceilpri;

	ercd = MTXID(mtxcb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	mtxcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_mtx */

/*
 *  ~[ebNX̍폜
 */
#ifdef __del_mtx
SYSCALL ER
del_mtx(ID mtxid)
{
	MTXCB	*mtxcb;
	ER	ercd;
	BOOL	dispflg = FALSE;

	LOG_DEL_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	CHECK_OBJECT_DELETABLE(mtxcb);

	t_lock_cpu();
	if (mtxcb->mtxtsk != NULL) {
		/* 
		 *  ~[ebNXbNĂꍇB
		 *  ȗDxK̗pĂ̂ŁA
		 *  ɌݗDx̕ύX`FbNB
		 */
		
		TCB *mtxtsk;
		PRI pri;

		/*
		 *  J~[ebNX
		 *  bNXg폜
		 */
		multiqueue_delete((MULTIOBJCB *)mtxcb, 0);

		mtxtsk = mtxcb->mtxtsk;
		if (mtxcb->mtxinib->mtxatr == TA_INHERIT)  {
			/*ݗDx̕ύX(ȗDxKɏ])*/
			if (multiqueue_empty((MULTIOBJCB *)mtxtsk, 0)) {
				/*
				 *  bNĂ~[ebNX
				 *  ȂƂɂ̓x[XDxɖ߂
				 */
				dispflg = set_current_priority(mtxtsk,mtxtsk->base_priority);
			}else if (!queue_empty(&(mtxcb->wait_queue))) {
				if (mtxtsk->priority == ((TCB *)(mtxcb->wait_queue.next))->priority ) {
				/*
				 *  ݗDx擪̑҂^XŇݗDx
				 * vĂƂ̓T[`ĕύX
				 */
					pri = search_mtx_priority(mtxtsk);
					if (pri != mtxtsk->priority){
						dispflg |= set_current_priority(mtxtsk, pri);
					}
				}
			}
		} else if ( mtxcb->mtxinib->mtxatr == TA_CEILING) {
			/*ݗDx̕ύX(ȗDxKɏ])*/
			if (multiqueue_empty((MULTIOBJCB *)mtxtsk, 0)) {
				/*
				 *  bNĂ~[ebNX
				 *  ȂƂɂ̓x[XDxɖ߂
				 */
				dispflg = set_current_priority(mtxtsk, mtxtsk->base_priority);
			} else if (mtxtsk->priority != mtxtsk->base_priority &&
				   mtxtsk->priority == INT_PRIORITY(mtxcb->mtxinib->ceilpri)) {
				/*
				 *  ݗDxDxƈv
				 *  Ƃ̓T[`ĕύX
				 */
				pri = search_mtx_priority(mtxtsk);
				if (pri != mtxtsk->priority) {
					dispflg |= set_current_priority(mtxtsk, pri);
				}
			}
		}
	}
	if (dispflg) {
		dispatch();
	}

	/* ҂šЕtB폜ɔ҂sB*/
	while (queue_empty(&(mtxcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mtxcb->wait_queue));
		if (wait_deleted(tcb)) {
			dispatch();
		}
	}

	t_unlock_cpu();

	if (!CHECK_OBJECT_RESERVED(mtxcb)) {
	  /*
	   * \IDłȂ΃t[XgɓB
	   */
		t_lock_cpu();
		queue_insert_prev(&mtx_freelist, (QUEUE *)mtxcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ł̃ANZX\ */
	mtxcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mtx */

/*
 *  ~[ebNX̃bN
 */
#ifdef __loc_mtx
SYSCALL ER
loc_mtx(ID mtxid)
{
	MTXCB	*mtxcb;
	WINFO_WOBJ winfo;
	ER	ercd;
    
	LOG_LOC_MTX_ENTER(mtxid);
	CHECK_DISPATCH();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (runtsk == mtxcb->mtxtsk){
		/*
		 *  dbN
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if ( ( mtxcb->mtxinib->mtxatr == TA_CEILING ) 
	     && (runtsk->base_priority < INT_PRIORITY(mtxcb->mtxinib->ceilpri)) ) {
		/*
		 *  ^XÑx[XDxΏۃ~[ebNX̏Dx
		 *  ꍇɂE_ILUSEԂB(ITRON4.0dl)
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if (mtxcb->mtxtsk == NULL){
		/*
		 *  󂢂ĂĊlłꍇ
		 */
		mtxcb->mtxtsk = runtsk;
		multiqueue_insert_prev((MULTIOBJCB *)runtsk, (MULTIOBJCB *)mtxcb, 0);
		if ((mtxcb->mtxinib->mtxatr == TA_CEILING) &&
		    (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < runtsk->priority)) {
			/*
			 *  TA_CEILING̃~[ebNX^XNbNꍇŁA
			 *  Ώۃ~[ebNX̏Dx^XŇݗDx
			 *  ꍇɂ́A^XŇݗDxA~[ebNX̏DxɕύXB
			 * (ITRON4.0dl)
			 */
			change_priority(runtsk, INT_PRIORITY(mtxcb->mtxinib->ceilpri));
		}
		ercd = E_OK;
	} else {
		/*
		 *  ҂ꍇ
		 */
		UINT pri;
		pri = runtsk->priority;
		if (mtxcb->mtxinib->mtxatr == TA_INHERIT) {
			if (mtxcb->mtxtsk->priority > pri) { 
				/*
				 *  (TA_INHERIT̏ꍇ && ^XNbN҂Ɉڍsꍇ)
				 *  ^XŇݗDx(A)Ώۃ~[ebNXbNĂ^XN
				 *  ݗDxꍇɂ́A~[ebNXbNĂ^XN
				 *  ݗDxA(A)ɕύXB(ITRON4.0dlv)
				 */
				set_current_priority(mtxcb->mtxtsk, pri);
			}
			wobj_make_wait_mutexi((WOBJCB *) mtxcb, &winfo);
		} else {
			wobj_make_wait((WOBJCB *) mtxcb, &winfo);
		}
		/*
		 *  ҂ɓ^XN̂ŁA
		 *  KfBXpb`Kv
		 */
		dispatch();
		ercd = winfo.winfo.wercd;
	}

    error:
	t_unlock_cpu();

    exit:
	LOG_LOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __loc_mtx */

/*
 *  ~[ebNX̃bNi|[Oj
 */
#ifdef __ploc_mtx
SYSCALL ER
ploc_mtx(ID mtxid)
{
	MTXCB	*mtxcb;
	ER	ercd;
    
	LOG_LOC_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (runtsk == mtxcb->mtxtsk){
		/*
		 *  dbN
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if ( ( mtxcb->mtxinib->mtxatr == TA_CEILING ) 
	     && (runtsk->base_priority < INT_PRIORITY(mtxcb->mtxinib->ceilpri)) ) {
		/*
		 *  ^XÑx[XDxΏۃ~[ebNX̏Dx
		 *  ꍇɂE_ILUSEԂB(ITRON4.0dl)
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if (mtxcb->mtxtsk == NULL){
		/*
		 *  󂢂ĂĊlłꍇ
		 */
		mtxcb->mtxtsk = runtsk;
		multiqueue_insert_prev((MULTIOBJCB *)runtsk, (MULTIOBJCB *)mtxcb, 0);
		if ((mtxcb->mtxinib->mtxatr == TA_CEILING) &&
		    (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < runtsk->priority)) {
			/*
			 *  TA_CEILING̃~[ebNX^XNbNꍇŁA
			 *  Ώۃ~[ebNX̏Dx^XŇݗDx
			 *  ꍇɂ́A^XŇݗDxA~[ebNX̏DxɕύXB
			 * (ITRON4.0dl)
			 */
			change_priority(runtsk, INT_PRIORITY(mtxcb->mtxinib->ceilpri));
		}
		ercd = E_OK;
	} else {
		/*
		 *  |[ȌꍇA҂Ƀ^CAEgB
		 */
		ercd = E_TMOUT;
	}

    error:
	t_unlock_cpu();

    exit:
	LOG_LOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ploc_mtx */

/*
 *  ~[ebNX̃bNi^CAEgj
 */
#ifdef __tloc_mtx
SYSCALL ER
tloc_mtx(ID mtxid, TMO tmout)
{
	MTXCB	*mtxcb;
	WINFO_WOBJ winfo;
	TMEVTB tmevtb;
	ER	ercd;

	CHECK_MTXID(mtxid);
	CHECK_TMOUT(tmout);

	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (runtsk == mtxcb->mtxtsk){
		/*
		 *  dbN
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if ( ( mtxcb->mtxinib->mtxatr == TA_CEILING ) 
	     && (runtsk->base_priority < INT_PRIORITY(mtxcb->mtxinib->ceilpri)) ) {
		/*
		 *  ^XÑx[XDxΏۃ~[ebNX̏Dx
		 *  ꍇɂE_ILUSEԂB(ITRON4.0dl)
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if (mtxcb->mtxtsk == NULL){
		/*
		 *  󂢂ĂĊlłꍇ
		 */
		mtxcb->mtxtsk = runtsk;
		multiqueue_insert_prev((MULTIOBJCB *)runtsk, (MULTIOBJCB *)mtxcb, 0);
		if ((mtxcb->mtxinib->mtxatr == TA_CEILING) &&
		    (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < runtsk->priority)) {
			/*
			 *  TA_CEILING̃~[ebNX^XNbNꍇŁA
			 *  Ώۃ~[ebNX̏Dx^XŇݗDx
			 *  ꍇɂ́A^XŇݗDxA~[ebNX̏DxɕύXB
			 * (ITRON4.0dl)
			 */
			change_priority(runtsk, INT_PRIORITY(mtxcb->mtxinib->ceilpri));
		}
		ercd = E_OK;
	} else {
		UINT pri;
		if (tmout == TMO_POL) {
			ercd = E_TMOUT;
			goto error;
		}
		/*
		 *  ҂ꍇ
		 */
		pri = runtsk->priority;
		if (mtxcb->mtxinib->mtxatr == TA_INHERIT) {
			if (mtxcb->mtxtsk->priority > pri) { 
				/*
				 *  (TA_INHERIT̏ꍇ && ^XNbN҂Ɉڍsꍇ)
				 *  ^XŇݗDx(A)Ώۃ~[ebNXbNĂ^XN
				 *  ݗDxꍇɂ́A~[ebNXbNĂ^XN
				 *  ݗDxA(A)ɕύXB(ITRON4.0dlv)
				 */
				set_current_priority(mtxcb->mtxtsk, pri);
			}
			wobj_make_wait_mutexi_tmout((WOBJCB *) mtxcb, &winfo, &tmevtb, tmout);
		} else {
			wobj_make_wait_tmout((WOBJCB *) mtxcb, &winfo, &tmevtb, tmout);
		}
		/*
		 *  ҂ɓ^XN̂ŁA
		 *  KfBXpb`Kv
		 */
		dispatch();
		ercd = winfo.winfo.wercd;
	}

    error:
	t_unlock_cpu();

    exit:
	LOG_LOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __tloc_mtx */

/*
 *  ~[ebNX̃bN
 */
#ifdef __unl_mtx
SYSCALL ER
unl_mtx(ID mtxid)
{
	MTXCB	*mtxcb;
	TCB	*tcb;
	ER	ercd;
    
	UINT	pri;
	BOOL	dispflg = FALSE;

	LOG_UNL_MTX_ENTER(mtxid);
	CHECK_DISPATCH();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (mtxcb->mtxtsk != runtsk){
		/*
		 *  sgp:  Ώۃ~[ebNXbNĂȂB
		 */
		ercd = E_ILUSE;
		goto error;
	}

	multiqueue_delete((MULTIOBJCB *)mtxcb, 0);/*J~[ebNXbNXg폜*/

	/* 
	 *  ȗDxK̗pĂ̂ŁA
	 *  ɌݗDx̕ύXKvB
	 */
	if (mtxcb->mtxinib->mtxatr == TA_INHERIT)  {
		/*ݗDx̕ύX(ȗDxKɏ])*/
		if (multiqueue_empty((MULTIOBJCB *)runtsk, 0)) {
			/*
			 *  bNĂ~[ebNX
			 *  ȂƂɂ̓x[XDxɖ߂
			 * 
			 *  ΏۂƂȂĂ^XN̏ԂrunningȂ̂Ȃ̂ŁA
			 *  ʂTA_INHERIT~[ebNX҂Ă͂B
			 *  āAset_current_priority()pKv͖B
			 */
			runtsk->priority = runtsk->base_priority;
			dispflg = FALSE;
		}else if (!queue_empty(&(mtxcb->wait_queue))) {
			if (runtsk->priority == ((TCB *)(mtxcb->wait_queue.next))->priority ) {
				/*
				 *  ݗDx擪̑҂^XŇݗDx
				 * vĂƂ̓T[`ĕύX
				 */
				pri = search_mtx_priority(runtsk);
				if (pri != runtsk->priority){
					dispflg = set_current_priority(runtsk, pri);
				}
			}
		}
	} else if ( mtxcb->mtxinib->mtxatr == TA_CEILING) {
		/*ݗDx̕ύX(ȗDxKɏ])*/
		if (multiqueue_empty((MULTIOBJCB *)runtsk, 0)) {
			/*
			 *  bNĂ~[ebNX
			 *  ȂƂɂ̓x[XDxɖ߂B
			 * 
			 *  ΏۂƂȂĂ^XN̏ԂrunningȂ̂Ȃ̂ŁA
			 *  ʂTA_INHERIT~[ebNX҂Ă͂B
			 *  āAset_current_priority()pKv͖B
			 */
			runtsk->priority = runtsk->base_priority;
			dispflg = FALSE;
		} else if (runtsk->priority != runtsk->base_priority &&
			   runtsk->priority == INT_PRIORITY(mtxcb->mtxinib->ceilpri)) {
			/*
			 *  ݗDxDxƈv
			 *  Ƃ̓T[`ĕύX
			 */
			pri = search_mtx_priority(runtsk);
			if (pri != runtsk->priority) {
				dispflg = set_current_priority(runtsk, pri);
			}
		}
	}

	if (!queue_empty(&(mtxcb->wait_queue))) {
		tcb = (TCB *) queue_delete_next(&(mtxcb->wait_queue));
		dispflg |= wait_complete(tcb);
		mtxcb->mtxtsk = tcb;
		multiqueue_insert_prev((MULTIOBJCB *)tcb, (MULTIOBJCB *)mtxcb, 0);
		/*TA_CEILINGłΗDxDx܂ŏグ*/
		if (mtxcb->mtxinib->mtxatr == TA_CEILING
		    && (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < tcb->priority) ){
			dispflg |= change_priority(tcb, INT_PRIORITY(mtxcb->mtxinib->ceilpri));
		}
	} else {
		mtxcb->mtxtsk = NULL;
	}

	if (dispflg) {
		dispatch();
	}
	ercd = E_OK;

    error:
	t_unlock_cpu();

    exit:
	LOG_UNL_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __unl_mtx */

/*
 *  ~[ebNX̏ԎQ
 */
#ifdef __ref_mtx
SYSCALL ER
ref_mtx(ID mtxid, T_RMTX *pk_rmtx)
{
	MTXCB	*mtxcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_REF_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (mtxcb->mtxtsk == NULL) {
		/* Ώۃ^XNbNĂȂꍇ */
		pk_rmtx->htskid = TSK_NONE;
	} else {
		pk_rmtx->htskid = TSKID(mtxcb->mtxtsk);
	}

	if (queue_empty(&(mtxcb->wait_queue))) {
		/* bN҂Ă^XNꍇ */
		pk_rmtx->wtskid = TSK_NONE;
	} else {
		tcb = (TCB *)queue_peek_next(&(mtxcb->wait_queue));
		pk_rmtx->wtskid = TSKID(tcb);
	}


	/*
	 *  y⑫z htskid == TSK_NONE  wtskid != TSK_NONE
	 *  ɐ邱Ƃ͂ȂB
	 */
	assert(!((pk_rmtx->htskid == TSK_NONE) && (pk_rmtx->wtskid != TSK_NONE)));

	
	ercd = E_OK;
   
	t_unlock_cpu();

    exit:
	LOG_REF_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_mtx */


/*
 *  bN~[ebNX̍ōDx̃T[`
 *  - TA_INHERIT̃~[ebNX̑҂^XŇݗDx
 *  - TA_CEILING̃~[ebNX̗Dx
 *  - x[XDx
 *  ̂Aō̗Dx̒l
 */
#ifdef __schmtxpri

UINT 
search_mtx_priority(TCB *tcb)
{
	UINT pri;
	MULTIOBJCB *cb;

	/*
	 *  x[XDxlƂČ
	 */
	pri = tcb->base_priority;

	cb = NULL;
	while ((cb = multiqueue_enumerate((MULTIOBJCB *)tcb, cb, 0)) != NULL) {
		MTXCB *mtxcb;
		mtxcb = (MTXCB *)cb;
		if (mtxcb->mtxinib->mtxatr == TA_INHERIT) {
			/*
			 *  ōDx̑҂^XŇݗDxƔr
			 */
			if (!queue_empty(&(mtxcb->wait_queue))) {
				TCB *tcb;
				tcb = (TCB *)(mtxcb->wait_queue.next);
				if(tcb->priority < pri){
					pri = tcb->priority;
				}
			}
		} if (mtxcb->mtxinib->mtxatr == TA_CEILING) {
			/*
			 *  DxƔr
			 */
			if (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < pri){
				pri = INT_PRIORITY(mtxcb->mtxinib->ceilpri);
			}
		}
	}
	return pri;
}

#endif /* __schmtxpri */


/*
 *  bNĂTA_CEILING~[ebNX̏Dx̂
 *  Œ̒ľ
 */
#ifdef __schmaxceilpri

UINT
search_max_ceilpri(TCB *tcb)
{
	UINT pri = 0;/*_~[̍l*/
	MULTIOBJCB *cb;

	cb = NULL;
	while ((cb = multiqueue_enumerate((MULTIOBJCB *)tcb, cb, 0)) != NULL) {
		MTXCB *mtxcb;
		mtxcb = (MTXCB *)cb;

		if(mtxcb->mtxinib->mtxatr == TA_CEILING) {
			/*
			 *  TA_CEILINGȂDxƔr
			 */
			if (INT_PRIORITY(mtxcb->mtxinib->ceilpri) > pri) {
				pri = INT_PRIORITY(mtxcb->mtxinib->ceilpri);
			}
		}
	}

	return pri;
}

#endif /* __schmaxceilpri */

/*
 *  w肳ꂽx[XDx^XNɗ^Ă悢ǂ`FbNB
 *  x[XDxݒ̐󂯂̂́AΏۃ^XNTA_CEILINGbNĂ邩
 *  bN҂ĂꍇŁAtskpriŎw肳ꂽx[XDxÃ~[ebNX
 *  ꂩ̏DxꍇB
 *  x[XDxݒ̐󂯂ꍇɂ́AFALSEԂB
 */
#ifdef __checkceilpri

BOOL
check_ceiling_priority(TCB *tcb, PRI base_priority)
{
 	if (search_max_ceilpri(tcb) > base_priority) {
		 return FALSE;
	}
	
	if ((tcb->tstat & TS_WAIT_MTX_I))  {
			MTXINIB *mtxinib = ((MTXCB *)( ((WINFO_WOBJ *)(tcb->winfo))->wobjcb))->mtxinib;
			if ((mtxinib->mtxatr & TA_CEILING) && mtxinib->ceilpri > base_priority) {
				return FALSE;
			}
	}
	
	return TRUE;
}

#endif /* __checkceilpri */

