/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  Copyright (C) 2002 by Masao Higuchi
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 *
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/mutex.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	~[ebNX@\
 *
 *  The original code was written by Masao Higuchi.
 *  Extended for uITRON4.0 fullset was written by Masaki Muranaka.
 */

#ifndef TOPPERS_MUTEX_H
#define TOPPERS_MUTEX_H

#include "queue.h"

/*
 *  ~[ebNXubN
 */
typedef struct mutex_initialization_block {
	ATR	mtxatr;		/* ~[ebNX */
	PRI	ceilpri;	/*Dx*/
} MTXINIB;

/*
 *  ~[ebNXubNAzyA
 */
typedef struct mutex_initialization_block_apair {
	ID	mtxid;
	MTXINIB	mtxinib;
} MTXINIA;

/*
 *  ~[ebNXǗubN
 */
typedef struct mutex_control_block {
	QUEUE	wait_queue;	/* ~[ebNX҂L[ */
	MTXINIB	*mtxinib;	/* ~[ebNXubN */
	QUEUE	mtxlist;	/* ^XNɂlĂ~[ebNX̃Xg */

	TCB	*mtxtsk;	/* ̃~[ebNXbNĂ^XNւ̃|C^
				 *  bNĂȂ == NULL
				 */
	unsigned int	exist:2;	/* gĂƂAKOBJ_EXIST */
	unsigned int	reserved:1;
} MTXCB;

/*
 *  ~[ebNXXg
 *  ̊ǗubN̐擪AhX
 *  邽߂̃}N
 */
#define HEADMTX(ptr) ( ((int)ptr) - (offsetof(MTXCB, mtxlist)) )

/*
 *  ~[ebNX@\̏
 */
extern void	mutex_initialize(void);

/*
 *  ~[ebNX֘A֐
 */
extern UINT search_max_ceilpri(TCB *);
extern UINT search_mtx_priority(TCB *);
extern BOOL check_ceiling_priority(TCB *tcb, PRI base_priority);

#define MTXID(mtxcb)	((ID)(mtxcb - mtxcb_table) + TMIN_MTXID)

#endif /* TOPPERS_MUTEX_H */
