/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2006 by Muranaka Masaki
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/queue.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	L[색Cu
 *
 *  ̃L[색Cuł́CL[wb_܂ރO\̃_u
 *  NL[D̓Iɂ́CL[wb_̎Gg̓L[
 *  擪̃GgCOGg̓L[̖̃GgƂD܂CL
 *  [̐擪̃Gg̑OGgƁCL[̖̃Gg̎G
 *  ǵCL[wb_ƂD̃L[́CGgCOGg
 *  gwL[wb_ł킷D
 */

#ifndef TOPPERS_QUEUE_H
#define TOPPERS_QUEUE_H

/*
 *  L[̃f[^\̒`
 */
typedef struct queue {
	struct queue *next;		/* Ggւ̃|C^ */
	struct queue *prev;		/* OGgւ̃|C^ */
} QUEUE;

/*
 *  L[̏
 *
 *  queue ɂ̓L[wb_w肷D
 */
Inline void
queue_initialize(QUEUE *queue)
{
	queue->prev = queue->next = queue;
}

/*
 *  L[̑OGgւ̑}
 *
 *  queue ̑O entry }Dqueue ɃL[wb_w肵ꍇ
 *  ɂ́CL[̖ entry }邱ƂɂȂD
 */
Inline void
queue_insert_prev(QUEUE *queue, QUEUE *entry)
{
	entry->prev = queue->prev;
	entry->next = queue;
	queue->prev->next = entry;
	queue->prev = entry;
}

/*
 *  Gg̍폜
 *
 *  entry L[폜D
 */
Inline void
queue_delete(QUEUE *entry)
{
	entry->prev->next = entry->next;
	entry->next->prev = entry->prev;
}

/*
 *  L[̗
 *
 *  topL[ƂGg擪񋓂B
 *  ŏ̌ďoł́AentryNULLnBԒltop̎̃Gg(܂擪)łB
 *  ȍ~͑OɓGgentryɓnBԒlentry̎̃GgƂȂB
 *  entry̎̃GgtopƂANULLԒlƂāAL[̏I[킷B
 *  topNULL`FbNentry̑Ó؂͍sĂȂBďo̐ӔCōsƁB
 *  ܂A܂łȂAXbhZ[tɂ͂Ȃ肦ȂB񋓃[v͔r
 *  ďo̐ӔCōsƁB
 */
Inline QUEUE *
queue_enumerate(QUEUE *top, QUEUE *entry)
{
	QUEUE *result;
	if (entry == NULL) {
		result = top->next;
	} else {
		result = entry->next;
	}
	if (result == top) {
		return NULL;
	}
	return result;
}

/*
 *  L[̎Gg̎o
 *
 *  queue ̎GgL[폜C폜GgԂDqueue
 *  ɃL[wb_w肵ꍇɂ́CL[̐擪̃Ggo
 *  ƂɂȂDqueue ɋ̃L[w肵ČĂяoĂ͂ȂȂD
 */
Inline QUEUE *
queue_delete_next(QUEUE *queue)
{
	QUEUE	*entry;

	assert(queue->next != queue);
	entry = queue->next;
	queue->next = entry->next;
	entry->next->prev = queue;
	return(entry);
}

/*
 *  L[̎Gg̃|C^擾
 *
 *  queue ̎GgԂDqueue ɃL[wb_w肵ꍇɂ́C
 *  L[̐擪̃GgoƂɂȂDqueue ɋ̃L[
 *  w肵ČĂяoĂ͂ȂȂD
 */
Inline QUEUE *
queue_peek_next(QUEUE *queue)
{
	assert(queue->next != queue);

	return(queue->next);
}

/*
 *  L[󂩂ǂ̃`FbN
 *
 *  queue ɂ̓L[wb_w肷D
 */
Inline BOOL
queue_empty(QUEUE *queue)
{
	if (queue->next == queue) {
		assert(queue->prev == queue);
		return(TRUE);
	}
	return(FALSE);
}

#endif /* TOPPERS_QUEUE_H */
