/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Masaki Muranaka
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/rendezvous.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	fu@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "rendezvous.h"

/*
 *  fu|[gID̍őlikernel_cfg.cj
 */
extern const ID	tmax_porid;

/*
 *  fu|[gubÑGAikernel_cfg.cj
 */
extern PORINIB	porinib_table[];

/*
 *  fu|[gubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_porinia;

/*
 *  fu|[gubNAzyÃGAikernel_cfg.cj
 */
extern const PORINIA	porinia_table[];

/*
 *  fu|[g\ID̃GAikernel_cfg.cj
 */
extern const ID		porrid_table[];

/*
 *  fu|[g\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_porrid;

/*
 *  fu|[gǗubÑGAikernel_cfg.cj
 */
extern PORCB	porcb_table[];

/*
 *  IDėpt[Xg
 */
extern QUEUE sem_freelist;

/*
 *  fu|[gID烉fu|[gǗubNo߂̃}N
 */
#define INDEX_POR(porid)	((UINT)((porid) - TMIN_PORID))
#define get_porcb(porid)	(&(porcb_table[INDEX_POR(porid)]))

/*
 *  fu|[g̐
 */
#define TNUM_POR	((UINT)(tmax_porid - TMIN_PORID + 1))

#define CHECK_RDVPTN(x) { if ((x) == 0) { return E_PAR; } }

#define TNUM_RDVNO_HASH (10)

extern RDVCB	rdvcb_table[TNUM_RDVNO_HASH];
extern RDVINIB	rdvinib_table[TNUM_RDVNO_HASH];

extern UINT rdvidx;

/*
 *  fu҂ubN̒`
 */
typedef struct rdvport_waiting_information {
	WINFO	winfo;		/* W̑҂ubN */
	WOBJCB *wobjcb;	/* ҂IuWFNg̃Rg[ubN */
	RDVPTN ptn;		/* ďo/t̃p^[ */
	RDVNO rdvno;
	VP *msg;
	UINT msgsz;
	UINT maxrmsz;
	TCB *caller_tcb;
} WINFO_POR;

extern QUEUE por_freelist;

/* 
 *  fu|[g@\̏
 */
#ifdef __inipor

UINT rdvidx = 0;
QUEUE por_freelist;

/*
 *  rdvcb_table indexrdvnô̂ł͂Ȃ
 *  rdvnõnbVlł邱ƂɒӁB
 */
RDVCB rdvcb_table[TNUM_RDVNO_HASH];
RDVINIB rdvinib_table[TNUM_RDVNO_HASH];

void
rendezvous_initialize()
{
	UINT	i;
	PORCB	*porcb;
	PORINIB *porinib;
	const PORINIA	*porinia;
	const ID	*porrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (porcb = porcb_table, i = 0; i < tmax_porid; porcb++, i++) {
		queue_initialize(&(porcb->wait_queue));
		porcb->porinib = NULL;
	}
	queue_initialize(&por_freelist);

	/*
	 *  porinia ɂĎ̂܂
	 */
	for (porinia = porinia_table, i = 0; i < tnum_porinia; porinia++, i++) {
		UINT idx = INDEX_POR(porinia->porid);
		queue_initialize(&(porcb_table[idx].wait_queue));
		queue_initialize(&(porcb_table[idx].await_queue));
		porinib = &porinib_table[idx];
		*porinib = porinia->porinib;
		porcb = &porcb_table[idx];
		porcb->porinib = porinib;
		porcb->exist = KOBJ_EXIST;
		porcb->reserved = TRUE;
	}

	/*
	 *  \ID̐ݒ
	 */
	for (porrid = porrid_table, i = 0; i < tnum_porrid; porrid++, i++) {
		porcb_table[INDEX_POR(*porrid)].reserved = TRUE;
	}

	/*
	 *  porinia ɂĎȂ̂
	 */
	for (porcb = porcb_table, i = 0; i < TNUM_POR; porcb++, i++) {
		if (porcb->porinib == NULL) {
			porcb->exist = KOBJ_NOEXS;
			porcb->porinib = &porinib_table[i];

			if (!CHECK_OBJECT_RESERVED(porcb)) {
				queue_insert_prev(&por_freelist, (QUEUE*)porcb);
			}
		}
	}

	for(i = 0; i < TNUM_RDVNO_HASH; i++) {
		queue_initialize(&(rdvcb_table[i].wait_queue));
		rdvcb_table[i].rdvinib = &rdvinib_table[i];
		rdvinib_table[i].atr = TA_TFIFO;
	}
}

#endif /* __inipor */

/*
 *  fu|[g̐
 */
#ifdef __cre_por

SYSCALL ER
cre_por(ID porid, const T_CPOR * pk_cpor)
{
	PORCB	*porcb;
	PORINIB *porinib;
	ER	ercd;
    
	LOG_CRE_POR_ENTER(porid, pk_cpor);
	CHECK_TSKCTX_UNL();

	CHECK_PORID(porid);
	CHECK_ATTRIBUTE(pk_cpor->poratr, TA_TFIFO | TA_TPRI);
	porcb = get_porcb(porid);
	CHECK_OBJECT_CREATABLE(porcb);
	UPDATE_OBJECT_FREELIST(porcb);

	/*
	 * ݒsB
	 */
	queue_initialize(&(porcb->wait_queue));
	queue_initialize(&(porcb->await_queue));
	porinib = porcb->porinib;
	porinib->poratr = pk_cpor->poratr;
	porinib->maxcmsz = pk_cpor->maxcmsz;
	porinib->maxrmsz = pk_cpor->maxrmsz;

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	porcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_POR_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_por */

/*
 *  fu|[g̐(IDԍt)
 */
#ifdef __acre_por

SYSCALL ER_ID
acre_por(const T_CPOR *pk_cpor)
{
	PORCB	*porcb;
	PORINIB *porinib;
	ER_ID	ercd;
    
	LOG_ACRE_POR_ENTER(pk_cpor);
	CHECK_TSKCTX_UNL();

	if (TNUM_POR == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_cpor->poratr, TA_TFIFO | TA_TPRI);
	
	t_lock_cpu();
	porcb = (PORCB *)t_get_free_id((QUEUE *)&por_freelist);
	if (porcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	porcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 *  ݒsB
	 */
	queue_initialize(&(porcb->wait_queue));
	queue_initialize(&(porcb->await_queue));
	porinib = porcb->porinib;
	porinib->poratr = pk_cpor->poratr;
	porinib->maxcmsz = pk_cpor->maxcmsz;
	porinib->maxrmsz = pk_cpor->maxrmsz;

	ercd = PORID(porcb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	porcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_POR_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_por */


/*
 *  fu|[g̍폜
 */
#ifdef __del_por
SYSCALL ER
del_por(ID porid)
{
	PORCB	*porcb;
	ER	ercd;
    
	LOG_DEL_POR_ENTER(porid);
	CHECK_TSKCTX_UNL();

	CHECK_PORID(porid);
	porcb = get_porcb(porid);

	CHECK_OBJECT_DELETABLE(porcb);

	/*
	 *  ҂šЕtB폜ɔ҂sB
	 */
	while (queue_empty(&(porcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(porcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	/*
	 *  ҂šЕtB폜ɔ҂sB
	 */
	while (queue_empty(&(porcb->await_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(porcb->await_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(porcb)) {
		/*
		 *  \IDłȂ΃t[XgɓB
		 */
		t_lock_cpu();
		queue_insert_prev(&por_freelist, (QUEUE *)porcb);
		t_unlock_cpu();
	}

	/*
	 *  acre_/cre_ł̃ANZX\
	 */
	porcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_POR_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_por */

/*
 *  fǔďo
 *
 *  poridŎw肳郉fv|[gɑ΂āA
 *  calptnŎw肳郉fuɂAfuĂяoB
 */
#ifdef __cal_por

SYSCALL ER_UINT
cal_por(ID porid, RDVPTN calptn, VP msg, UINT cmsgsz)
{
	PORCB	*porcb = NULL;
	ER	ercd;
	QUEUE	*queue = NULL;
	RDVNO	rdvno;
	TCB *tcb;

	CHECK_DISPATCH();
	CHECK_RDVPTN(calptn);

	CHECK_PORID(porid);
	porcb = get_porcb(porid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	if (cmsgsz > porcb->porinib->maxcmsz) {
		/*
		 *  cmsgsz AΏۃfu|[ǧďobZ[W
		 *  őTCY傫ꍇɂ́AE_PAR̃G[ԂB
		 */
		ercd = E_PAR;
		goto error;
	}

	rdvno = ((TSKID(runtsk) & 0xffff) << 16) | (++rdvidx & 0xffff);

	/*
	 *  fut҂s𑖍Arbgp^[v
	 *  fut҂B
	 */
	while ((queue = queue_enumerate(&(porcb->await_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & calptn)) {
			memcpy(pk_winfo->msg, msg, cmsgsz);
			pk_winfo->msgsz = cmsgsz;
			pk_winfo->rdvno = rdvno;
			queue_delete(queue);
			break;
		}
	}

	/*
	 *  fut҂Ă(ȀŃrbgp^[
	 *  vĂ)A^XNfuI҂ɂB
	 *  łȂ΁A^XNfuďo҂ԂɂB
	 */
	if (queue != NULL) {
		WINFO_POR winfo;
		RDVCB *rdvcb;
		winfo.msg = msg;
		winfo.msgsz = cmsgsz;
		winfo.rdvno = rdvno;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		rdvcb = &rdvcb_table[winfo.rdvno % TNUM_RDVNO_HASH];
		wobj_make_wait((WOBJCB *)rdvcb, (WINFO_WOBJ *)&winfo);
		dispatch();
		if (winfo.winfo.wercd == E_OK) {
			ercd = winfo.msgsz;
		} else {
			ercd = winfo.winfo.wercd;
		}
	} else {
		WINFO_POR winfo;
		winfo.ptn = calptn;
		winfo.msg = msg;
		winfo.msgsz = cmsgsz;
		winfo.rdvno = rdvno;
		winfo.caller_tcb = runtsk;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		wobj_make_wait((WOBJCB *) porcb, (WINFO_WOBJ *)&winfo);
		dispatch();
		if (winfo.winfo.wercd == E_OK) {
			ercd = winfo.msgsz;
		} else {
			ercd = winfo.winfo.wercd;
		}
	}

    error:
	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __cal_por */

/*
 *  fǔďo
 *
 * poridŎw肳郉fv|[gɑ΂āA
 * calptnŎw肳郉fuɂAfuĂяoB
 */
#ifdef __tcal_por

SYSCALL ER_UINT
tcal_por(ID porid, RDVPTN calptn, VP msg, UINT cmsgsz, TMO tmout)
{
	PORCB	*porcb = NULL;
	ER	ercd;
	TCB *tcb;
	QUEUE	*queue = NULL;
	RDVNO	rdvno;
	TMEVTB	tmevtb;

	CHECK_DISPATCH();
	CHECK_RDVPTN(calptn);
	CHECK_TMOUT(tmout);
	if (tmout == TMO_POL) {
		ercd = E_PAR;
		goto exit;
	}

	CHECK_PORID(porid);
	porcb = get_porcb(porid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	if (cmsgsz > porcb->porinib->maxcmsz) {
		/*
		 *  cmsgsz AΏۃfu|[ǧďobZ[W
		 *  őTCY傫ꍇɂ́AE_PAR̃G[ԂB
		 */
		ercd = E_PAR;
		goto error;
	}

	rdvno = ((TSKID(runtsk) & 0xffff) << 16) | (++rdvidx & 0xffff);

	/*
	 *  fut҂s𑖍Arbgp^[v
	 *  fut҂B
	 */
	while ((queue = queue_enumerate(&(porcb->await_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & calptn)) {
			memcpy(pk_winfo->msg, msg, cmsgsz);
			pk_winfo->msgsz = cmsgsz;
			pk_winfo->rdvno = rdvno;
			queue_delete(queue);
			break;
		}
	}

	/*
	 *  fut҂Ă(ȀŃrbgp^[
	 *  vĂ)A^XNfuI҂ɂB
	 *  łȂ΁A^XNfuďo҂ԂɂB
	 */
	if (queue != NULL) {
		WINFO_POR winfo;
		RDVCB *rdvcb;
		winfo.msg = msg;
		winfo.msgsz = cmsgsz;
		winfo.rdvno = rdvno;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		rdvcb = &rdvcb_table[winfo.rdvno % TNUM_RDVNO_HASH];
		wobj_make_wait_tmout((WOBJCB *)rdvcb, (WINFO_WOBJ *)&winfo, &tmevtb, tmout);
		dispatch();
		if (winfo.winfo.wercd == E_OK) {
			ercd = winfo.msgsz;
		} else {
			ercd = winfo.winfo.wercd;
		}
	} else {
		WINFO_POR winfo;
		winfo.ptn = calptn;
		winfo.msg = msg;
		winfo.msgsz = cmsgsz;
		winfo.rdvno = rdvno;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		winfo.caller_tcb = runtsk;
		wobj_make_wait_tmout((WOBJCB *) porcb, (WINFO_WOBJ *)&winfo, &tmevtb, tmout);
		dispatch();
		if (winfo.winfo.wercd == E_OK) {
			ercd = winfo.msgsz;
		} else {
			ercd = winfo.winfo.wercd;
		}
	}

    error:
	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __tcal_por */

/*
 *  fu̎t
 *
 * porid Ŏw肳郉fu|[gɑ΂āA
 * acpptnŎw肳郉fuɂAfu󂯕tB
 */
#ifdef __acp_por

SYSCALL ER
acp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg)
{
	PORCB	*porcb = NULL;
	WINFO_POR winfo;
	ER_UINT	ercd = E_SYS;
	QUEUE	*queue = NULL;

	CHECK_DISPATCH();
	
	CHECK_PORID(porid);
	CHECK_RDVPTN(acpptn);
	porcb = get_porcb(porid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ďo҂s𑖍Arbgp^[vȂ΁A
	 *  ҂^XNfuI҂ɈڍsB
	 */
	while ((queue = queue_enumerate(&(porcb->wait_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;

		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & acpptn)) {
			memcpy(msg, pk_winfo->msg, pk_winfo->msgsz);
			ercd = pk_winfo->msgsz;
			*p_rdvno = pk_winfo->rdvno;

			queue_delete(queue);
			queue_insert_prev(&rdvcb_table[pk_winfo->rdvno % TNUM_RDVNO_HASH].wait_queue, queue);

			break;
		}
	}

	if (queue == NULL) {
		/*
		 *  tɈvďo҂݂Ȃ
		 *  fut҂ԂɂB
		 */
		winfo.ptn = acpptn;
		winfo.msg = msg;
		winfo.msgsz = porcb->porinib->maxcmsz;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
		make_wait(&(winfo.winfo));
		queue_insert_prev(&(porcb->await_queue),
				  &(runtsk->task_queue));
		winfo.wobjcb = (WOBJCB *)porcb;
		LOG_TSKSTAT(runtsk);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (MERCD(ercd) == E_OK)
		{
			ercd = winfo.msgsz;
			*p_rdvno = winfo.rdvno;
		}
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __acp_por */

/*
 *  fu̎t (|[O)
 *
 * porid Ŏw肳郉fu|[gɑ΂āA
 * acpptnŎw肳郉fuɂAfu󂯕tB
 */
#ifdef __pacp_por

ER_UINT
pacp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg)
{
	PORCB	*porcb = NULL;
	ER_UINT	ercd = E_SYS;
	QUEUE	*queue = NULL;

	CHECK_TSKCTX_UNL();
	
	CHECK_PORID(porid);
	CHECK_RDVPTN(acpptn);
	porcb = get_porcb(porid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ďo҂s𑖍Arbgp^[vȂ΁A
	 *  ҂^XNfuI҂ɈڍsB
	 */
	while ((queue = queue_enumerate(&(porcb->wait_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;

		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & acpptn)) {
			memcpy(msg, pk_winfo->msg, pk_winfo->msgsz);
			ercd = pk_winfo->msgsz;
			*p_rdvno = pk_winfo->rdvno;

			queue_delete(queue);
			queue_insert_prev(&rdvcb_table[pk_winfo->rdvno % TNUM_RDVNO_HASH].wait_queue, queue);

			break;
		}
	}

	/*
	 * tɈvďo҂݂Ȃ
	 * ^CAEgG[ɂB
	 */
	if (queue == NULL) {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __pacp_por */

/*
 *  fu̎t (^CAEg)
 *
 * porid Ŏw肳郉fu|[gɑ΂āA
 * acpptnŎw肳郉fuɂAfu󂯕tB
 */
#ifdef __tacp_por

ER_UINT
tacp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg, TMO tmout)
{
	PORCB	*porcb = NULL;
	WINFO_POR winfo;
	ER_UINT	ercd = E_SYS;
	QUEUE	*queue = NULL;

	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);
	
	CHECK_PORID(porid);
	CHECK_RDVPTN(acpptn);
	porcb = get_porcb(porid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ďo҂s𑖍Arbgp^[vȂ΁A
	 *  ҂^XNfuI҂ɈڍsB
	 */
	while ((queue = queue_enumerate(&(porcb->wait_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;

		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & acpptn)) {
			memcpy(msg, pk_winfo->msg, pk_winfo->msgsz);
			ercd = pk_winfo->msgsz;
			*p_rdvno = pk_winfo->rdvno;

			queue_delete(queue);
			queue_insert_prev(&rdvcb_table[pk_winfo->rdvno % TNUM_RDVNO_HASH].wait_queue, queue);

			break;
		}
	}

	/*
	 *  tɈvďo҂݂Ȃ
	 */
	if (queue == NULL) {
		/*
		 *  |[OŵƂ́A
		 *  ҂Ă͂ȂB(E_TMOUT)
		 *  |[OwȊÔƂ́A
		 *  fut҂ԂɂB
		 */
		if (tmout == TMO_POL) {
			ercd = E_TMOUT;
		} else {
			TMEVTB tmevtb;

			winfo.ptn = acpptn;
			winfo.msg = msg;
			winfo.msgsz = porcb->porinib->maxcmsz;
			runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
			make_wait_tmout(&(winfo.winfo), &tmevtb, tmout);
			queue_insert_prev(&(porcb->await_queue),
					  &(runtsk->task_queue));
			winfo.wobjcb = (WOBJCB *)porcb;
			LOG_TSKSTAT(runtsk);
			dispatch();
			ercd = winfo.winfo.wercd;
			if (MERCD(ercd) == E_OK)
			{
				ercd = winfo.msgsz;
				*p_rdvno = winfo.rdvno;
			}
		}
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __tacp_por */

/*
 *  fȕI
 */
#ifdef __rpl_rdv

SYSCALL ER
rpl_rdv(RDVNO rdvno, VP msg, UINT rmsgsz)
{
	ER	ercd = E_OBJ;
	QUEUE	*queue = NULL;
	RDVCB	*rdvcb;
	TCB	*tcb;
	WINFO_POR *pk_winfo;

	CHECK_TSKCTX_UNL();

	rdvcb = &rdvcb_table[rdvno % TNUM_RDVNO_HASH];

	t_lock_cpu();

	/*
	 *  fuI҂s𑖍AfuԍvȂ΁A
	 *  ҂B
	 */
	while ((queue = queue_enumerate(&(rdvcb->wait_queue), queue)) != NULL) {
		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		
		if (pk_winfo->rdvno != rdvno) {
			continue;
		}

		if (pk_winfo->maxrmsz < rmsgsz) {
			ercd = E_PAR;
		} else {
			memcpy(pk_winfo->msg, msg, rmsgsz);
			pk_winfo->msgsz = rmsgsz;
			queue_delete(queue);
			if (wait_complete(tcb)) {
				dispatch();
			}
			ercd = E_OK;
		}
		break;
	}

	/*
	 *  Y郉fuԍȂ̂ŁAϐercd
	 *  ݒlłE_OBJƂȂB
	 *  rdvnoɎw肳ꂽlAfuԍƂĉ߂łȂ
	 *  P[X͖{o[Wł݂͑ȂB
	 */
	t_unlock_cpu();
    exit:
	return ercd;
}
#endif /* __rpl_rdv */

/*
 *  fủ
 */
#ifdef __fwd_por

SYSCALL ER
fwd_por(ID porid, RDVPTN calptn, RDVNO rdvno, VP msg, UINT cmsgsz)
{
	PORCB *porcb;
	RDVCB *rdvcb;
	QUEUE *queue = NULL;
	TCB	*tcb;
	TCB *await_tcb;
	WINFO_POR	*pk_winfo;

	ER	ercd = E_OBJ;

	CHECK_DISPATCH();

	CHECK_PORID(porid);
	CHECK_RDVPTN(calptn);
	porcb = get_porcb(porid);

	rdvcb = &rdvcb_table[rdvno % TNUM_RDVNO_HASH];

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	if (cmsgsz > porcb->porinib->maxcmsz) {
		/*
		 *  cmsgsz AΏۃfu|[ǧďobZ[W
		 *  őTCY傫ꍇɂ́AE_PAR̃G[ԂB
		 */
		ercd = E_PAR;
		goto error;
	}

	/*
	 *  fuI҂̃^XNAB
	 */
	while ((queue = queue_enumerate(&(rdvcb->wait_queue), queue)) != NULL) {
		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		
		if (rdvno == pk_winfo->rdvno) {
			QUEUE	*await_queue = NULL;

			/*
			 *  񑗂郉fufu|[g̕ԑbZ[W
			 *  cmsgsz傫΁AE_PARG[ԂB
			 */
			if (pk_winfo->maxrmsz < cmsgsz) {
				ercd = E_PAR;
				break;
			}
			queue_delete(queue);

			/*
			 *  fut҂s̃rbgp^[𑖍A
			 *  ΁Ã^XN̑҂B
			 */
			while ((await_queue = queue_enumerate(&(porcb->await_queue), await_queue)) != NULL) {
				await_tcb = (TCB *)await_queue;
				pk_winfo = (WINFO_POR *)(await_tcb->winfo);
				if ((pk_winfo->ptn & calptn)) {
					/*
					 *  񑗐̃fu|[g̕ԓbZ[W̍őTCY
					 *  񑗂郉fufu|[g̕ԓbZ[W
					 *  őTCY傫ƂAE_ILUSEԂB
					 */
					if (pk_winfo->maxrmsz < porcb->porinib->maxrmsz) {
						ercd = E_ILUSE;
						goto error;
					}
					memcpy(pk_winfo->msg, msg, cmsgsz);
					pk_winfo->msgsz = cmsgsz;
					pk_winfo->rdvno = rdvno;
					queue_delete(await_queue);

					queue_insert_prev(&rdvcb_table[rdvno % TNUM_RDVNO_HASH].wait_queue, queue);

					break;
				}
			}

			/*
			 *  fut҂sɊYrbgp^[Ȃ΁A
			 *  porid|[gɑ΂ăfuďo҂̏ԂɂB
			 */
			if (await_queue == NULL) {
				memcpy(pk_winfo->msg, msg, cmsgsz);
				pk_winfo->msgsz = cmsgsz;
				pk_winfo->ptn = calptn;
				wobj_move_wait(porcb, pk_winfo, tcb);
			} else {
				if (wait_complete(await_tcb)) {
					dispatch();
				}
			}

			ercd = E_OK;
			break;
		}
	}

	/*
	 *  Y郉fuԍȂ̂ŁAϐercd
	 *  ݒlłE_OBJƂȂB
	 *  rdvnoɎw肳ꂽlAfuԍƂĉ߂łȂ
	 *  P[X͖{o[Wł݂͑ȂB
	 */
    error:
	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __fwd_por */

/*
 *  fu|[g̏ԎQ
 */
#ifdef __ref_por

SYSCALL ER
ref_por(ID porid, T_RPOR *pk_rpor)
{
	ER ercd;
	TCB *tcb;
	PORCB *porcb;

	LOG_REF_POR_ENTER(porid);
	CHECK_TSKCTX_UNL();

	CHECK_PORID(porid);
	porcb = get_porcb(porid); 

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	if (!queue_empty(&(porcb->wait_queue))) {
		tcb = (TCB *)queue_peek_next(&(porcb->wait_queue));
		pk_rpor->ctskid = TSKID(tcb);
	} else {
		pk_rpor->ctskid = TSK_NONE;
	}

	if (!queue_empty(&(porcb->await_queue))) {
		tcb = (TCB *)queue_peek_next(&(porcb->await_queue));
		pk_rpor->atskid = TSKID(tcb);
	} else {
		pk_rpor->atskid = TSK_NONE;
	}

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_POR_LEAVE(ercd);

	return(ercd);
}

#endif

/*
 *  fȕԎQ
 */
#ifdef __ref_rdv

SYSCALL ER
ref_rdv(RDVNO rdvno, T_RRDV *pk_rrdv)
{
	ER ercd;
	RDVCB *rdvcb;
	QUEUE *queue = NULL;

	LOG_REF_RDV_ENTER(rdvno);

	rdvcb = &rdvcb_table[rdvno % TNUM_RDVNO_HASH];

	t_lock_cpu();

	/*
	 *  Y郉fuԍĂAE_OBJɂ͂Ȃ炸ATSK_NONEɂȂB
	 */
	pk_rrdv->wtskid = TSK_NONE;
	while((queue = queue_enumerate(&(rdvcb->wait_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;
		tcb = (TCB*)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if (pk_winfo->rdvno == rdvno) {
			pk_rrdv->wtskid = TSKID(tcb);
			break;
		}
	}

	ercd = E_OK;

	t_unlock_cpu();

	LOG_REF_RDV_LEAVE(ercd);

	return(ercd);
}

#endif
