/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2006 by Masaki Muranaka
 *  Copyright (C) 2003-2006 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/rendezvous.h 6183 2006-11-05T03:43:32.794177Z monaka  $
 */

/*
 *	fu|[g@\
 */

#ifndef TOPPERS_RENDEZVOUS_H
#define TOPPERS_RENDEZVOUS_H

#include "queue.h"

/*
 *  fu|[gubN
 */
typedef struct rendezvous_port_initialization_block {
  ATR	poratr;		/* Rendezvous port attribute. */
  UINT	maxcmsz;	/* ďobZ[W̍őTCY(byte count) */
  UINT	maxrmsz;	/* ԓbZ[W̍őTCY(byte count) */
} PORINIB;

/*
 *  fu|[gubNAzyA
 */
typedef struct rendezvous_port_initialization_block_apair {
	ID	porid;
	PORINIB	porinib;
} PORINIA;

/*
 *  fu|[gǗubN
 */
typedef struct rendezvous_port_control_block {
  QUEUE	wait_queue;		/* fuďo҂L[ */
  PORINIB *porinib;		/* fu|[gubNւ̃|C^ */
  QUEUE	await_queue;		/* fut҂L[ */
  unsigned int	reserved:1;
  unsigned int	exist:2;
} PORCB;


/*
 *  fuԍubN
 *  ̊ǗubNƂ͈Ⴄ(nbV\ł)ƂɒӁB
 */
typedef struct rendezvous_number_initialization_block {
	ATR	atr;			/* dummy */
} RDVINIB;

/*
 *  fuԍǗubN
 *  ̊ǗubNƂ͈Ⴄ(nbV\ł)ƂɒӁB
 */
typedef struct rendezvous_number_control_block {
	QUEUE	wait_queue;		/* fuI҂L[ */
	RDVINIB *rdvinib;  
} RDVCB;


/*
 *  fu|[g@\̏
 */
extern void rendezvous_initialize(void);

#define PORID(porcb)	((ID)((porcb) - porcb_table) + TMIN_PORID)

#endif /* TOPPERS_RENDEZVOUS_H */
