/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/semaphore.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	Z}tH@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "semaphore.h"

/*
 *  Z}tHID̍őlikernel_cfg.cj
 */
extern const ID	tmax_semid;

/*
 *  Z}tHubÑGAikernel_cfg.cj
 */
extern SEMINIB	seminib_table[];

/*
 *  Z}tHubNAzyA̐ikernel_cfg.cj
 */
extern const UINT	tnum_seminia;

/*
 *  Z}tHubNAzyÃGAikernel_cfg.cj
 */
extern const SEMINIA	seminia_table[];

/*
 *  Z}tH\ID̃GAikernel_cfg.cj
 */
extern const ID		semrid_table[];

/*
 *  Z}tH\ID̐ (kernel_cfg.c)
 */
extern const UINT	tnum_semrid;

/*
 *  Z}tHǗubÑGAikernel_cfg.cj
 */
extern SEMCB	semcb_table[];

/*
 *  Z}tH̐
 */
#define TNUM_SEM	((UINT)(tmax_semid - TMIN_SEMID + 1))

/*
 *  Z}tHIDZ}tHǗubNo߂̃}N
 */
#define INDEX_SEM(semid)	((UINT)((semid) - TMIN_SEMID))
#define get_semcb(semid)	(&(semcb_table[INDEX_SEM(semid)]))

/*
 *  IDėpt[Xg
 */
extern QUEUE sem_freelist;

/* 
 *  Z}tH@\̏
 */
#ifdef __semini

/*
 *  IDėpt[Xg
 */
QUEUE sem_freelist;

void
semaphore_initialize()
{
	UINT	i;
	SEMCB	*semcb;
	SEMINIB *seminib;
	const SEMINIA	*seminia;
	const ID	*semrid;

	/*
	 * J[lN̏ԂɊւ炸Ȃ΂Ȃ̂
	 * ܂B
	 */
	for (semcb = semcb_table, i = 0; i < TNUM_SEM; semcb++, i++) {
		queue_initialize(&(semcb->wait_queue));
		semcb->seminib = NULL;
	}
	queue_initialize(&sem_freelist);

	/*
	 * seminia ɂĎ̂܂
	 */
	for (seminia = seminia_table, i = 0; i < tnum_seminia; seminia++, i++) {
		seminib = &seminib_table[INDEX_SEM(seminia->semid)];
		*seminib = seminia->seminib;
		semcb = &semcb_table[INDEX_SEM(seminia->semid)];
		semcb->seminib = seminib;
		semcb->exist = KOBJ_EXIST;
		semcb->reserved = TRUE;

		semcb->semcnt = seminib->isemcnt;
	}

	/*
	 *  \ID̐ݒ
	 */
	for (semrid = semrid_table, i = 0; i < tnum_semrid; semrid++, i++) {
		semcb_table[INDEX_SEM(*semrid)].reserved = TRUE;
	}

	/*
	 * seminia ɂĎȂ̂
	 */
	for (semcb = semcb_table, i = 0; i < TNUM_SEM; semcb++, i++) {
		if (semcb->seminib == NULL) {
			semcb->exist = KOBJ_NOEXS;
			semcb->seminib = &seminib_table[i];

			if (!CHECK_OBJECT_RESERVED(semcb)) {
				queue_insert_prev(&sem_freelist, (QUEUE*)semcb);
			}
		}
	}
}

#endif /* __semini */

/*
 *  Z}tH̏
 */
#ifdef __semcbini

ER init_semcb(SEMCB *semcb, T_CSEM *pk_csem)
{
	SEMINIB *seminib;

	/*
	 * ݒsB
	 */
	queue_initialize(&(semcb->wait_queue));
	seminib = semcb->seminib;
	seminib->sematr = pk_csem->sematr;
	semcb->semcnt = seminib->isemcnt = pk_csem->isemcnt;
	seminib->maxsem = pk_csem->maxsem;


	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	semcb->exist = KOBJ_EXIST;

	return E_OK;
}

#endif /* __semcbini */

/*
 *  Z}tH̐
 */
#ifdef __cre_sem

SYSCALL ER
cre_sem(ID semid, const T_CSEM * pk_csem)
{
	SEMCB	*semcb;
	ER	ercd;
    
	LOG_CRE_SEM_ENTER(semid, pk_csem);
	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	CHECK_ATTRIBUTE(pk_csem->sematr, TA_TFIFO | TA_TPRI);
	if (pk_csem->isemcnt > pk_csem->maxsem) {
		ercd = E_PAR;
	} else {
		semcb = get_semcb(semid);
		CHECK_OBJECT_CREATABLE(semcb);
		UPDATE_OBJECT_FREELIST(semcb);

		ercd = init_semcb(semcb, pk_csem);
	}
    exit:
	LOG_CRE_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_sem */

/*
 *  Z}tH̐(IDԍt)
 */
#ifdef __acre_sem

SYSCALL ER_ID
acre_sem(const T_CSEM *pk_csem)
{
	SEMCB	*semcb;
	ER_ID	ercd;
    
	LOG_ACRE_SEM_ENTER(pk_csem);

	if (TNUM_SEM == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_csem->sematr, TA_TFIFO | TA_TPRI);
	if (pk_csem->isemcnt > pk_csem->maxsem) {
		ercd = E_PAR;
		goto exit;
	}

	t_lock_cpu();
	semcb = (SEMCB *)t_get_free_id((QUEUE *)&sem_freelist);
	if (semcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	semcb->exist = KOBJ_EXIST;
	t_unlock_cpu();

	ercd = init_semcb(semcb, pk_csem);

	if (ercd == E_OK) {
		ercd = SEMID(semcb);
	}

    exit:
	LOG_ACRE_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_sem */

/*
 *  Z}tH̍폜
 */
#ifdef __del_sem
SYSCALL ER
del_sem(ID semid)
{
	SEMCB	*semcb;
	ER	ercd;
    
	LOG_DEL_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	CHECK_OBJECT_DELETABLE(semcb);

	/* ҂šЕtB폜ɔ҂sB*/
	while (queue_empty(&(semcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(semcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();	
	}

	if (!CHECK_OBJECT_RESERVED(semcb)) {
	  /*
	   * \IDłȂ΃t[XgɓB
	   */
		t_lock_cpu();
		queue_insert_prev(&sem_freelist, (QUEUE *)semcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ł̃ANZX\ */
	semcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_sem */

/*
 *  Z}tH̕ԋp
 */
#ifdef __sig_sem

SYSCALL ER
sig_sem(ID semid)
{
	SEMCB	*semcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_SIG_SEM_ENTER(semid);

	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (!(queue_empty(&(semcb->wait_queue)))) {
		tcb = (TCB *) queue_delete_next(&(semcb->wait_queue));
		if (wait_complete(tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (semcb->semcnt < semcb->seminib->maxsem) {
		semcb->semcnt += 1;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}

	t_unlock_cpu();

    exit:
	LOG_SIG_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __sig_sem */

/*
 *  Z}tH̕ԋpi^XNReLXgpj
 */
#ifdef __isig_sem

SYSCALL ER
isig_sem(ID semid)
{
	SEMCB	*semcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_ISIG_SEM_ENTER(semid);
	CHECK_INTCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	i_lock_cpu();
	I_CHECK_OBJECT_EXIST(semcb);

	if (!queue_empty(&(semcb->wait_queue))) {
		tcb = (TCB *) queue_delete_next(&(semcb->wait_queue));
		if (wait_complete(tcb)) {
			reqflg = TRUE;
		}
		ercd = E_OK;
	}
	else if (semcb->semcnt < semcb->seminib->maxsem) {
		semcb->semcnt += 1;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}

	i_unlock_cpu();

    exit:
	LOG_ISIG_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __isig_sem */

/*
 *  Z}tH̊l
 */
#ifdef __wai_sem

SYSCALL ER
wai_sem(ID semid)
{
	SEMCB	*semcb;
	WINFO_WOBJ winfo;
	ER	ercd;

	LOG_WAI_SEM_ENTER(semid);
	CHECK_DISPATCH();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
		ercd = E_OK;
	}
	else {
		wobj_make_wait((WOBJCB *) semcb, &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
	}

	t_unlock_cpu();

    exit:
	LOG_WAI_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __wai_sem */

/*
 *  Z}tH̊li|[Oj
 */
#ifdef __pol_sem

SYSCALL ER
pol_sem(ID semid)
{
	SEMCB	*semcb;
	ER	ercd;

	LOG_POL_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_POL_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __pol_sem */

/*
 *  Z}tH̊li^CAEgj
 */
#ifdef __twai_sem

SYSCALL ER
twai_sem(ID semid, TMO tmout)
{
	SEMCB	*semcb;
	WINFO_WOBJ winfo;
	TMEVTB	tmevtb;
	ER	ercd;

	LOG_TWAI_SEM_ENTER(semid, tmout);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else {
		wobj_make_wait_tmout((WOBJCB *) semcb, &winfo, &tmevtb, tmout);
		dispatch();
		ercd = winfo.winfo.wercd;
	}

	t_unlock_cpu();

    exit:
	LOG_TWAI_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __twai_sem */

/*
 *  Z}tH̏ԎQ
 */
#ifdef __ref_sem
SYSCALL ER
ref_sem(ID semid, T_RSEM *pk_rsem)
{
	SEMCB	*semcb;
	ER	ercd;
    
	LOG_REF_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (!queue_empty(&(semcb->wait_queue))) {
		TCB *tcb;
		tcb = (TCB *)queue_peek_next(&(semcb->wait_queue));
		pk_rsem->wtskid = TSKID(tcb);
	} else {
		pk_rsem->wtskid = TSK_NONE;
	}
	pk_rsem->semcnt = semcb->semcnt;
	ercd = E_OK;
   
	t_unlock_cpu();

    exit:
	LOG_REF_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_sem */

