/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/servicecall.c 2750 2006-03-07T16:15:24.532712Z monaka  $
 */

/*
 *	gT[rXR[Ǘ@\
 */

#include "fi4_kernel.h"
#include "servicecall.h"
#include "bufmgr.h"
#include "check.h"

/*
 *  gT[rXR[̐ikernel_cfg.cj
 */
extern const UINT	tnum_svcno;

/*
 *  gT[rXR[̃GAikernel_cfg.cj
 */
extern SVCCB	svccb_table[];

/*
 *  gT[rXR[ubÑGAikernel_cfg.cj
 */
extern SVCINIB	svcinib_table[];

#define SVCINIB_HASH_SIZE	(8)
extern QUEUE	svcinib_hash_table[];

extern const UINT _kernel_tnum_svcno;

/*
 *  gT[rXR[ǗpnbVe[ȕ
 *
 *  exservicecall_initialize()ĂяoOɖ{֐KĂяoƁB
 *  ʏ̓RtBM[^kernel_cfg.cĂ̂ŐSz
 *  Kv͖AÂRtBM[^Âkernel_cfg.cpƖ肪
 *  o\Bsvcinib_hash_tablet߂ŊȋƂ́A
 *  o[Wsv^Ă݂邱Ƃ߂B
 */
#ifdef __svchashini

QUEUE	svcinib_hash_table[SVCINIB_HASH_SIZE];

void
_kernel_svchash_initialize()
{
	UINT		i;
	for (i = 0; i < SVCINIB_HASH_SIZE; i++) {
		queue_initialize(&svcinib_hash_table[i]);
	}
}

#endif /* __svchashini */

/* 
 *  gT[rXR[Ǘ@\̏
 *
 *  ̊֐́AO__kernel_svchash_initialize() ĂяoĂƁB
 *  ʏ̓RtBM[^kernel_cfg.cĂ̂ŐSz
 *  Kv͖AÂRtBM[^Âkernel_cfg.cpƖ肪
 *  o\Bsvcinib_hash_tablet߂ŊȋƂ́A
 *  o[Wsv^Ă݂邱Ƃ߂B
 */
#ifdef __svcini

void
exservicecall_initialize()
{
	UINT		i;
	SVCCB		*svccb;
	SVCINIB		*svcinib;

	for (svccb = svccb_table, svcinib = svcinib_table, i = 0; i < _kernel_tnum_svcno; svccb++, svcinib++, i++) {
		UINT hash;
		hash = (UINT)svcinib->fncd % SVCINIB_HASH_SIZE;
		svccb->svcinib = svcinib;
		queue_insert_prev(&svcinib_hash_table[hash], &(svccb->queue));
	}
}

#endif /* __svcini */

/*
 *  gT[rXR[̒`
 */
#ifdef __def_svc

SYSCALL
ER def_svc(FN fncd, const T_DSVC *pk_dsvc)
{
	ER ercd = E_OK;
	SIZE bufsz;
	SVCCB *svccb;
	UINT hash;
	QUEUE *queue = NULL;
	BOOL stat;

	if (fncd <= 0) {
		return E_RSFN;
	}

	if (pk_dsvc != NULL) {
		CHECK_ATTRIBUTE(pk_dsvc->svcatr, TA_HLNG | TA_ASM);
	}

	hash = (UINT)fncd % SVCINIB_HASH_SIZE;

	t_lock_cpu();
	while ((queue = queue_enumerate(&svcinib_hash_table[hash], queue)) != NULL) {
		SVCINIB *svcinib;
		svcinib = ((SVCCB *)queue)->svcinib;
		if (svcinib->fncd == fncd) {
			queue_delete(queue);
			/*
			 *  pk_dsvc == NULL ͓o^̉ӖB
			 */
			if (pk_dsvc == NULL) {
				t_unlock_cpu();
				return E_OK;
			}
			break;
		}
	}
	t_unlock_cpu();

	bufsz = sizeof(SVCCB) + sizeof(SVCINIB);
	t_lock_cpu();
	bufmgr_allocate(&stat, bufsz, (VP *)&svccb);
	t_unlock_cpu();
	if (!stat) {
		return E_NOMEM;
	}

	svccb->svcinib = (SVCINIB *)(svccb + 1);
	
	svccb->svcinib->fncd = fncd;
	svccb->svcinib->svcatr = pk_dsvc->svcatr;
	svccb->svcinib->svcrtn = pk_dsvc->svcrtn;
	queue_insert_prev(&svcinib_hash_table[hash], &(svccb->queue));

    exit:
	return ercd;
}

#endif /* __def_svc */

/*
 *  gT[rXR[̌ďo
 */
#ifdef __cal_svc

SYSCALL
ER cal_svc(FN fncd, VP_INT arg1, VP_INT arg2, VP_INT arg3, VP_INT arg4, VP_INT arg5)
{
	ER_UINT ercd;
	QUEUE	*queue = NULL;

	UINT hash;

	if (fncd <= 0) {
		return E_RSFN;
	}

	hash = (UINT)fncd % SVCINIB_HASH_SIZE;

	while ((queue = queue_enumerate(&svcinib_hash_table[hash], queue)) != NULL) {
		SVCINIB *svcinib;
		svcinib = ((SVCCB *)queue)->svcinib;
		if (svcinib->fncd == fncd) {
			ER_UINT (*svcrtn)(VP_INT arg1, VP_INT arg2, VP_INT arg3, VP_INT arg4, VP_INT arg5)
				 = (ER_UINT (*)(VP_INT arg1, VP_INT arg2, VP_INT arg3, VP_INT arg4, VP_INT arg5))svcinib->svcrtn;
			ercd = svcrtn(arg1, arg2, arg3, arg4, arg5);
			return ercd;
		}
	}

	return E_RSFN;
}

#endif /* __cal_svc */

