/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/task_manage.c 6101 2006-09-10T08:00:54.989588Z monaka  $
 */

/*
 *	^XNǗ@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "bufmgr.h"

/*
 *  IDėpt[Xg
 */
extern QUEUE tsk_freelist;


/*
 *  ^XN̐
 */
#ifdef __cre_tsk

SYSCALL ER
cre_tsk(ID tskid, const T_CTSK *pk_ctsk)
{
	TCB	*tcb;
	TINIB *tinib;
	ER	ercd;
	VP	stk = NULL;
	BOOL	disp = FALSE;

	LOG_CRE_TSK_ENTER(tskid, pk_ctsk);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID(tskid);
	CHECK_ATTRIBUTE(pk_ctsk->tskatr, TA_HLNG | TA_ASM | TA_ACT);
	if (TMIN_TPRI > pk_ctsk->itskpri || pk_ctsk->itskpri > TMAX_TPRI) {
		return E_PAR;
	}

	tcb = get_tcb(tskid);
	CHECK_TASK_CREATABLE(tcb);
	stk = pk_ctsk->stk;
	if (stk == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, pk_ctsk->stksz, &stk);
		if (!stat) {
			tcb->exist = KOBJ_NOEXS;
			ercd = E_NOMEM;
			goto exit;
		}
	}
	
	UPDATE_OBJECT_FREELIST(tcb);
	
	/*
	 * ݒsB
	 * tcbtinib̏KvB
	 */
	tinib = tcb->tinib;
	tinib->tskatr = pk_ctsk->tskatr;
	tinib->exinf = pk_ctsk->exinf;
	tinib->task = pk_ctsk->task;
	tinib->stksz = pk_ctsk->stksz;
	tinib->stk = stk;
	tinib->ipriority = INT_PRIORITY(pk_ctsk->itskpri);

	tcb->actcnt = FALSE;

	/*
	 *   make_dormant()
	 *  t_lock_cpu()̒ɓ̂
	 *  璷ȂǁAÔ߁B
	 */
	t_lock_cpu();
	make_dormant(tcb);
	if ((tcb->tinib->tskatr & TA_ACT) != 0) {
		/*
		 *  make_activequeueւ̃ANZX
		 *  邽߁ACPUbN͕K{B
		 */
		disp = make_active(tcb);
	}
	t_unlock_cpu();

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	tcb->exist = KOBJ_EXIST;

	ercd = E_OK;

	t_lock_cpu();
	/*
	 *  disp == TRUE ɂȂ̂ TA_ACT ŵƂ̂
	 *  ł邽߁Aŉ߂ă`FbNKv͖B
	 */  
	if (disp) {
		dispatch();
	}
	t_unlock_cpu();

    exit:
	LOG_CRE_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_tsk */

/*
 *  ^XN̐ (IDԍt)
 */
#ifdef __acre_tsk

SYSCALL ER_ID
acre_tsk(const T_CTSK *pk_ctsk)
{
	TCB	*tcb;
	TINIB	*tinib;
	ER_ID	ercd;
	VP stk;
	BOOL	disp = FALSE;

	LOG_ACRE_TSK_ENTER(pk_ctsk);
	CHECK_TSKCTX_UNL();

	if (TNUM_TSK == 0) {
		ercd = E_NOID;
		goto exit;
	}
	CHECK_ATTRIBUTE(pk_ctsk->tskatr, TA_HLNG | TA_ASM | TA_ACT);
	if (TMIN_TPRI > pk_ctsk->itskpri || pk_ctsk->itskpri > TMAX_TPRI) {
		return E_PAR;
	}

	if (pk_ctsk->stk == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, pk_ctsk->stksz, &stk);
		if (stat == FALSE) {
			ercd = E_NOMEM;
			goto exit;
		}
	} else {
		stk = pk_ctsk->stk;
	}
	
	t_lock_cpu();
	tcb = (TCB *)t_get_free_id((QUEUE *)&tsk_freelist);
	if (tcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	tcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * ݒsB
	 * tcbtinib̏KvB
	 */
	tinib = tcb->tinib;
	tinib->tskatr = pk_ctsk->tskatr;
	tinib->exinf = pk_ctsk->exinf;
	tinib->task = pk_ctsk->task;
	tinib->stk = stk;
	tinib->stksz = pk_ctsk->stksz;
	tinib->ipriority = INT_PRIORITY(pk_ctsk->itskpri);

	tcb->actcnt = FALSE;

	/*
	 *  t_lock_cpu()̌ďo
	 * 璷ȂǁAÔ߁B
	 */
	t_lock_cpu();
	make_dormant(tcb);
	if ((tcb->tinib->tskatr & TA_ACT) != 0) {
		disp = make_active(tcb);
	}
	t_unlock_cpu();

	ercd = TSKID(tcb);

	/*
	 *  ŏ߂đ̃T[rXR[gp\ɂȂB
	 */
	tcb->exist = KOBJ_EXIST;

	t_lock_cpu();
	/*
	 *  disp == TRUE ɂȂ̂ TA_ACT ŵƂ̂
	 *  ł邽߁Aŉ߂ă`FbNKv͖B
	 */  
	if (disp) {
		dispatch();
	}
	t_unlock_cpu();

    exit:
	if (ercd < E_OK) {
		BOOL stat;
		stat = bufmgr_release(stk);
		if (stat == FALSE) {
			ercd = E_SYS;
		}
	}
	LOG_ACRE_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_tsk */

/*
 *  ^XN̍폜
 */
#ifdef __del_tsk

SYSCALL ER
del_tsk(ID tskid)
{
	TCB	*tcb;
	ER	ercd;
	BOOL	stat;
    
	LOG_DEL_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	/*
	 * ł́A^XN̎wB
	 * Ax~Ԃł͂Ȃ߂
	 * E_OBJG[ԂB
	 */
	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	CHECK_OBJECT_DELETABLE(tcb);

	t_lock_cpu();
	if (!TSTAT_DORMANT(tcb->tstat)) {
		tcb->exist = KOBJ_EXIST;
		ercd = E_OBJ;
		t_unlock_cpu();
		goto exit;
	}
	t_unlock_cpu();

	/*
	 *  X^bN̈B
	 */
	stat = bufmgr_release(tcb->tinib->stk);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_SYS;
	}

	/*
	 * o^ԂցB
	 */
	if (!CHECK_OBJECT_RESERVED(tcb)) {
	  /*
	   * \IDłȂ΃t[XgɓB
	   */
		t_lock_cpu();
		queue_insert_prev(&tsk_freelist, (QUEUE *)tcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ł̃ANZX\ */
	tcb->exist = KOBJ_NOEXS;

    exit:
	LOG_DEL_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_tsk */

/*
 *  ^XN̋N
 */
#ifdef __act_tsk

SYSCALL ER
act_tsk(ID tskid)
{
	TCB	*tcb;
	ER	ercd;

	LOG_ACT_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	if (TSTAT_DORMANT(tcb->tstat)) {
		if (make_active(tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (!(tcb->actcnt)) {
		tcb->actcnt = TRUE;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}

	t_unlock_cpu();

    exit:
	LOG_ACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __act_tsk */

/*
 *  ^XN̋Ni^XNReLXgpj
 */
#ifdef __iact_tsk

SYSCALL ER
iact_tsk(ID tskid)
{
	TCB	*tcb;
	ER	ercd;

	LOG_IACT_TSK_ENTER(tskid);
	CHECK_INTCTX_UNL();

	CHECK_TSKID(tskid);
	tcb = get_tcb(tskid);

	i_lock_cpu();
	I_CHECK_OBJECT_EXIST(tcb);

	if (TSTAT_DORMANT(tcb->tstat)) {
		if (make_active(tcb)) {
			reqflg = TRUE;
		}
		ercd = E_OK;
	}
	else if (!(tcb->actcnt)) {
		tcb->actcnt = TRUE;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}

	i_unlock_cpu();

    exit:
	LOG_IACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __iact_tsk */

/*
 *  ^XNNṽLZ
 */
#ifdef __can_act

SYSCALL ER_UINT
can_act(ID tskid)
{
	TCB	*tcb;
	ER_UINT	ercd;

	LOG_CAN_ACT_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	ercd = tcb->actcnt ? 1 : 0;
	tcb->actcnt = FALSE;

	t_unlock_cpu();

    exit:
	LOG_CAN_ACT_LEAVE(ercd);
	return(ercd);
}

#endif /* __can_act */

/*
 *  ^XN̋NiNR[hwj
 */
#ifdef __sta_tsk

#include "cpu_context.h"

SYSCALL ER
sta_tsk(ID tskid, VP_INT stacd)
{
	ER	ercd;
	TCB	*tcb;
	LOG_STA_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	/*
	 *  łTSK_SELFB
	 *  ǍDORMANTԃ`FbN
	 *  E_OBJƂȂB
	 */
	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	if (TSTAT_DORMANT(tcb->tstat)) {
		/*
		 * ^XÑx[XDx́A^XN̋NɃ^XN̋NDxɏB
		 * (ITRON4.0dl 4.1)
		 */ 
		tcb->priority = tcb->tinib->ipriority;
		
		activate_context_with_stacd(tcb, stacd);
		if (make_runnable(tcb)) {
//			reqflg = TRUE;
			dispatch();                 /* [04/Aug/2004 AIC] ύX */
		}
		ercd = E_OK;
	} else {
		ercd = E_OBJ;
	}

	t_unlock_cpu();
    exit:
	LOG_STA_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_tsk */

/*
 *  ^XN̏I̓[`
 *  ext_tskexd_tskŋLB
 */
#ifdef __prepexttsk
void
prepare_exit_task(void)
{
#ifdef ACTIVATED_STACK_SIZE
	/*
	 *  create_context  activate_context ŁCgp̃X^bN
	 *  j󂵂Ȃ悤ɁCX^bNɃ_~[̈mۂD
	 */
	(void) alloca(ACTIVATED_STACK_SIZE);
#endif /* ACTIVATED_STACK_SIZE */

	if (sense_context()) {
		/*
		 *  ^XNReLXg ext_tsk/exd_tsk 
		 *  Ă΂ꂽꍇC
		 *  VXeOɃG[L^Ĉ܂܎s𑱂D
		 *  ̌ʁCIɃ^XNReLXgɐ؂芷āC
		 *  sԂ̃^XNI邱ƂɂȂDJ[l
		 *  ̂܂܎sp邪C^[QbgɂẮC
		 *  ^XNReLXgp̃X^bNɃS~cC
		 *  ݃nh̃lXg̊Ǘɖ肷
		 *  D
		 */
		syslog_0(LOG_ALERT,
			"ext_tsk is called from non-task contexts.");
	}
	if (sense_lock()) {
		/*
		 *  CPUbNԂ ext_tsk Ă΂ꂽꍇ́CCPUbN
		 *  Ă^XNID́CT[rX
		 *  R[łCPUbNȗ΂悢D
		 */
		syslog_0(LOG_WARNING,
			"ext_tsk is called from CPU locked state.");
	}
	else {
		if (sense_context()) {
			i_lock_cpu();
		}
		else  {
			t_lock_cpu();
		}
	}
	if (!(enadsp)) {
		/*
		 *  fBXpb`֎~Ԃ ext_tsk Ă΂ꂽꍇ́C
		 *  fBXpb`ԂɂĂ^XNID
		 */
		syslog_0(LOG_WARNING,
			"ext_tsk is called from dispatch disabled state.");
		enadsp = TRUE;
	}
}
#endif /* __prepexttsk */

/*
 *  ^XN̏I
 */
#ifdef __ext_tsk

SYSCALL void
ext_tsk(void)
{
	LOG_EXT_TSK_ENTER();

	prepare_exit_task();
	exit_task();
}

#endif /* __ext_tsk */

/*
 *  ^XN̏Iƍ폜
 */
#ifdef __exd_tsk

#include "mutex.h"
#include "multiqueue.h"

SYSCALL void
exd_tsk(void)
{
	TCB	*tcb;
	MTXCB *mtxcb;

	LOG_EXD_TSK_ENTER();

	prepare_exit_task();

	/*
	 *  ȉ́Aقexit_task()̏ƓB
	 *  łAexit_tasḱAďoƖ߂ĂȂ̂ŎgȂB
	 *  (See also <BTS:228>) 
	 */

	unlock_all_mutex(runtsk);
	make_non_runnable(runtsk);
	make_dormant(runtsk);
	if (runtsk->actcnt) {
		runtsk->actcnt = FALSE;
		make_active(runtsk);
	} else {
		/*
		 *  actcnt == 0 ̂Ƃ́A
		 */
/* Toppers porting F.Okazaki A start@^XNX^bNR */
		bufmgr_release(runtsk->tinib->stk);
		runtsk->tinib->stk = NULL;
/* Toppers porting F.Okazaki A end */

		if (!CHECK_OBJECT_RESERVED(runtsk)) {
			/*
			 *  \IDłȂ΃t[XgɓB
			 */
			queue_insert_prev(&tsk_freelist, (QUEUE *)runtsk);
		}
		/*
		 * o^ԂցB
		 */
		runtsk->exist = KOBJ_NOEXS;
	}
	exit_and_dispatch();
}

#endif /* __exd_tsk */

/*
 *  ^XN̋I
 */
#ifdef __ter_tsk

SYSCALL ER
ter_tsk(ID tskid)
{
	TCB	*tcb;
	UINT	tstat;
	ER	ercd;
	BOOL	dspflg = FALSE;     /* [03/Aug/2004 AIC] ǉ */

	LOG_TER_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID(tskid);
	tcb = get_tcb(tskid);
	CHECK_NONSELF(tcb);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	if (TSTAT_DORMANT(tstat = tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
		unlock_all_mutex(tcb);
		if (TSTAT_RUNNABLE(tstat)) {
			make_non_runnable(tcb);
		}
		else if (TSTAT_WAITING(tstat)) {
			wait_cancel(tcb);
			if ((tcb->tstat & TS_WAIT_MTX_I) != 0) {
				scan_new_priority(tcb); /* Dxp */
			}
		}
		make_dormant(tcb);
		if (tcb->actcnt) {
			tcb->actcnt = FALSE;
			dspflg |= make_active(tcb); /* [03/Aug/2004 AIC] ύX */
		}
		ercd = E_OK;
		if (dspflg) {           /* [03/Aug/2004 AIC] ǉ */
			dispatch();
		}
	}


	t_unlock_cpu();

    exit:
	LOG_TER_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __ter_tsk */

/*
 *  ^XNDx̕ύX
 */
#ifdef __chg_pri

SYSCALL ER
chg_pri(ID tskid, PRI tskpri)
{
	TCB	*tcb;
	UINT	newpri; /* ^XN̐Vx[XDx */
	UINT	tstat;
	ER	ercd = E_SYS;
	BOOL dispflg = FALSE;
	
	LOG_CHG_PRI_ENTER(tskid, tskpri);
	CHECK_TSKCTX_UNL();
	CHECK_TPRI_INI(tskpri);

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	if (TSTAT_DORMANT(tstat = tcb->tstat)) {
		ercd = E_OBJ;
		goto error;
	}

	if (!check_ceiling_priority(tcb, tskpri)) {
		ercd = E_ILUSE;
		goto error;
	}
	
	if (tskpri == TPRI_INI) {
		/*
		 *  tskpriTSK_SELF (= 0)w肳ƁA
		 *  ^XÑx[XDx^XN̋NDx
		 *  ύXB
		 */
		newpri = tcb->tinib->ipriority;
	} else {
		newpri = INT_PRIORITY(tskpri);
	}

	if (tcb->priority != newpri &&
		tcb->priority == tcb->base_priority) {
		/*
		 *  Ώۃ^XŇݗDxωꍇьݗDx
		 *  x[XDxɈvĂꍇB
		 *  JSPƂ͈ႢAL͏ɐ藧Ƃ͌ȂB
		 */
		if (TSTAT_RUNNABLE(tstat)) {
			if (change_priority(tcb, newpri)) {
				dispflg = TRUE;
			}
			ercd = E_OK;
		}
		else {
			tcb->priority = newpri;
			if ((tstat & TS_WAIT_WOBJCB) != 0) {
				wobj_change_priority(((WINFO_WOBJ *)(tcb->winfo))
								->wobjcb, tcb);
			}
			ercd = E_OK;
		}
	}
	
	dispflg |= inherit_priority(tcb, newpri);
	if (dispflg) {
		dispatch();
	}
	
	error:
	t_unlock_cpu();

    exit:
	LOG_CHG_PRI_LEAVE(ercd);
	return(ercd);
}

#endif /* __chg_pri */

/*
 *  ^XNDx̎Q
 */
#ifdef __get_pri

SYSCALL ER
get_pri(ID tskid, PRI *p_tskpri)
{
	TCB	*tcb;
	ER	ercd;

	LOG_GET_PRI_ENTER(tskid, p_tskpri);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	if (TSTAT_DORMANT(tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
		*p_tskpri = EXT_TSKPRI(tcb->priority);
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_GET_PRI_LEAVE(ercd, *p_tskpri);
	return(ercd);
}

#endif /* __get_pri */

/*
 *  ^XN̏ԎQ
 */
#ifdef __ref_tsk

SYSCALL ER
ref_tsk(ID tskid, T_RTSK *pk_rtsk)
{
	TCB	*tcb;
	ER	ercd;
	UINT	tstat;

	LOG_REF_TSK_ENTER(tskid);

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	tstat = tcb->tstat;
	if (TSTAT_RUNNABLE(tstat)) {
		if (tcb == runtsk) {
			pk_rtsk->tskstat = TTS_RUN;
		} else pk_rtsk->tskstat = TTS_RDY;
	} else {
		if (TSTAT_WAIT_SUSPENDED(tstat)) {
			pk_rtsk->tskstat = TTS_WAS;
		} else if (TSTAT_WAITING(tstat)) {
			pk_rtsk->tskstat = TTS_WAI;
		} else if (TSTAT_SUSPENDED(tstat)) {
			pk_rtsk->tskstat = TTS_SUS;
		} else if (TSTAT_DORMANT(tstat)) {
			pk_rtsk->tskstat = TTS_DMT;
		}
	}

	pk_rtsk->tskpri = EXT_TSKPRI(tcb->priority);
	pk_rtsk->tskbpri = EXT_TSKPRI(tcb->base_priority);
	/* TODO: tskwait, wobjid */
	/* pk_rtsk->lefttmo = tmevt_heap[tcb->winfo->tmevtb->index] - current_time; */
	pk_rtsk->actcnt = tcb->actcnt;
	pk_rtsk->wupcnt = tcb->wupcnt;
	if (TSTAT_SUSPENDED(tstat)) {
		pk_rtsk->suscnt = 1;
	} else {
		pk_rtsk->suscnt = 0;
	}

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_tsk */

/*
 *  ^XN̏ԎQƁiȈՔŁj
 */
#ifdef __ref_tst

SYSCALL ER
ref_tst(ID tskid, T_RTST *pk_rtst)
{
	TCB	*tcb;
	ER	ercd;
	UINT	tstat;

	LOG_REF_TST_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	tstat = tcb->tstat;
	if (TSTAT_RUNNABLE(tstat)) {
		if (tcb == runtsk) {
			pk_rtst->tskstat = TTS_RUN;
		} else pk_rtst->tskstat = TTS_RDY;
	} else {
		if (TSTAT_WAIT_SUSPENDED(tstat)) {
			pk_rtst->tskstat = TTS_WAS;
		} else if (TSTAT_WAITING(tstat)) {
			pk_rtst->tskstat = TTS_WAI;
		} else if (TSTAT_SUSPENDED(tstat)) {
			pk_rtst->tskstat = TTS_SUS;
		} else if (TSTAT_DORMANT(tstat)) {
			pk_rtst->tskstat = TTS_DMT;
		}
	}

	/* TODO: pk_rtst->tskwait = tcb-> */

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_TST_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_tsk */

