/*
 *  TOPPERS/FI4 Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Fullset uItron4 Kernel
 * 
 *  Copyright (C) 2003-2004 by Monami software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: /local/fi4-1.4/toppers/RELEASE_20061105_1/kernel/task_overrun.c 2750 2006-03-07T16:15:24.532712Z monaka  $
 */

/*
 *	I[o[nh@\
 */

#include "fi4_kernel.h"
#include "check.h"
#include "task.h"
#include "task_overrun.h"

/*
 *  I[o[nhID̍őlikernel_cfg.cj
 */
extern const ID	tmax_ovrid;

/*
 *  I[o[nhubÑGAikernel_cfg.cj
 */
extern const OVRINIB	ovrinib_table[];

/*
 *  I[o[nhǗubÑGAikernel_cfg.cj
 */
extern OVRCB	ovrcb_table[];

/*
 *  ܂Œ`I[o[nȟ^
 */
typedef void	(*OVRHDR)(ID tskid, VP_INT exinf);

/*
 *  I[onh̑݃`FbN
 *  I[onh`̂ƂAE_OBJ ԂB
 */
#define CHECK_OVERRUN_HADNLER_DEFINED() \
	if (overrun_handler_function == NULL) { \
		ercd = E_OBJ; \
		goto exit; \
	}

extern FP overrun_handler_function;

/*
 *  I[o[nh@\̏
 */
#ifdef __ovrini

void
overrun_initialize()
{
	/* TODO: @*/
}

#endif /* __ovrini */

/*
 *  I[onh̒`
 */
#ifdef __def_ovr

SYSCALL ER
def_ovr(const T_DOVR *pk_dovr)
{
	ER	ercd;
    
	LOG_DEF_OVR_ENTER();
	CHECK_TSKCTX_UNL();

	if (pk_dovr == NULL) {
		int i;

		t_lock_cpu();

		/*
		 *  SẴ^XNԂ
		 */
		for (i = 0; i < tmax_tskid; i++) {
			tcb_table[i].staovr = FALSE;
		}
		/*
		 *  I[onh^C}~B
		 */
		hw_overrun_timer_stop();

		overrun_handler_function = NULL;

		t_unlock_cpu();
	} else {
		
		CHECK_ATTRIBUTE(pk_dovr->ovratr, TA_HLNG | TA_ASM);
		
		/*
		 *  bN͕svƎvARpC
		 *  ǂȃR[h𐶐邩Ȃ̂ŔÔ߁B
		 */
		t_lock_cpu();
		overrun_handler_function = pk_dovr->ovrhdr;
		t_unlock_cpu();

	}

	ercd = E_OK;
 exit:
	LOG_DEF_OVR_LEAVE(ercd);
	return(ercd);
}

#endif /* __def_ovr */

/*
 *  I[onh̓Jn
 */
#ifdef __sta_ovr

SYSCALL ER
sta_ovr(ID tskid, OVRTIM ovrtim)
{
	TCB	*tcb;
	ER	ercd;

	LOG_STA_OVR_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_OVERRUN_HADNLER_DEFINED();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	tcb->staovr = TRUE;
	tcb->leftotm = ovrtim;

	if (tcb == runtsk) {
	    hw_overrun_timer_start();
	}

	t_unlock_cpu();

	ercd = E_OK;

    exit:
	LOG_STA_OVR_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_ovr */

/*
 *  I[onh̓~
 */
#ifdef __stp_ovr

SYSCALL ER
stp_ovr(ID tskid)
{
	TCB	*tcb;
	ER	ercd;

	LOG_STP_OVR_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_OVERRUN_HADNLER_DEFINED();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	tcb->staovr = FALSE;

	if (tcb == runtsk) {
	    hw_overrun_timer_stop();
	}

	t_unlock_cpu();

	ercd = E_OK;
    exit:
	LOG_STP_OVR_LEAVE(ercd);
	return(ercd);
}

#endif /* __stp_ovr */

/*
 *  I[onh̏ԎQ
 */
#ifdef __ref_ovr
SYSCALL ER
ref_ovr(ID tskid, T_ROVR *pk_rovr)
{
	TCB	*tcb;
	ER	ercd;
    
	LOG_REF_OVR_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_OVERRUN_HADNLER_DEFINED();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(tcb);

	if (tcb->staovr) {
		pk_rovr->ovrstat = TOVR_STA;
	} else {
		pk_rovr->ovrstat = TOVR_STP;
	}

	pk_rovr->leftotm = tcb->leftotm;

	t_unlock_cpu();

	ercd = E_OK;

    exit:
	LOG_REF_OVR_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_ovr */

/*
 *  I[onhďo
 *  I[onhp^C}݃nh
 *  ĂяoBďo^XNReLXg
 *  ł邱ƂɒӁB
 */
#ifdef __ovrcal

extern FP overrun_handler_function;

void
call_ovrhdr()
{
	typedef void (*OVRHDR)(ID,VP_INT);

	/*
	 *  蓾Ȃ͂AÔ߁B
	 *  assert}Nɂق悢ȂB
	 */
	if (overrun_handler_function == NULL) {
		return;
	}
	
	/*
	 *  ^XN̏vZbTԂ̐ݒ
	 */
	runtsk->staovr = FALSE;

	/*
	 *  I[onȟďo
	 */
	((OVRHDR)overrun_handler_function)(runtsk->tskid, runtsk->tinib->exinf);
}

#endif
